2014-12-03 11:36 temnoregg
	* qlib/SqlUtil.qm: Added SUM operator: cop_sum

2014-07-16 12:12  subik

	* lib/QC_HTTPClient.qpp, lib/QoreHttpClientObject.cpp: HTTPClient:
	  allow to enable additional http methods for clients

2014-07-12 12:55  david_nichols

	* qore.spec-fedora: minor fedora/rh spec file updates

2014-07-11 15:03  subik

	* configure.ac, qore.changes-opensuse, qore.spec-opensuse: suse
	  spec files

2014-07-11 13:07  david_nichols

	* qore.spec-fedora, qore.spec-multi: fixed doc and devel-doc file
	  specs to fix packaging bugs for documentation

2014-07-08 22:15  david_nichols

	* command-line.cpp: added --user-module-dir command-line argument

2014-07-08 22:10  david_nichols

	* command-line.cpp: fixed --module-dir output since showing the
	  path breaks module builds from source, added --module-path

2014-07-08 20:55  david_nichols

	* Makefile.am, qore.spec-multi: build updates for SLES, include
	  both spec files in distribution sources

2014-07-08 19:20  david_nichols

	* configure.ac, qore.spec-multi: build fixes for powerpc64 and for
	  configure without any --prefix argument

2014-07-08 17:53  david_nichols

	* Makefile.am, examples/test, qore.spec-fedora, qore.spec-multi,
	  runtest.sh, test: moved test/ subdir to examples/, fixed rpm
	  build with "make check", updated spec files

2014-07-08 17:28  david_nichols

	* Makefile.am, runtest.sh: fixed rpm builds with "make check"

2014-07-08 17:01  david_nichols

	* qore.spec-fedora, qore.spec-multi: added %check target to spec
	  files and aligned multi spec with fedora

2014-07-08 16:53  david_nichols

	* Makefile.am, reconf.sh, test/test.q: added a "make check" target

2014-06-27 12:16  david_nichols

	* Makefile.am, qore.spec-fedora: removed ChangeLog from
	  distribution sources

2014-06-27 06:58  david_nichols

	* include/qore/intern/QoreLogicalLessThanOrEqualsOperatorNode.h,
	  next_build.sh: license updates

2014-06-27 06:49  david_nichols

	* configure.ac, qore.spec-fedora: made a separate qore-stdlib rpm
	  package for noarch user modules delivered with qore

2014-06-26 11:39  david_nichols

	* command-line.cpp, command-line.h, include/qore/ScopeGuard.h,
	  include/qore/intern/QoreLogicalGreaterThanOperatorNode.h,
	  include/qore/macros-sparc.h, include/qore/macros.h,
	  lib/QoreLogicalGreaterThanOperatorNode.cpp,
	  lib/single-compilation-unit.cpp, main.cpp,
	  single-compilation-unit.cpp: added missing license header info

2014-06-24 14:13  david_nichols

	* qore.spec-fedora, qore.spec-multi: removed --disable-static from
	  the configure call since it's the default

2014-06-24 13:56  david_nichols

	* command-line.cpp, configure.ac: enable thread call stacks by
	  default
	  improved configure summary output
	  added all language module directies to output of --module-dir in
	  command-line.cpp

2014-06-24 09:18  david_nichols

	* qore.spec-fedora, qore.spec-multi: removed non-arch-specific ABI
	  provides

2014-06-24 08:44  david_nichols

	* qore.spec-fedora, qore.spec-multi: fixed abi provides and moved
	  runtime module lib to libqore package

2014-06-23 16:25  david_nichols

	* qore.spec-fedora, qore.spec-multi: uses hardcoded version for
	  obsoletes for libqore5

2014-06-23 15:46  david_nichols

	* Makefile.am, configure.ac,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/ModuleManager.h, include/qore/Qore.h,
	  lib/Makefile.am, lib/ModuleManager.cpp, lib/QoreLib.cpp,
	  qore.spec-fedora, qore.spec-multi: added new exported global
	  symbols for new module directories
	  updated ABI to 5.13.0, module ABI to 0.19
	  install user modules in ${datarootdir}/qore-modules/...
	  updated spec files accordingly

2014-06-23 14:29  david_nichols

	* configure.ac, lib/Makefile.am: fixed building qpp when
	  cross-compiling

2014-06-23 14:17  david_nichols

	* configure.ac, doxygen/lang/900_release_notes.dox.tmpl,
	  lib/ql_lib.qpp: updated relnotes for 0.8.11.1 release
	  removed explicit gmp linking due to fedora-review feedback

2014-06-23 14:02  david_nichols

	* configure.ac, qore.spec-fedora, qore.spec-multi: updated release
	  to 0.8.1.11 with spec file fixes for fedora submission

2014-06-23 10:13  david_nichols

	* include/qore/AbstractPrivateData.h,
	  include/qore/AbstractQoreNode.h,
	  include/qore/AbstractThreadResource.h, include/qore/AutoVLock.h,
	  include/qore/BinaryNode.h, include/qore/BuiltinFunctionList.h,
	  include/qore/CallReferenceNode.h, include/qore/DBI.h,
	  include/qore/Datasource.h, include/qore/DateTime.h,
	  include/qore/DateTimeNode.h, include/qore/ExceptionSink.h,
	  include/qore/ModuleManager.h, include/qore/ParseOptionMap.h,
	  include/qore/Qore.h, include/qore/QoreBigIntNode.h,
	  include/qore/QoreBoolNode.h, include/qore/QoreClass.h,
	  include/qore/QoreCondition.h, include/qore/QoreCounter.h,
	  include/qore/QoreEncoding.h, include/qore/QoreEvents.h,
	  include/qore/QoreFile.h, include/qore/QoreFloatNode.h,
	  include/qore/QoreFtpClient.h, include/qore/QoreHTTPClient.h,
	  include/qore/QoreHashNode.h, include/qore/QoreHttpClientObject.h,
	  include/qore/QoreIteratorBase.h, include/qore/QoreLib.h,
	  include/qore/QoreListNode.h, include/qore/QoreNamespace.h,
	  include/qore/QoreNet.h,
	  include/qore/QoreNodeEvalOptionalRefHolder.h,
	  include/qore/QoreNothingNode.h, include/qore/QoreNullNode.h,
	  include/qore/QoreNumberNode.h, include/qore/QoreObject.h,
	  include/qore/QoreProgram.h, include/qore/QoreQueue.h,
	  include/qore/QoreQueueHelper.h, include/qore/QoreRWLock.h,
	  include/qore/QoreReferenceCounter.h, include/qore/QoreSSLBase.h,
	  include/qore/QoreSSLCertificate.h,
	  include/qore/QoreSSLPrivateKey.h, include/qore/QoreSocket.h,
	  include/qore/QoreSocketObject.h, include/qore/QoreString.h,
	  include/qore/QoreStringNode.h,
	  include/qore/QoreThreadLocalStorage.h,
	  include/qore/QoreThreadLock.h, include/qore/QoreType.h,
	  include/qore/QoreTypeSafeReferenceHelper.h,
	  include/qore/QoreURL.h, include/qore/ReferenceArgumentHelper.h,
	  include/qore/ReferenceHolder.h, include/qore/ReferenceNode.h,
	  include/qore/Restrictions.h, include/qore/SQLStatement.h,
	  include/qore/SystemEnvironment.h, include/qore/common.h,
	  include/qore/intern/AbstractIteratorHelper.h,
	  include/qore/intern/AbstractSmartLock.h,
	  include/qore/intern/AbstractStatement.h,
	  include/qore/intern/BackquoteNode.h,
	  include/qore/intern/BarewordNode.h,
	  include/qore/intern/BreakStatement.h,
	  include/qore/intern/BuiltinFunction.h,
	  include/qore/intern/CallReferenceCallNode.h,
	  include/qore/intern/CallReferenceNode.h,
	  include/qore/intern/CaseNodeRegex.h,
	  include/qore/intern/CaseNodeWithOperator.h,
	  include/qore/intern/ClassRefNode.h,
	  include/qore/intern/ComplexContextrefNode.h,
	  include/qore/intern/ConstantList.h,
	  include/qore/intern/Context.h,
	  include/qore/intern/ContextRowNode.h,
	  include/qore/intern/ContextStatement.h,
	  include/qore/intern/ContextrefNode.h,
	  include/qore/intern/ContinueStatement.h,
	  include/qore/intern/DatasourcePool.h,
	  include/qore/intern/DatasourceStatementHelper.h,
	  include/qore/intern/DoWhileStatement.h,
	  include/qore/intern/ExecArgList.h,
	  include/qore/intern/ExpressionStatement.h,
	  include/qore/intern/FindNode.h,
	  include/qore/intern/ForEachStatement.h,
	  include/qore/intern/ForStatement.h,
	  include/qore/intern/Function.h,
	  include/qore/intern/FunctionCallNode.h,
	  include/qore/intern/FunctionList.h,
	  include/qore/intern/GlobalVariableList.h,
	  include/qore/intern/IfStatement.h,
	  include/qore/intern/LocalVar.h,
	  include/qore/intern/ManagedDatasource.h,
	  include/qore/intern/ModuleInfo.h,
	  include/qore/intern/NamedScope.h,
	  include/qore/intern/ObjectMethodReferenceNode.h,
	  include/qore/intern/OnBlockExitStatement.h,
	  include/qore/intern/Operator.h, include/qore/intern/ParseNode.h,
	  include/qore/intern/ParseReferenceNode.h,
	  include/qore/intern/ParserSupport.h,
	  include/qore/intern/QC_AbstractSmartLock.h,
	  include/qore/intern/QC_AutoGate.h,
	  include/qore/intern/QC_AutoLock.h,
	  include/qore/intern/QC_AutoReadLock.h,
	  include/qore/intern/QC_AutoWriteLock.h,
	  include/qore/intern/QC_Condition.h,
	  include/qore/intern/QC_Counter.h,
	  include/qore/intern/QC_Datasource.h,
	  include/qore/intern/QC_DatasourcePool.h,
	  include/qore/intern/QC_Dir.h, include/qore/intern/QC_File.h,
	  include/qore/intern/QC_FtpClient.h,
	  include/qore/intern/QC_Gate.h, include/qore/intern/QC_GetOpt.h,
	  include/qore/intern/QC_HTTPClient.h,
	  include/qore/intern/QC_Mutex.h, include/qore/intern/QC_Program.h,
	  include/qore/intern/QC_Queue.h, include/qore/intern/QC_RWLock.h,
	  include/qore/intern/QC_SQLStatement.h,
	  include/qore/intern/QC_SSLCertificate.h,
	  include/qore/intern/QC_SSLPrivateKey.h,
	  include/qore/intern/QC_Sequence.h,
	  include/qore/intern/QC_Socket.h,
	  include/qore/intern/QC_TermIOS.h,
	  include/qore/intern/QC_TimeZone.h,
	  include/qore/intern/QException.h,
	  include/qore/intern/QoreAndEqualsOperatorNode.h,
	  include/qore/intern/QoreAssignmentOperatorNode.h,
	  include/qore/intern/QoreBinaryLValueOperatorNode.h,
	  include/qore/intern/QoreCastOperatorNode.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreClassList.h,
	  include/qore/intern/QoreClosureNode.h,
	  include/qore/intern/QoreClosureParseNode.h,
	  include/qore/intern/QoreDeleteOperatorNode.h,
	  include/qore/intern/QoreDir.h,
	  include/qore/intern/QoreDivideEqualsOperatorNode.h,
	  include/qore/intern/QoreDotEvalOperatorNode.h,
	  include/qore/intern/QoreException.h,
	  include/qore/intern/QoreExtractOperatorNode.h,
	  include/qore/intern/QoreGetOpt.h,
	  include/qore/intern/QoreHashIterator.h,
	  include/qore/intern/QoreHashListIterator.h,
	  include/qore/intern/QoreHashNodeIntern.h,
	  include/qore/intern/QoreHttpClientObjectIntern.h,
	  include/qore/intern/QoreImplicitArgumentNode.h,
	  include/qore/intern/QoreImplicitElementNode.h,
	  include/qore/intern/QoreIntAssignmentOperatorNode.h,
	  include/qore/intern/QoreIntMinusEqualsOperatorNode.h,
	  include/qore/intern/QoreIntPlusEqualsOperatorNode.h,
	  include/qore/intern/QoreIntPostDecrementOperatorNode.h,
	  include/qore/intern/QoreIntPostIncrementOperatorNode.h,
	  include/qore/intern/QoreIntPreDecrementOperatorNode.h,
	  include/qore/intern/QoreIntPreIncrementOperatorNode.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreListHashIterator.h,
	  include/qore/intern/QoreListIterator.h,
	  include/qore/intern/QoreLogicalEqualsOperatorNode.h,
	  include/qore/intern/QoreLogicalGreaterThanOrEqualsOperatorNode.h,
	  include/qore/intern/QoreLogicalLessThanOperatorNode.h,
	  include/qore/intern/QoreLogicalNotEqualsOperatorNode.h,
	  include/qore/intern/QoreMinusEqualsOperatorNode.h,
	  include/qore/intern/QoreModuloEqualsOperatorNode.h,
	  include/qore/intern/QoreMultiplyEqualsOperatorNode.h,
	  include/qore/intern/QoreNamespaceIntern.h,
	  include/qore/intern/QoreNamespaceList.h,
	  include/qore/intern/QoreObjectIntern.h,
	  include/qore/intern/QoreObjectIterator.h,
	  include/qore/intern/QoreOperatorNode.h,
	  include/qore/intern/QoreOrEqualsOperatorNode.h,
	  include/qore/intern/QorePlusEqualsOperatorNode.h,
	  include/qore/intern/QorePostDecrementOperatorNode.h,
	  include/qore/intern/QorePostIncrementOperatorNode.h,
	  include/qore/intern/QorePreDecrementOperatorNode.h,
	  include/qore/intern/QorePreIncrementOperatorNode.h,
	  include/qore/intern/QorePseudoMethods.h,
	  include/qore/intern/QoreQuestionMarkOperatorNode.h,
	  include/qore/intern/QoreQueueIntern.h,
	  include/qore/intern/QoreRegexBase.h,
	  include/qore/intern/QoreRegexNode.h,
	  include/qore/intern/QoreRemoveOperatorNode.h,
	  include/qore/intern/QoreSQLStatement.h,
	  include/qore/intern/QoreSSLIntern.h,
	  include/qore/intern/QoreShiftLeftEqualsOperatorNode.h,
	  include/qore/intern/QoreShiftRightEqualsOperatorNode.h,
	  include/qore/intern/QoreSignal.h,
	  include/qore/intern/QoreSpliceOperatorNode.h,
	  include/qore/intern/QoreThreadList.h,
	  include/qore/intern/QoreTimeZoneManager.h,
	  include/qore/intern/QoreTreeNode.h,
	  include/qore/intern/QoreTypeInfo.h,
	  include/qore/intern/QoreUnaryMinusOperatorNode.h,
	  include/qore/intern/QoreValue.h,
	  include/qore/intern/QoreXorEqualsOperatorNode.h,
	  include/qore/intern/RWLock.h,
	  include/qore/intern/RangeIterator.h,
	  include/qore/intern/ReferenceHelper.h,
	  include/qore/intern/RegexSubstNode.h,
	  include/qore/intern/RegexTransNode.h,
	  include/qore/intern/RethrowStatement.h,
	  include/qore/intern/ReturnStatement.h,
	  include/qore/intern/SSLSocketHelper.h,
	  include/qore/intern/ScopedObjectCallNode.h,
	  include/qore/intern/ScopedRefNode.h,
	  include/qore/intern/SelfVarrefNode.h,
	  include/qore/intern/Sequence.h,
	  include/qore/intern/SingleValueIterator.h,
	  include/qore/intern/SmartMutex.h,
	  include/qore/intern/StatementBlock.h,
	  include/qore/intern/StaticClassVarRefNode.h,
	  include/qore/intern/SummarizeStatement.h,
	  include/qore/intern/SwitchStatement.h,
	  include/qore/intern/ThreadExitStatement.h,
	  include/qore/intern/ThreadPool.h,
	  include/qore/intern/ThreadResourceList.h,
	  include/qore/intern/ThrowStatement.h,
	  include/qore/intern/TryStatement.h, include/qore/intern/VLock.h,
	  include/qore/intern/VRMutex.h, include/qore/intern/VarRefNode.h,
	  include/qore/intern/Variable.h,
	  include/qore/intern/WhileStatement.h,
	  include/qore/intern/config.h, include/qore/intern/glob.h,
	  include/qore/intern/inline_printf.h,
	  include/qore/intern/ql_compression.h,
	  include/qore/intern/ql_crypto.h, include/qore/intern/ql_debug.h,
	  include/qore/intern/ql_env.h, include/qore/intern/ql_file.h,
	  include/qore/intern/ql_lib.h, include/qore/intern/ql_list.h,
	  include/qore/intern/ql_math.h, include/qore/intern/ql_misc.h,
	  include/qore/intern/ql_object.h, include/qore/intern/ql_pwd.h,
	  include/qore/intern/ql_string.h, include/qore/intern/ql_thread.h,
	  include/qore/intern/ql_time.h, include/qore/intern/ql_type.h,
	  include/qore/intern/qore_date_private.h,
	  include/qore/intern/qore_dbi_private.h,
	  include/qore/intern/qore_ds_private.h,
	  include/qore/intern/qore_list_private.h,
	  include/qore/intern/qore_number_private.h,
	  include/qore/intern/qore_program_private.h,
	  include/qore/intern/qore_socket_private.h,
	  include/qore/intern/qore_string_private.h,
	  include/qore/intern/qore_thread_intern.h,
	  include/qore/intern/sql_statement_private.h,
	  include/qore/intern/ssl_constants.h,
	  include/qore/intern/win32-config.h, include/qore/macros-i386.h,
	  include/qore/macros-ia64.h, include/qore/macros-none.h,
	  include/qore/macros-powerpc.h, include/qore/macros-x86_64.h,
	  include/qore/node_types.h, include/qore/params.h,
	  include/qore/qlist, include/qore/qore_bitopts.h,
	  include/qore/qore_thread.h, include/qore/safe_dslist,
	  include/qore/support.h, lib/AbstractQoreNode.cpp,
	  lib/AbstractSmartLock.cpp, lib/AbstractStatement.cpp,
	  lib/BackquoteNode.cpp, lib/BarewordNode.cpp, lib/BinaryNode.cpp,
	  lib/BuiltinFunctionList.cpp, lib/CallReferenceNode.cpp,
	  lib/CallStack.cpp, lib/ClassRefNode.cpp,
	  lib/ComplexContextrefNode.cpp, lib/ConstantList.cpp,
	  lib/Context.cpp, lib/ContextRowNode.cpp,
	  lib/ContextStatement.cpp, lib/ContextrefNode.cpp, lib/DBI.cpp,
	  lib/Datasource.cpp, lib/DatasourcePool.cpp, lib/DateTime.cpp,
	  lib/DateTimeNode.cpp, lib/DoWhileStatement.cpp,
	  lib/ExceptionSink.cpp, lib/ExecArgList.cpp,
	  lib/ExpressionStatement.cpp, lib/FindNode.cpp,
	  lib/ForEachStatement.cpp, lib/ForStatement.cpp, lib/Function.cpp,
	  lib/FunctionCallNode.cpp, lib/FunctionList.cpp,
	  lib/GlobalVariableList.cpp, lib/IfStatement.cpp,
	  lib/ManagedDatasource.cpp, lib/ModuleManager.cpp,
	  lib/NamedScope.cpp, lib/OnBlockExitStatement.cpp,
	  lib/Operator.cpp, lib/ParseOptionMap.cpp, lib/Pseudo_QC_All.qpp,
	  lib/Pseudo_QC_Binary.qpp, lib/Pseudo_QC_Bool.qpp,
	  lib/Pseudo_QC_Callref.qpp, lib/Pseudo_QC_Closure.qpp,
	  lib/Pseudo_QC_Date.qpp, lib/Pseudo_QC_Float.qpp,
	  lib/Pseudo_QC_Hash.qpp, lib/Pseudo_QC_Int.qpp,
	  lib/Pseudo_QC_List.qpp, lib/Pseudo_QC_Nothing.qpp,
	  lib/Pseudo_QC_Number.qpp, lib/Pseudo_QC_Object.qpp,
	  lib/Pseudo_QC_String.qpp,
	  lib/QC_AbstractBidirectionalIterator.qpp,
	  lib/QC_AbstractDatasource.qpp, lib/QC_AbstractIterator.qpp,
	  lib/QC_AbstractQuantifiedBidirectionalIterator.qpp,
	  lib/QC_AbstractQuantifiedIterator.qpp,
	  lib/QC_AbstractSmartLock.qpp, lib/QC_AutoGate.qpp,
	  lib/QC_AutoLock.qpp, lib/QC_AutoReadLock.qpp,
	  lib/QC_AutoWriteLock.qpp, lib/QC_Condition.qpp,
	  lib/QC_Counter.qpp, lib/QC_Datasource.qpp,
	  lib/QC_DatasourcePool.qpp, lib/QC_Dir.qpp, lib/QC_File.qpp,
	  lib/QC_FileLineIterator.qpp, lib/QC_FtpClient.qpp,
	  lib/QC_Gate.qpp, lib/QC_GetOpt.qpp, lib/QC_HTTPClient.qpp,
	  lib/QC_HashIterator.qpp, lib/QC_HashKeyIterator.qpp,
	  lib/QC_HashKeyReverseIterator.qpp, lib/QC_HashListIterator.qpp,
	  lib/QC_HashListReverseIterator.qpp, lib/QC_HashPairIterator.qpp,
	  lib/QC_HashPairReverseIterator.qpp,
	  lib/QC_HashReverseIterator.qpp, lib/QC_ListHashIterator.qpp,
	  lib/QC_ListHashReverseIterator.qpp, lib/QC_ListIterator.qpp,
	  lib/QC_ListReverseIterator.qpp, lib/QC_Mutex.qpp,
	  lib/QC_ObjectIterator.qpp, lib/QC_ObjectKeyIterator.qpp,
	  lib/QC_ObjectKeyReverseIterator.qpp,
	  lib/QC_ObjectPairIterator.qpp,
	  lib/QC_ObjectPairReverseIterator.qpp,
	  lib/QC_ObjectReverseIterator.qpp, lib/QC_Program.qpp,
	  lib/QC_Queue.qpp, lib/QC_RWLock.qpp, lib/QC_RangeIterator.qpp,
	  lib/QC_ReadOnlyFile.qpp, lib/QC_SQLStatement.qpp,
	  lib/QC_SSLCertificate.qpp, lib/QC_SSLPrivateKey.qpp,
	  lib/QC_Sequence.qpp, lib/QC_SingleValueIterator.qpp,
	  lib/QC_Socket.qpp, lib/QC_TermIOS.qpp, lib/QC_ThreadPool.qpp,
	  lib/QC_TimeZone.qpp, lib/QException.cpp,
	  lib/QoreAndEqualsOperatorNode.cpp,
	  lib/QoreAssignmentOperatorNode.cpp, lib/QoreBigIntNode.cpp,
	  lib/QoreBoolNode.cpp, lib/QoreCastOperatorNode.cpp,
	  lib/QoreClass.cpp, lib/QoreClassList.cpp,
	  lib/QoreClosureNode.cpp, lib/QoreClosureParseNode.cpp,
	  lib/QoreCondition.cpp, lib/QoreCounter.cpp,
	  lib/QoreDeleteOperatorNode.cpp, lib/QoreDir.cpp,
	  lib/QoreDivideEqualsOperatorNode.cpp,
	  lib/QoreDotEvalOperatorNode.cpp, lib/QoreException.cpp,
	  lib/QoreExtractOperatorNode.cpp, lib/QoreFile.cpp,
	  lib/QoreFloatNode.cpp, lib/QoreFtpClient.cpp, lib/QoreGetOpt.cpp,
	  lib/QoreHTTPClient.cpp, lib/QoreHashNode.cpp,
	  lib/QoreHttpClientObject.cpp, lib/QoreImplicitArgumentNode.cpp,
	  lib/QoreImplicitElementNode.cpp,
	  lib/QoreIntAssignmentOperatorNode.cpp,
	  lib/QoreIntMinusEqualsOperatorNode.cpp,
	  lib/QoreIntPlusEqualsOperatorNode.cpp,
	  lib/QoreIntPostDecrementOperatorNode.cpp,
	  lib/QoreIntPostIncrementOperatorNode.cpp,
	  lib/QoreIntPreDecrementOperatorNode.cpp,
	  lib/QoreIntPreIncrementOperatorNode.cpp, lib/QoreLib.cpp,
	  lib/QoreListNode.cpp, lib/QoreLogicalEqualsOperatorNode.cpp,
	  lib/QoreLogicalGreaterThanOperatorNode.cpp,
	  lib/QoreLogicalLessThanOperatorNode.cpp,
	  lib/QoreMinusEqualsOperatorNode.cpp,
	  lib/QoreModuloEqualsOperatorNode.cpp,
	  lib/QoreMultiplyEqualsOperatorNode.cpp, lib/QoreNamespace.cpp,
	  lib/QoreNet.cpp, lib/QoreNothingNode.cpp, lib/QoreNullNode.cpp,
	  lib/QoreNumberNode.cpp, lib/QoreObject.cpp,
	  lib/QoreOrEqualsOperatorNode.cpp,
	  lib/QorePlusEqualsOperatorNode.cpp,
	  lib/QorePostDecrementOperatorNode.cpp,
	  lib/QorePostIncrementOperatorNode.cpp,
	  lib/QorePreDecrementOperatorNode.cpp,
	  lib/QorePreIncrementOperatorNode.cpp, lib/QoreProgram.cpp,
	  lib/QorePseudoMethods.cpp, lib/QoreQueue.cpp,
	  lib/QoreQueueHelper.cpp, lib/QoreReferenceCounter.cpp,
	  lib/QoreRegexBase.cpp, lib/QoreRegexNode.cpp,
	  lib/QoreRemoveOperatorNode.cpp, lib/QoreSQLStatement.cpp,
	  lib/QoreSSLBase.cpp, lib/QoreSSLCertificate.cpp,
	  lib/QoreSSLPrivateKey.cpp,
	  lib/QoreShiftLeftEqualsOperatorNode.cpp,
	  lib/QoreShiftRightEqualsOperatorNode.cpp, lib/QoreSignal.cpp,
	  lib/QoreSocket.cpp, lib/QoreSocketObject.cpp,
	  lib/QoreSpliceOperatorNode.cpp, lib/QoreString.cpp,
	  lib/QoreStringNode.cpp, lib/QoreTimeZoneManager.cpp,
	  lib/QoreTreeNode.cpp, lib/QoreType.cpp, lib/QoreTypeInfo.cpp,
	  lib/QoreURL.cpp, lib/QoreUnaryMinusOperatorNode.cpp,
	  lib/QoreXorEqualsOperatorNode.cpp, lib/RWLock.cpp,
	  lib/ReferenceArgumentHelper.cpp, lib/ReferenceHelper.cpp,
	  lib/ReferenceNode.cpp, lib/RegexSubstNode.cpp,
	  lib/RegexTransNode.cpp, lib/ReturnStatement.cpp,
	  lib/SQLStatement.cpp, lib/ScopedRefNode.cpp,
	  lib/SelfVarrefNode.cpp, lib/Sequence.cpp, lib/SmartMutex.cpp,
	  lib/StatementBlock.cpp, lib/StaticClassVarRefNode.cpp,
	  lib/SummarizeStatement.cpp, lib/SwitchStatement.cpp,
	  lib/SystemEnvironment.cpp, lib/ThreadResourceList.cpp,
	  lib/ThrowStatement.cpp, lib/TryStatement.cpp, lib/VLock.cpp,
	  lib/VRMutex.cpp, lib/VarRefNode.cpp, lib/Variable.cpp,
	  lib/WhileStatement.cpp, lib/charset.cpp, lib/glob.cpp,
	  lib/inline_printf.cpp, lib/minitest.cpp, lib/parser.ypp,
	  lib/qc_errno.qpp, lib/qc_option.qpp, lib/qc_qore.qpp,
	  lib/ql_compression.qpp, lib/ql_context.qpp, lib/ql_crypto.qpp,
	  lib/ql_dbi.qpp, lib/ql_debug.cpp, lib/ql_env.qpp,
	  lib/ql_file.qpp, lib/ql_lib.qpp, lib/ql_list.qpp,
	  lib/ql_math.qpp, lib/ql_misc.qpp, lib/ql_object.qpp,
	  lib/ql_pwd.qpp, lib/ql_string.qpp, lib/ql_thread.qpp,
	  lib/ql_time.qpp, lib/ql_type.qpp, lib/qore-main.cpp,
	  lib/qore_date_private.cpp, lib/qpp.cpp, lib/scanner.lpp,
	  lib/support.cpp, lib/thread.cpp, lib/unicode-charmaps.cpp,
	  main.cpp: per Fedora submission/review:
	  - updated all LGPL license statements in source files to reflect
	  the most permissive license, MIT and refer to the possibility of
	  using the LGPL 2+ or GPL 2+
	  - updated copyright statements

2014-06-23 08:26  david_nichols

	* qore.spec-fedora, qore.spec-multi: further spec updates from
	  fedora submission review process

2014-06-22 14:13  david_nichols

	* qore.1, qore.spec-fedora, qore.spec-multi: more spec file and
	  other updates for fedora package acceptance

2014-06-22 13:36  david_nichols

	* lib/getopt_long.cpp, lib/getopt_long.h, lib/qpp.cpp: replaced
	  getopt_long with BSD version

2014-06-21 15:58  nros

	* include/qore/intern/qore_program_private.h: Fix memory in
	  makeParseException that occurs when only_first_except is set
	  and exceptions has been raised before (exceptions_raised > 0).

2014-06-21 13:08  david_nichols

	* configure.ac, doxygen/lang/900_release_notes.dox.tmpl,
	  lib/ql_lib.qpp, qore.spec, qore.spec-multi: make spec file for
	  dist dependent on host OS - on fedora & rhel use the fedora spec
	  file, otherwise use the generic one
	  added docs for new functions (getgroups(), setgroups())

2014-06-21 07:35  david_nichols

	* configure.ac, qore.spec, qore.spec-fedora: updated spec file with
	  feedback from fedora submission
	  added new spec file specifically for fedora, the old generic spec
	  file now generates equal binaries for fedora and rhel
	  added checks to configure for more 64-bit architectures, removed
	  configuration in spec file

2014-06-20 17:56  david_nichols

	* configure.ac, doxygen/lang/245_parse_directives.dox.tmpl,
	  lib/getopt_long.h, lib/ql_lib.qpp, qore.spec: last-minute rpm
	  fixes:
	  - added getgroups() and setgroups() functions to ql_lib.qpp
	  - disable execute bit on examples in the doc package for all
	  platforms
	  - corrected FSF address in getopt_long.h

2014-06-20 14:16  subik

	* qore.spec: spec file for opensuse

2014-06-20 13:37  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: fixed typo

2014-06-20 13:20  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: minor relnotes updates

2014-06-20 13:17  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: updated relnotes for
	  0.8.11 release

2014-06-20 13:14  david_nichols

	* qlib/CsvUtil.qm, qlib/HttpServer.qm, qlib/MailMessage.qm,
	  qlib/Mapper.qm, qlib/Mime.qm, qlib/MysqlSqlUtil.qm,
	  qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/Pop3Client.qm,
	  qlib/Qorize.qm, qlib/RestClient.qm, qlib/RestHandler.qm,
	  qlib/Schema.qm, qlib/SmtpClient.qm, qlib/SqlUtil.qm,
	  qlib/TableMapper.qm, qlib/TelnetClient.qm, qlib/Util.qm,
	  qlib/WebSocketClient.qm, qlib/WebSocketHandler.qm,
	  qlib/WebSocketUtil.qm, qlib/WebUtil.qm: updated to require 0.8.11
	  for new release

2014-06-20 13:11  david_nichols

	* ChangeLog, doxygen/lang/900_release_notes.dox.tmpl, qore.spec:
	  updated ChangeLog and relnotes for minor 0.8.11 release

2014-06-16 12:11  david_nichols

	* qore.spec: minor spec file fixes

2014-06-16 06:44  david_nichols

	* qlib/Util.qm: read from /dev/urandom instead of /dev/random since
	  /dev/random may block for long periods to fill the entropy pool

2014-06-15 16:28  david_nichols

	* configure.ac: configure fixes for ubuntu

2014-06-14 16:40  david_nichols

	* lib/QoreSignal.cpp: updated copyright stmt

2014-06-14 16:39  david_nichols

	* doxygen/lang/230_signal_handling.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, lib/QoreSignal.cpp,
	  lib/ql_lib.qpp: do not start the signal handling thread in the
	  child process, since pthread_create() is not async-signal safe
	  updated fork() and signal-handling docs

2014-06-09 14:43  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreSocketObject.h,
	  include/qore/intern/qore_socket_private.h, lib/QC_HTTPClient.qpp,
	  lib/QoreHttpClientObject.cpp, lib/QoreSocketObject.cpp,
	  qlib/HttpServer.qm, qlib/RestHandler.qm: - qore:
	  HTTPClient::sendWithSendCallback() and
	  HTTPClient::sendWithSendCallback() updated such that if a
	  response is received while the chunked send operation is still in
	  progress, an error is assumed, the send operation is aborted, and
	  the response header is read immediately
	  - HttpServer.qm: if an error occurs receiving a message with
	  chunked transfer encoding, send the response immediately before
	  reading the rest of the chunked transfer
	  - RestHandler: added module release notes section to module docs

2014-06-04 09:41  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/Util.qm: fixed
	  parse_to_qore_value() with hashes with a comma in the first key
	  name

2014-06-03 19:04  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/qore_dbi_private.h: fixed a bug in the DBI
	  layer where calling SQLStatement::describe() would crash when
	  called with an older module that did not implement this method

2014-06-03 12:00  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_Socket.qpp,
	  lib/QoreNet.cpp: added AFMap and AFStrMap constants to map
	  address constant integer codes to and from descriptive string
	  codes

2014-06-03 09:56  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: removed non-functional
	  link in relnotes

2014-06-03 09:50  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/HttpServer.qm: when
	  binding a wildcard address with AF_UNSPEC on Windows with
	  HttpServer::addListeners() and both IPv6 and IPv4 addresses are
	  returned, bind both addresses since Windows doesn't direct the
	  IPv4 requests to the wildcard-bound IPv6 listener

2014-06-02 13:34  david_nichols

	* include/qore/intern/qore_socket_private.h, lib/QoreSocket.cpp:
	  support ECONNRESET actions on Windows

2014-06-02 13:27  david_nichols

	* configure.ac, doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QoreFile.cpp, lib/QoreSocket.cpp,
	  lib/QoreTimeZoneManager.cpp: more windows fixes:
	  + filed file reading by always opening in binary mode
	  + added support for the WSAECONNABORTED socket error

2014-06-01 16:38  david_nichols

	* qlib/WebUtil.qm: added additional MIME text types

2014-06-01 13:28  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/WebUtil.qm: updated
	  WebUtil.qm: added logic to the default file serving code to
	  determine if the file is a binary or text file from the MIME type

2014-05-31 16:20  david_nichols

	* lib/QoreLib.cpp: fixed usleep() on Windows

2014-05-31 15:25  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/Mime.qm,
	  qlib/Util.qm: Mime and Util module fixes for windows

2014-05-31 05:50  david_nichols

	* configure.ac, lib/Makefile.am, lib/QoreTimeZoneManager.cpp,
	  qore.spec: updated to 0.8.11
	  updated library version info
	  fixed Windows TimeZone info copy constructor to use the standard
	  name rather than the display name so that it can be found in the
	  registry

2014-05-30 13:52  david_nichols

	* ChangeLog, doxygen/lang/900_release_notes.dox.tmpl: updated
	  relnotes & ChangeLog for release

2014-05-30 09:35  subik

	* cmake/QoreConfig.cmake.in: cmake modules: use
	  CMAKE_INSTALL_PREFIX based on qore location if there is no
	  CMAKE_INSTALL_PREFIX set by user

2014-05-29 16:08  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/CsvUtil.qm: set the
	  "optimal-quotes" option by default when outputting csv data

2014-05-29 15:00  david_nichols

	* lib/QoreLib.cpp: more efficient implementation of local
	  strcasestr()

2014-05-29 14:57  david_nichols

	* include/qore/intern/QoreLibIntern.h: added a prototype in an
	  internal header for strcasestr() when the local implementation is
	  needed

2014-05-29 14:53  david_nichols

	* configure.ac, include/qore/intern/qore_socket_private.h,
	  lib/QoreLib.cpp: added strcasestr tests and fixed typo in last
	  commit

2014-05-29 14:52  david_nichols

	* lib/QoreLib.cpp: added strcasestr for platforms without it (ex:
	  windows)

2014-05-29 14:36  david_nichols

	* doxygen/lang/120_modules.dox.tmpl: doc updates

2014-05-29 13:59  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/qpp.cpp,
	  qlib/CsvUtil.qm: CsvUtil updates:
	  - added the "write-headers" option to AbstractCsvWriter and
	  subclasses to enable headers to be suppressed
	  - added the "optimal-quotes" option to AbstractCsvWriter and
	  subclasses to enable more efficient csv output
	  qpp update:
	  - allow preprocessor defines to be used as string constant values

2014-05-28 14:19  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/ThreadPool.h, lib/QC_ThreadPool.qpp: fixed
	  several race conditions and potential deadlocks in ThreadPool
	  destruction with active threads in the pool

2014-05-28 13:43  david_nichols

	* include/qore/intern/ThreadPool.h, lib/QC_ThreadPool.qpp: fixed a
	  race condition in the ThreadPool class where a worker thread is
	  canceled before it starts while a task has already been queued

2014-05-28 13:18  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_ThreadPool.qpp:
	  fixed a bug handling thread cancellation with the ThreadPool
	  class

2014-05-28 12:21  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/qore_socket_private.h: fixed a bug where
	  case-sensitive comparisons were being made with critical header
	  values when parsing HTTP responses

2014-05-28 11:38  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/HttpServer.qm,
	  qlib/RestHandler.qm, qlib/SqlUtil.qm: added additional thread
	  context handling to HttpServer
	  fixed a bug where select and row iterator operations could fail
	  with certain select hash arguments without a \c "columns" entry
	  but where column names were otherwise required
	  minor RestHandler changes

2014-05-27 18:38  david_nichols

	* lib/qore-main.cpp: removed debugging lines

2014-05-26 17:55  david_nichols

	* qlib/SqlUtil.qm: fixed typo

2014-05-26 17:08  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QC_AbstractDatasource.qpp, qlib/SqlUtil.qm: added the
	  AbstractDatasource::currentThreadInTransaction() method
	  added support for the "forupdate" select option

2014-05-26 16:13  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreHttpClientObject.h, include/qore/QoreProgram.h,
	  include/qore/intern/qore_program_private.h,
	  lib/QC_HTTPClient.qpp, lib/QoreHttpClientObject.cpp,
	  lib/QoreProgram.cpp, lib/ql_thread.qpp, qlib/HttpServer.qm: fixed
	  crashing bugs in get_thread_data() and friends in certain use
	  cases
	  added HTTPClient::setPersistent() to disable implicit connections
	  for a single HTTP session
	  added support for persistent connections to a given handler to
	  the HTTP server

2014-05-26 11:34  david_nichols

	* qlib/HttpServer.qm: started work on supporting persistent
	  connections - where a connection is dedicated to a certain
	  handler

2014-05-26 08:06  david_nichols

	* include/qore/intern/qore_program_private.h, lib/QoreProgram.cpp,
	  qlib/CsvUtil.qm, qlib/MailMessage.qm, qlib/Mapper.qm,
	  qlib/Mime.qm, qlib/MysqlSqlUtil.qm, qlib/PgsqlSqlUtil.qm,
	  qlib/Pop3Client.qm, qlib/Qorize.qm, qlib/RestHandler.qm,
	  qlib/SmtpClient.qm, qlib/TableMapper.qm, qlib/TelnetClient.qm,
	  qlib/Util.qm, qlib/WebSocketClient.qm, qlib/WebSocketHandler.qm,
	  qlib/WebSocketUtil.qm, qlib/WebUtil.qm: add
	  QoreHasUserModuleLicense = True define when parsing user modules
	  update user modules to require at least qore 0.8.10 since the
	  license user module key is not accepted by previous versions

2014-05-22 14:44  david_nichols

	* Makefile.am: fixed builds from dist source

2014-05-19 15:45  david_nichols

	* include/qore/intern/qore_socket_private.h, lib/ModuleManager.cpp:
	  fixed error in last commit regarding chunked trailer processing;
	  chunked trailers are now sent and parsed correctly

2014-05-19 11:08  david_nichols

	* lib/ModuleManager.cpp: removed debugging output

2014-05-19 10:59  david_nichols

	* include/qore/QoreLib.h: updated module sources to reflect MIT
	  licenses; added license string to binary module's exported
	  symbols for use with Qore >= 0.8.10

2014-05-19 10:24  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/ModuleInfo.h, lib/ModuleManager.cpp,
	  lib/ql_misc.qpp, qlib/CsvUtil.qm, qlib/HttpServer.qm,
	  qlib/MailMessage.qm, qlib/Mapper.qm, qlib/Mime.qm,
	  qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/Pop3Client.qm, qlib/Qorize.qm,
	  qlib/RestClient.qm, qlib/RestHandler.qm, qlib/Schema.qm,
	  qlib/SmtpClient.qm, qlib/SqlUtil.qm, qlib/TableMapper.qm,
	  qlib/TelnetClient.qm, qlib/Util.qm, qlib/WebSocketClient.qm,
	  qlib/WebSocketHandler.qm, qlib/WebSocketUtil.qm, qlib/WebUtil.qm:
	  added support for reporting module license strings for all
	  modules
	  added support for the new "qore_module_license_str" symbol for
	  binary modules
	  added a 'license = "MIT";' line to all user modules shipped with
	  Qore
	  updated docs

2014-05-19 08:01  subik

	* doxygen/qdx: qdx: fixed tab vs. spaces mixing

2014-05-17 15:55  david_nichols

	* configure.ac: changes for compiling on Mavericks with XCode 5.1,
	  cannot use -Wl,-x in link anymore since Apple LLVM 5.1 will fail
	  with optimizations enabled

2014-05-17 15:37  david_nichols

	* configure.ac, include/qore/intern/QoreNamespaceIntern.h,
	  include/qore/intern/qore_socket_private.h: included patches for
	  compiling on Mavericks with XCode 5.1, cannot use -Wl,-x in link
	  anymore since Apple LLVM 5.1 will fail with optimizations enabled
	  prevented export of additional internal symbols

2014-05-16 22:09  nros

	* include/qore/intern/QC_TermIOS.h: Close the local file descriptor
	  in getWindowSize.

2014-05-15 11:36  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/OracleSqlUtil.qm:
	  fixed schema information classes when the "string-numbers" driver
	  option is enabled

2014-05-14 12:27  david_nichols

	* include/qore/intern/qore_socket_private.h: fixed problems parsing
	  HTTP chunked trailers and setting up callback arguments for
	  trailers

2014-05-12 12:30  david_nichols

	* doxygen/lang/150_container_data_types.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreClosureNode.h,
	  include/qore/intern/QoreHashNodeIntern.h,
	  lib/QoreClosureNode.cpp, lib/QoreObject.cpp: fixed a memory and
	  reference leak caused by recursive references when closures
	  encapsulating an object\'s scope are assigned to or accessible
	  from members of the object by making references to the object
	  from within a closure encapsulating the object\'s state weak
	  references instead of strong references

2014-05-12 10:52  david_nichols

	* examples/restserver.q: added a shutdown api call to the
	  restserver.q example

2014-05-11 18:43  david_nichols

	* lib/qore_date_private.cpp, qlib/HttpServer.qm: handle return
	  value errors with the handleRequest() method in a more
	  user-friendly way

2014-05-11 13:17  david_nichols

	* include/qore/intern/qore_socket_private.h: fixed a memory leak
	  that happens when an HTTP message is received with an empty
	  Content-Type header

2014-05-11 11:46  nros

	* lib/qpp.cpp: Close file pointers properly when not needed
	  anymore.

2014-05-06 18:27  nros

	* configure.ac: Fix building on NetBSD 7.

2014-05-05 19:43  nros

	* lib/QoreString.cpp: Fixed out-of-bounds read of
	  url_reserved_list[] in qore_string_init().
	  -This line, and those below, will be ignored--
	  
	  M lib/QoreString.cpp

2014-05-05 11:37  david_nichols

	* qlib/Schema.qm: fixed bugs setting info_callback in schema
	  alignment and drop operations

2014-05-04 15:41  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreNamespaceIntern.h, lib/QoreNamespace.cpp,
	  lib/QoreProgram.cpp: fixed the following bugs:
	  - fixed a bug in Program::importFunction() where only the
	  committed function list was checked when importing functions with
	  a specific target namespace path
	  - fixed a bug in Program::importClass() where only the committed
	  class list was checked when importing functions with a specific
	  target namespace path
	  - fixed a bug when parsing subnamespaces into a parent namespace
	  where the subnamespace already exists (either in the committed
	  list or in the pending list)

2014-05-02 15:07  david_nichols

	* qlib/Schema.qm: doc updates

2014-05-02 13:41  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/Schema.qm: doc
	  updates

2014-05-02 11:57  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: minor release note doc
	  updates

2014-05-02 11:50  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QC_DatasourcePool.qpp, lib/ql_lib.qpp, qlib/Schema.qm:
	  sanitized Schema module API, renamed, reorganized, and documented
	  classes

2014-04-30 13:00  david_nichols

	* qlib/HttpServer.qm, qlib/RestHandler.qm: HTTP chunked/stream
	  handling infrastructure updates:
	  + added more documentation
	  + sanitized callback architecture

2014-04-30 08:47  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/OracleSqlUtil.qm:
	  OracleSqlUtil updates:
	  + convert date/time values to timestamps with microseconds
	  resolution instead of dates with second resolution when
	  dynamically inserting values as strings in SQL (binding by value
	  not affected)
	  + make some private methods private in OracleDatabase
	  + doc updates

2014-04-30 08:18  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/SqlUtil.qm: added
	  SqlUtil::Table::checkExistence() method to SqlUtil

2014-04-29 14:34  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/HttpServer.qm,
	  qlib/RestHandler.qm, qlib/SqlUtil.qm: added the
	  HttpServer::AbstractStreamRequestHandler class
	  updated docs

2014-04-29 12:27  david_nichols

	* configure.ac: fixed configure.ac with new iconv.m4 on freebsd
	  with libiconv installed under /usr/local

2014-04-29 12:04  david_nichols

	* m4/iconv.m4: added AC_LANG_PROGRAM to AC_COMPILE_IFELSE
	  invokation to avoid excess warnings

2014-04-29 11:53  nros

	* configure.ac, m4/iconv.m4: Use Keith Marshalls iconv.m4 to find
	  iconv instead of AC_SEARCH_LIBS.

2014-04-29 10:45  david_nichols

	* qlib/SqlUtil.qm: doc updates

2014-04-29 10:36  david_nichols

	* qlib/SqlUtil.qm: added new Table::insertFromSelect*() variants
	  taking Table arguments

2014-04-29 09:49  david_nichols

	* include/qore/intern/ConstantList.h,
	  include/qore/intern/QoreNamespaceIntern.h,
	  include/qore/intern/qore_program_private.h, lib/ConstantList.cpp,
	  lib/QoreNamespace.cpp: non-functional and debugging updates

2014-04-28 17:53  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QoreHttpClientObject.cpp, qlib/HttpServer.qm,
	  qlib/OracleSqlUtil.qm, qlib/RestHandler.qm, qlib/SqlUtil.qm: -
	  fixed programmatic select queries with "limit" but no "offset" in
	  OracleSqlUtil
	  - many DataStream and HTTP chunked support fixes
	  - added a minimum body size threshold for Content-Encoding
	  compression to HttpServer
	  - added new upsert constant maps to SqlUtil
	  - added logic to verify that literal placeholder arguments
	  inserted directly into sql strings from insert operators are only
	  made up of legal identifiers
	  - do not throw exceptions with new HTTPClient methods with
	  receive callbacks if the status code is < 100 or >= 300

2014-04-28 09:04  david_nichols

	* examples/sqlutil, qlib/Schema.qm: cosmetic updates

2014-04-27 20:43  david_nichols

	* lib/ql_misc.qpp, qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm,
	  qlib/SqlUtil.qm: added the ability to use sequence values in
	  select statements, in insert statements, and in update statements
	  in OracleSqlUtil and PgsqlSqlUtil

2014-04-22 11:29  david_nichols

	* qlib/Schema.qm: make sure to flush output after each info log msg

2014-04-20 15:41  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/RestClient.qm: add
	  support for application/xml to RestClient to indicate XML-RPC
	  value encoding
	  release notes updates

2014-04-20 11:34  david_nichols

	* include/qore/intern/ModuleInfo.h, qlib/HttpServer.qm,
	  qlib/RestHandler.qm: user module dependency fixes; finally
	  working I hope :)
	  additional module docs + datastream compatibility fixes

2014-04-20 07:49  david_nichols

	* lib/ModuleManager.cpp: fixed user module dependency management
	  again when a module cannot be loaded due to errors but
	  dependencies were already in place - remove dependencies when the
	  user module name context is removed if any errors occurred

2014-04-20 06:23  david_nichols

	* include/qore/intern/ModuleInfo.h, lib/ModuleManager.cpp,
	  lib/QC_Socket.qpp: fixed module dependency bugs: fixed dependency
	  management with module errors, fixed feature name generation from
	  user module file names
	  updated docs

2014-04-19 20:41  david_nichols

	* include/qore/QoreSocketObject.h,
	  include/qore/intern/qore_socket_private.h, lib/QC_Socket.qpp,
	  lib/QoreHttpClientObject.cpp, lib/QoreSocketObject.cpp: chunked
	  transfer fixes; ensure socket object is set in header callback

2014-04-19 20:19  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreHttpClientObject.h,
	  include/qore/intern/QoreHttpClientObjectIntern.h,
	  include/qore/intern/qore_socket_private.h, lib/QC_HTTPClient.qpp,
	  lib/QoreHttpClientObject.cpp, qlib/HttpServer.qm,
	  qlib/RestHandler.qm: data stream fixes; pass a reference to the
	  owning Socket object to allow the receive callback to change
	  socket params (such as the character encoding) when headers are
	  received

2014-04-19 19:52  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/CallReferenceNode.h,
	  include/qore/intern/qore_thread_intern.h,
	  lib/CallReferenceNode.cpp, lib/thread.cpp: fixed a bug where a
	  valid call reference to a private object method was created
	  within the class, then in some cases an object protection
	  exception was raised when the call reference was called outside
	  the class

2014-04-19 18:18  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/CallReferenceNode.h,
	  include/qore/intern/FunctionCallNode.h,
	  include/qore/intern/ObjectMethodReferenceNode.h,
	  include/qore/intern/QoreClassIntern.h, lib/CallReferenceNode.cpp,
	  lib/Function.cpp: fixed a bug where a call reference to an
	  abstract object method returned from an abstract class could be
	  executed even though it must have been instantiated by a concrete
	  subclass

2014-04-19 17:25  david_nichols

	* include/qore/intern/ModuleInfo.h, lib/ModuleManager.cpp: really
	  fixed user module dependency management

2014-04-19 16:45  david_nichols

	* include/qore/intern/ModuleInfo.h, lib/ModuleManager.cpp: really
	  fixed the user module dependency bug by implementing
	  bidirectional dependency maps and processing them correctly when
	  unloading user modules

2014-04-19 15:38  david_nichols

	* include/qore/intern/ModuleInfo.h,
	  include/qore/intern/qore_thread_intern.h, lib/ModuleManager.cpp,
	  lib/thread.cpp: user module dependency tracking fixes

2014-04-19 15:14  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: added info to relnotes
	  for last fix

2014-04-19 15:12  david_nichols

	* qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: fixed a bug in SqlUtil
	  where SqlUtil used excessively verbose column aliases that caused
	  errors when automatically updating columns with existing rows and
	  new default values and non-null contraints with PostgreSQL
	  databases

2014-04-19 14:56  david_nichols

	* include/qore/intern/QoreClassIntern.h: fixed a minor memory error
	  in class variable copy handling

2014-04-19 14:28  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/ModuleInfo.h,
	  include/qore/intern/qore_thread_intern.h, lib/ModuleManager.cpp,
	  lib/thread.cpp: fixed a bug where qore could crash on exit due to
	  user module destruction not taking into consideration user module
	  dependencies

2014-04-19 12:44  david_nichols

	* lib/QoreClassList.cpp, lib/QoreProgram.cpp: make sure class
	  variables 'finalized' values are copied when classes are
	  inherited; other cosmetic updates

2014-04-19 07:00  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/qore_socket_private.h, qlib/HttpServer.qm,
	  qlib/WebUtil.qm: fixed HTTP chunked trailer receive with
	  callback; trailew now set correctly under the "hdr" hash key
	  do not try to decode message chunks separately; chunked
	  transfer-encoding applies to the entire message and not to
	  individual chunks

2014-04-18 11:56  subik

	* qlib/SqlUtil.qm: sqlutil: fixed arguments for getCreateSql()

2014-04-17 13:58  david_nichols

	* qlib/HttpServer.qm, qlib/RestClient.qm, qlib/RestHandler.qm:
	  added configurable content encoding for send request message
	  bodies (ie optional compression to the RestClient module
	  decode message bodies with content-encoding before calling the
	  handler (regression in this release)

2014-04-16 16:42  david_nichols

	* lib/QoreTypeInfo.cpp, qlib/RestClient.qm: fixed a bug where *any
	  was not handled correctly; now is handled just like "any"
	  minor RestClient updates

2014-04-15 09:27  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: updated docs for last
	  commit

2014-04-15 09:26  david_nichols

	* lib/thread.cpp: fixed a bug where qore could crash on exit with
	  certain openssl versions by calling ERR_remove_state(0) in the
	  main thread's cleanup function

2014-04-10 04:48  david_nichols

	* qlib/RestHandler.qm: renamed socket object context attribute

2014-04-09 17:34  david_nichols

	* qlib/HttpServer.qm: fixed typo in last commit

2014-04-09 17:33  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreSocket.h, include/qore/QoreSocketObject.h,
	  include/qore/intern/qore_socket_private.h, lib/QC_Socket.qpp,
	  lib/QoreSocket.cpp, lib/QoreSocketObject.cpp, qlib/HttpServer.qm,
	  qlib/RestHandler.qm: http streaming transfer updates and
	  improvements

2014-04-08 18:15  david_nichols

	* qlib/HttpServer.qm, qlib/Mime.qm, qlib/RestHandler.qm: more HTTP
	  streaming send/recv support

2014-04-08 14:40  david_nichols

	* include/qore/intern/qore_socket_private.h,
	  lib/QoreHttpClientObject.cpp, lib/QoreSocketObject.cpp,
	  qlib/HttpServer.qm, qlib/RestHandler.qm: HTTP chunked fixes and
	  HttpServer and RestHandler streaming API fixes
	  HTTP chunked data recv fix: content encoding cannot be applied to
	  each chunk individually but rather only to the whole message
	  (rendering compression much less useful for chunked messaging)

2014-04-08 13:18  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/ConstantList.cpp:
	  fixed a bug handling parse initialization of constant values
	  requiring run-time evaluation after other parse exceptions have
	  been raised that could cause a parse-time crash

2014-04-08 12:43  david_nichols

	* examples/restserver.q, qlib/HttpServer.qm, qlib/RestHandler.qm:
	  progress on HTTP streaming support with REST

2014-04-08 06:42  david_nichols

	* include/qore/intern/qore_socket_private.h, qlib/HttpServer.qm:
	  fixed a regression introduced in the HttpServer module yesterday

2014-04-07 17:23  david_nichols

	* qlib/HttpServer.qm: more streaming HTTP messaging support

2014-04-06 21:07  david_nichols

	* include/qore/intern/qore_socket_private.h, lib/QC_HTTPClient.qpp,
	  lib/QC_Socket.qpp, qlib/HttpServer.qm: streaming socket support
	  fixes, started adding infrastructural support to the HttpServer
	  module for handling streaming requests and responses

2014-04-06 15:56  david_nichols

	* include/qore/QoreSocketObject.h, lib/QC_Socket.qpp,
	  lib/QoreSocketObject.cpp, qlib/HttpServer.qm: more progress on
	  streaming HTTP messaging support with chunked transfer encoding

2014-04-06 14:05  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreHttpClientObject.h, include/qore/QoreSocket.h,
	  include/qore/QoreSocketObject.h, include/qore/QoreThreadLock.h,
	  include/qore/intern/qore_socket_private.h, lib/QC_HTTPClient.qpp,
	  lib/QC_Socket.qpp, lib/QoreHttpClientObject.cpp,
	  lib/QoreSocket.cpp, lib/QoreSocketObject.cpp: more HTTP streaming
	  chunked send/recv support

2014-04-04 17:16  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, include/qore/QoreLib.h,
	  include/qore/intern/qore_socket_private.h,
	  lib/QoreHttpClientObject.cpp, lib/QoreSocket.cpp: implemented
	  internal support for receive callbacks with HTTP chunked receives
	  - not yet tested or bound to user code

2014-04-04 14:44  david_nichols

	* include/qore/QoreHttpClientObject.h, include/qore/QoreSocket.h,
	  include/qore/QoreThreadLock.h,
	  include/qore/intern/qore_socket_private.h, lib/QC_HTTPClient.qpp,
	  lib/QoreHttpClientObject.cpp, test/socket-test.q: initial support
	  for chunk HTTP sends; chunk HTTP recv callbacks not yet
	  implemented (currently will abort in debugging mode if called)
	  new HTTPClient methods:
	  * sendWithSendCallback() (initial tests passed)
	  * sendWithRecvCallback() (not yet working)
	  * sendWithCallbacks() (not yet working)

2014-04-04 13:27  subik

	* qore.spec: spec file: add cmake support files to spec

2014-04-04 11:56  subik

	* Makefile.am, cmake/QoreConfig.cmake.in, cmake/QoreMacros.cmake:
	  qore: reintrodiced cmake support; cmake fixes for jhbuild/jenkins

2014-04-03 16:08  david_nichols

	* include/qore/QoreHTTPClient.h,
	  include/qore/QoreHttpClientObject.h,
	  include/qore/QoreSocketObject.h,
	  include/qore/intern/qore_socket_private.h,
	  lib/QoreHTTPClient.cpp, lib/QoreHttpClientObject.cpp,
	  lib/QoreSocket.cpp, lib/QoreSocketObject.cpp: initial changes to
	  add support for HTTP chunked sends and receives with callbacks
	  for better streaming data support in Qore

2014-04-02 11:18  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: various SqlUtil fixes,
	  mostly for Mysql and Pgsql + some common SqlUtil API changes

2014-04-01 16:51  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/PgsqlSqlUtil.qm,
	  qlib/SqlUtil.qm: fixed bugs handling "bigint" and "double
	  precision" column types with schema alignments with the
	  PgsqlSqlUtil module

2014-04-01 16:16  david_nichols

	* lib/ModuleManager.cpp, qlib/Schema.qm, qlib/SqlUtil.qm: reversed
	  module logic - qmod extension means binary module, everything
	  else is assumed to be a user module
	  minor Schema and SqlUtil API updates

2014-04-01 14:10  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreCondition.h,
	  include/qore/intern/AbstractSmartLock.h,
	  include/qore/intern/DatasourcePool.h,
	  include/qore/intern/QC_Condition.h, include/qore/intern/RWLock.h,
	  include/qore/intern/SmartMutex.h, include/qore/intern/VRMutex.h,
	  lib/AbstractSmartLock.cpp, lib/QC_Condition.qpp,
	  lib/QoreCondition.cpp, lib/RWLock.cpp, lib/SmartMutex.cpp,
	  lib/VRMutex.cpp, test/test.q: fixed a bug where an error could
	  result with Condition::wait() with timeouts > 2147483648 ms

2014-03-31 15:11  david_nichols

	* qlib/Schema.qm: minor formatting updates in log msgs

2014-03-31 15:10  david_nichols

	* qlib/Schema.qm: added support for dropping schemas; reworked the
	  API

2014-03-31 12:09  david_nichols

	* qlib/Schema.qm: Schema module updates

2014-03-28 17:00  david_nichols

	* qlib/Schema.qm: more Schema API updates

2014-03-28 16:45  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/SelfVarrefNode.h, lib/FunctionCallNode.cpp,
	  lib/QoreNamespace.cpp, lib/SelfVarrefNode.cpp, lib/parser.ypp,
	  qlib/Schema.qm: fixed several bugs where the parse location could
	  be reported incorrectly for type errors regarding in-object
	  variable references
	  Schema module updates

2014-03-28 13:41  david_nichols

	* qlib/Schema.qm: implemented intial public VersionedSchema class

2014-03-28 12:16  subik

	* qlib/SqlUtil.qm: check schema hash for whitespaces (begin/end) in
	  keys

2014-03-28 09:36  david_nichols

	* TODO, doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/ModuleInfo.h, lib/ModuleManager.cpp,
	  qlib/Schema.qm: started work on VersionedSchema class

2014-03-27 15:23  david_nichols

	* Makefile.am, doxygen/lang/900_release_notes.dox.tmpl,
	  qlib/Schema.qm, qlib/SqlUtil.qm: initial addition of the Schema
	  module, minor SqlUtil updates

2014-03-24 17:11  david_nichols

	* include/qore/intern/QoreObjectIntern.h,
	  include/qore/intern/Variable.h, lib/QoreObject.cpp,
	  lib/Variable.cpp: defined out temporary / non-functional object
	  recursive code

2014-03-20 17:26  nros

	* configure.ac: Fix AC_SEARCH_LIBS.
	  http://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/Libraries.html

2014-03-20 14:05  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/qc_option.qpp,
	  lib/ql_lib.qpp, lib/qpp.cpp: implemented the close_all_fd()
	  function and the HAVE_CLOSE_ALL_FD constant; this function will
	  close all open file descriptors; it's useful for executing when a
	  new daemon process starts that may have inherited open file
	  descriptors from the parent

2014-03-19 11:53  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, include/qore/QoreLib.h,
	  include/qore/QoreSocket.h,
	  include/qore/intern/qore_socket_private.h, lib/QoreSocket.cpp: -
	  new public C++ socket performance instrumentation API
	  fixed a reference leak related to exception handling with invalid
	  arguments with @ref Qore::Socket::setWarningQueue() and @ref
	  Qore::HTTPClient::setWarningQueue()

2014-03-18 14:55  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/qc_errno.qpp: added
	  the ESRCH error constant

2014-03-18 13:01  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/SwitchStatement.cpp,
	  lib/parser.ypp: fixed a bug where a qore switch statement with no
	  case conditions and only a default label would erroneously never
	  have it's default code executed

2014-03-17 12:43  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/SmtpClient.qm:
	  fixed missing username and missing password errors in the
	  SmtpClient module

2014-03-15 15:19  david_nichols

	* configure.ac: fix for compiling on 32-bit ARM (removed -m32 flag)

2014-03-14 10:02  david_nichols

	* qlib/WebSocketClient.qm: minor doc update

2014-03-14 10:01  david_nichols

	* qlib/WebSocketClient.qm: prepend "WebSocketClient: " to log
	  messages

2014-03-14 08:27  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/ConstantList.h,
	  include/qore/intern/QoreClassIntern.h, lib/ConstantList.cpp,
	  lib/Makefile.am, qore.spec: fixed an issue with class constant
	  parse initialization where invalid recursive class constant
	  definition parse exceptions could be raised and in some cases
	  also crashes could result
	  updated library version info

2014-03-12 10:55  david_nichols

	* configure.ac, qore.spec: updated to v 0.8.10 for future release

2014-03-11 16:53  david_nichols

	* include/qore/QoreQueue.h, lib/QoreQueue.cpp: more MXE build fixes

2014-03-11 16:45  david_nichols

	* include/qore/QoreIteratorBase.h, lib/QoreLib.cpp: build/compile
	  fixes for MXE

2014-03-11 16:11  david_nichols

	* ChangeLog, Makefile.am: commented out cmake info in Makefile so
	  the opensuse build service builds would succeed (for real this
	  time! :))
	  updated ChangeLog for 0.8.9 release

2014-03-11 15:50  david_nichols

	* Makefile.am: added cmake files to distribution so that builds
	  with the opensuse build service succeed

2014-03-07 18:57  david_nichols

	* lib/scanner.lpp: removed duplicate rulex

2014-03-07 11:10  david_nichols

	* lib/Pseudo_QC_String.qpp: doc update

2014-03-05 22:02  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/Function.h,
	  include/qore/intern/QoreClassIntern.h, lib/QoreClass.cpp: fixed a
	  memory leak in handling abstract methods when multiple abstract
	  methods with the same name but different signatures were declared
	  in a class

2014-03-04 16:23  david_nichols

	* qlib/HttpServer.qm: non-functional updates

2014-03-03 21:40  david_nichols

	* lib/qpp.cpp: fixed bug in qpp regarding "or nothing" class
	  restrictions

2014-03-03 16:08  david_nichols

	* Makefile.am, doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/DBI.h, include/qore/Datasource.h,
	  include/qore/Qore.h, include/qore/QoreLib.h,
	  include/qore/QoreQueue.h, include/qore/intern/DatasourcePool.h,
	  include/qore/intern/ManagedDatasource.h,
	  include/qore/intern/QC_Queue.h, include/qore/intern/QoreQueue.h,
	  include/qore/intern/QoreQueueIntern.h,
	  include/qore/intern/qore_dbi_private.h,
	  include/qore/intern/qore_ds_private.h, include/qore/params.h,
	  lib/DBI.cpp, lib/Datasource.cpp, lib/DatasourcePool.cpp,
	  lib/ManagedDatasource.cpp, lib/QC_Datasource.qpp,
	  lib/QC_DatasourcePool.qpp, lib/QC_Queue.qpp, lib/QoreQueue.cpp,
	  lib/qpp.cpp: added support for a DBI warning API to allow DBI
	  drivers to raise warnings that are posted on an event queue
	  added initial internal and external API support for describe
	  methods in DB drivers
	  fixed some issues supporting "or nothing" class parameters in qpp

2014-02-28 20:08  david_nichols

	* include/qore/intern/qore_socket_private.h: applied select()
	  error-handling fix to 0.8.8 branch, updated error msg in trunk

2014-02-28 17:01  david_nichols

	* include/qore/intern/qore_socket_private.h: non-functional changes

2014-02-28 13:28  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreHttpClientObjectIntern.h,
	  include/qore/intern/qore_socket_private.h: fixed a bug in socket
	  timeout handling with select() errors

2014-02-25 17:43  david_nichols

	* include/qore/DBI.h, include/qore/QoreLib.h, lib/QC_FtpClient.qpp,
	  lib/QoreSocket.cpp, qlib/WebSocketClient.qm: added the
	  _QORE_HAS_DBI_DESCRIBE define
	  doc fixes

2014-02-21 13:08  subik

	* include/qore/DBI.h, include/qore/intern/QoreSQLStatement.h,
	  include/qore/intern/qore_dbi_private.h, lib/DBI.cpp,
	  lib/QC_SQLStatement.qpp, lib/QoreSQLStatement.cpp: Implementation
	  of SQLStatement::describe() method

2014-02-18 20:11  david_nichols

	* qlib/Util.qm: fixed output formatting of get_*byte_size()
	  functions with values < 1K

2014-02-06 10:34  david_nichols

	* include/qore/QoreFtpClient.h,
	  include/qore/QoreHttpClientObject.h, include/qore/QoreSocket.h,
	  include/qore/QoreSocketObject.h,
	  include/qore/intern/qore_socket_private.h, lib/QC_FtpClient.qpp,
	  lib/QC_HTTPClient.qpp, lib/QC_Socket.qpp, lib/QoreFtpClient.cpp,
	  lib/QoreHttpClientObject.cpp, lib/QoreSocket.cpp,
	  lib/QoreSocketObject.cpp, qlib/Pop3Client.qm, qlib/SmtpClient.qm,
	  qlib/TelnetClient.qm, qlib/WebSocketClient.qm: added an
	  additional argument to set the minimum time period for socket
	  performance warnings (default: 1 second)

2014-02-04 16:28  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/Pop3Client.qm,
	  qlib/TelnetClient.qm, qlib/WebSocketClient.qm: minor corrections
	  to recent updates in user modules re socket performance
	  instrumentation, added support for socket performance
	  instrumentation and warning events to the WebSocketClient module

2014-02-04 16:22  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/Pop3Client.qm,
	  qlib/SmtpClient.qm, qlib/TelnetClient.qm: added support for
	  socket performance instrumentation and warning events to the
	  Pop3Client, SmtpClient, and TelnetClient modules

2014-02-04 16:12  david_nichols

	* Makefile.am, doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreFtpClient.h, include/qore/QoreSocket.h,
	  include/qore/intern/qore_socket_private.h, lib/QC_FtpClient.qpp,
	  lib/QC_HTTPClient.qpp, lib/QC_Socket.qpp, lib/QoreFtpClient.cpp,
	  lib/QoreSocket.cpp, qlib/SmtpClient.qm: added supoprt for socket
	  performance instrumentation and warning events to the FtpClient
	  class and the SmtpClient module/class

2014-02-04 07:27  david_nichols

	* lib/QoreSocket.cpp: socket performance monitoring fixes / updates

2014-02-03 16:26  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreHttpClientObject.h, include/qore/QoreSocket.h,
	  include/qore/QoreSocketObject.h, include/qore/intern/QC_Socket.h,
	  lib/QC_HTTPClient.qpp, lib/QC_Socket.qpp,
	  lib/QoreHttpClientObject.cpp, lib/QoreSocket.cpp,
	  lib/QoreSocketObject.cpp: added performance instrumentation for
	  Socket and HTTPClient classes plus warning infrastructure if
	  performance does not meet pre-defined limits

2014-01-31 15:35  david_nichols

	* lib/ql_misc.qpp: doc updates

2014-01-31 14:45  david_nichols

	* include/qore/intern/QoreHttpClientObjectIntern.h,
	  lib/QoreHttpClientObject.cpp: fixed double // reported in HTTP
	  URLs

2014-01-31 14:09  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm: minor doc updates

2014-01-31 14:01  david_nichols

	* command-line.cpp, qlib/TableMapper.qm: minor doc updates

2014-01-31 13:15  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreObjectIntern.h, lib/QoreClass.cpp,
	  lib/QoreObject.cpp, qlib/CsvUtil.qm, test/test.q: fixed a bug
	  managing object private data in complex inheritance cases where
	  the same class may be inherited with virtual private data and
	  also real private data
	  fixed CsvDataIterator::next() when header_lines > 0 and working
	  with empty input data
	  added a regression test for the CsvDataIterator case fixed above

2014-01-30 16:53  david_nichols

	* include/qore/QoreIteratorBase.h: added virtual destructors to new
	  abstract iterator classes with virtual methods

2014-01-29 15:09  david_nichols

	* doxygen/lang/245_parse_directives.dox.tmpl,
	  lib/QC_HTTPClient.qpp, lib/ql_misc.qpp: doc updates related to
	  environment variable substitution in the %include directive
	  added docs about the URL syntax when using UNIX socket paths

2014-01-29 14:58  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/scanner.lpp:
	  implemented support for environment variable substitution in the
	  %include parse directive; enforce PO_NO_FILESYSTEM in %include

2014-01-28 10:31  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/qore_number_private.h,
	  lib/QoreNumberNode.cpp, test/test.q: fixed a bug in the
	  arbitrary-precision rounding heuristic that could cause invalid
	  results

2014-01-27 11:47  david_nichols

	* doxygen/qdx: improved qdx regex for qore class -> c++ class
	  generation for doxygen documentation

2014-01-24 16:35  david_nichols

	* lib/QoreSocket.cpp: updated copyright to 2014

2014-01-20 16:08  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_Socket.qpp,
	  lib/QoreSocket.cpp, qlib/HttpServer.qm, qlib/RestHandler.qm:
	  HttpServer update:
	  - added support for the OPTIONS method
	  RestHandler updates:
	  - added support for the OPTIONS method
	  - return a 400 "Bad Request" error if an unsupported HTTP method
	  is used in a REST Call
	  other minor updates

2014-01-16 13:42  david_nichols

	* qlib/Util.qm: made iec abbreviations the default (and only
	  option) for get_byte_size()

2014-01-16 13:40  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, doxygen/qdx,
	  qlib/Mime.qm, qlib/Util.qm: doc updates
	  added new Mime file mappings
	  added use_iec argument to get_bute_size() function in the Util
	  module

2014-01-14 09:53  david_nichols

	* include/qore/AbstractQoreNode.h,
	  include/qore/intern/ConstantList.h,
	  include/qore/intern/ParseNode.h, lib/ConstantList.cpp: fixed a
	  constant entry lifetime mgmt bug introduced in a recent patch
	  related to memory leaks in constant mgmt

2014-01-12 15:39  david_nichols

	* include/qore/node_types.h: updated nax node type value

2014-01-12 15:35  david_nichols

	* include/qore/intern/CallReferenceNode.h,
	  include/qore/intern/qore_program_private.h,
	  lib/CallReferenceNode.cpp, lib/ConstantList.cpp,
	  lib/QoreObject.cpp, lib/QoreProgram.cpp,
	  lib/QoreReferenceCounter.cpp, lib/qore-main.cpp: fixed memory
	  issues with the last commit re ConstantEntry destruction, fixed a
	  memory leak in ConstantEntry destruction with parse rollbacks and
	  constant value of NULL

2014-01-12 15:15  david_nichols

	* Makefile.am, include/qore/intern/CallReferenceNode.h,
	  include/qore/intern/ConstantList.h,
	  include/qore/intern/qore_list_private.h,
	  include/qore/node_types.h, lib/CallReferenceNode.cpp,
	  lib/ConstantList.cpp, lib/QoreListNode.cpp,
	  lib/QoreNamespace.cpp: patches to avoid circular references in
	  constants with values that include call references

2014-01-10 15:22  david_nichols

	* lib/QoreNamespace.cpp: fixed a memory leak in clearing namespace
	  and class constant values when destroying Program objects if a
	  constant is assigned to a code reference

2014-01-09 13:42  david_nichols

	* include/qore/QoreReferenceCounter.h,
	  include/qore/intern/QoreObjectIntern.h,
	  include/qore/intern/qore_program_private.h,
	  lib/Pseudo_QC_String.qpp, lib/QoreProgram.cpp, lib/parser.ypp:
	  minor updates

2014-01-08 19:11  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreNamespaceIntern.h: missed files from last
	  commit

2014-01-08 16:32  david_nichols

	* lib/QoreClass.cpp: fixed memory leaks when an entire class has to
	  be rolled back due to parse errors and the class has pending
	  static variables

2014-01-08 16:23  david_nichols

	* lib/parser.ypp: fixed memory leaks in class member management
	  when adding static variables and members, and more memory leaks
	  when conflicts are detected in the parser and parse exceptions
	  are thrown

2014-01-08 16:18  david_nichols

	* lib/ql_time.qpp: fixed an off-by-one memory bug in date(string,
	  string) parsing a 4-digit date mask

2014-01-07 10:48  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: removed invalid line in
	  relnotes

2014-01-07 10:45  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/Pseudo_QC_All.qpp,
	  lib/Pseudo_QC_Binary.qpp, lib/Pseudo_QC_Hash.qpp,
	  lib/Pseudo_QC_List.qpp, lib/Pseudo_QC_Object.qpp,
	  lib/Pseudo_QC_String.qpp, lib/QC_FileLineIterator.qpp,
	  qlib/CsvUtil.qm, test/test.q: added new pseudo-methods:
	  <*>::sizep(): if the value type can return a non-zero size
	  <string>::getLine(): for parsing line data in string buffers
	  CsvUtil module updates:
	  new CsvAbstractIterator and CsvDataIterator classes
	  added tests for CsvDataIterator class

2014-01-06 19:48  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: minor doc update

2014-01-06 19:43  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/RestHandler.qm,
	  qlib/Util.qm: doc updates

2014-01-06 14:18  subik

	* Makefile.am, cmake/QoreConfig.cmake.in, cmake/QoreMacros.cmake,
	  doxygen/lib/90_cmake.doxygen, doxygen/lib/mainpage.doxygen: cmake
	  builds: documented; more macros introduced; compiler warning fix

2014-01-06 12:43  david_nichols

	* qlib/TableMapper.qm: do not add mappings for columns where there
	  is no input mapping and there is no not null constraint or no
	  default value

2014-01-06 12:21  david_nichols

	* qlib/Mapper.qm, qlib/TableMapper.qm, test/test.q: mapper API and
	  doc updates, added tests for the Mapper class

2014-01-06 09:06  david_nichols

	* include/qore/QoreIteratorBase.h: added missing file

2014-01-05 20:19  david_nichols

	* qlib/Mapper.qm: doc update

2014-01-05 17:47  david_nichols

	* qlib/HttpServer.qm, qlib/Mapper.qm, qlib/TableMapper.qm: mapper
	  updates

2014-01-04 16:31  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/Mapper.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/TableMapper.qm: fixed a bug in
	  PgsqlSqlUtil retrieving sequence values with
	  Database::getNextSequenceValue()
	  mapper fixes
	  updated release notes

2014-01-04 15:50  david_nichols

	* include/qore/QoreString.h, qlib/Mapper.qm, qlib/TableMapper.qm:
	  mapper updates and minor C++ api updates

2014-01-04 14:15  david_nichols

	* qlib/Mapper.qm: mapper fix

2014-01-04 14:08  david_nichols

	* qlib/Mapper.qm, qlib/TableMapper.qm: mapper fixes

2014-01-04 14:03  david_nichols

	* qlib/Mapper.qm: fixed Mapper constructor

2014-01-04 13:59  david_nichols

	* qlib/TableMapper.qm: implementation fixes

2014-01-04 13:46  david_nichols

	* include/qore/intern/AbstractIteratorHelper.h, lib/QoreLib.cpp,
	  qlib/Mapper.qm, qlib/TableMapper.qm: added new mapper
	  constructors and new infrastructure for binary modules to provide
	  iterator support

2014-01-04 11:32  david_nichols

	* include/qore/ModuleManager.h, lib/Makefile.am,
	  lib/ModuleManager.cpp, qore.spec: updated library and module api
	  version info to reflect new APIs

2014-01-04 11:28  david_nichols

	* Makefile.am, include/qore/AbstractPrivateData.h,
	  include/qore/Qore.h, include/qore/intern/QoreHashIterator.h,
	  include/qore/intern/QoreHashListIterator.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreListIterator.h,
	  include/qore/intern/SingleValueIterator.h, lib/QoreLib.cpp,
	  qlib/OracleSqlUtil.qm: made QoreIteratorBase class public to make
	  it easier to implement iterators in binary modules

2014-01-04 10:57  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, qlib/Mapper.qm,
	  qlib/TableMapper.qm: mapping updates

2014-01-03 18:00  david_nichols

	* Makefile.am, qlib/Mapper.qm, qlib/TableMapper.qm: added
	  TableMapper module based on Mapper and SqlUtil

2014-01-03 15:45  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, qlib/Mapper.qm: started
	  adding initial data mapping module

2014-01-02 18:46  david_nichols

	* qlib/HttpServer.qm, qlib/WebUtil.qm: minor doc updates

2014-01-02 15:22  subik

	* Makefile.am, cmake, cmake/QoreConfig.cmake.in,
	  cmake/QoreConfigVersion.cmake.in, cmake/QoreMacros.cmake,
	  configure.ac: cmake build reworked: qore creates cmake support
	  files during configuration; modules using cmake just do not use
	  FindQore.cmake in internal trees but use system-wide
	  QoreConfig.cmake

2013-12-31 08:18  david_nichols

	* lib/QC_RWLock.qpp, qlib/WebUtil.qm: minor doc updates

2013-12-30 16:55  david_nichols

	* qlib/SqlUtil.qm: removed unused variable declaration in SqlUtil

2013-12-30 16:51  david_nichols

	* lib/QoreFtpClient.cpp: updated exceptions to be consistent with
	  other FtpClient exceptions

2013-12-30 15:42  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/SqlUtil.qm: added
	  new UpsertInsertOnly upsert strategy to SqlUtil, updated relnotes

2013-12-29 13:27  david_nichols

	* qlib/CsvUtil.qm: updated module doxygen docs for easier
	  integration in external docs

2013-12-29 13:19  david_nichols

	* qlib/TelnetClient.qm, qlib/WebSocketClient.qm,
	  qlib/WebSocketHandler.qm: updated module doxygen docs for easier
	  integration in external docs

2013-12-29 09:32  david_nichols

	* qlib/HttpServer.qm, qlib/Mime.qm, qlib/RestHandler.qm: renamed
	  module intro sections for easier incorporation in external docs

2013-12-29 09:20  david_nichols

	* doxygen/qdx: remove $ signs in "our" global variable declarations
	  for doxygen processing

2013-12-28 19:11  david_nichols

	* qlib/RestClient.qm, qlib/SqlUtil.qm, qlib/Util.qm: renamed intro
	  sections for incorporation in external docs

2013-12-28 07:29  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreEncoding.h, include/qore/QoreFtpClient.h,
	  include/qore/QoreString.h, lib/QoreString.cpp, lib/charset.cpp,
	  lib/ql_misc.qpp: fixed url encoding and decoding in encode_url()
	  and decode_url() to really be RFC 3986 compliant

2013-12-27 16:40  david_nichols

	* lib/QoreHttpClientObject.cpp, lib/QoreSocket.cpp:
	  cosmetic/non-functional changes

2013-12-24 11:53  david_nichols

	* TODO, doxygen/lang/120_modules.dox.tmpl, lib/QC_HTTPClient.qpp:
	  minor doc updates

2013-12-18 13:35  david_nichols

	* lib/ql_misc.qpp: doc update for encode_url()

2013-12-18 13:34  david_nichols

	* include/qore/QoreString.h, include/qore/intern/QoreLibIntern.h,
	  lib/QoreString.cpp, lib/ql_misc.qpp, lib/qore-main.cpp: added new
	  option to encode_url() to encode all reserved characters listed
	  by RFC 3986

2013-12-18 11:25  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/RestClient.qm:
	  RestClient fixes:
	  - set the character encoding in the Content-Type request header
	  when sending strings
	  - set the Accept header correctly in requests (previously only
	  indicated yaml as an acceptible response encoding

2013-12-17 14:28  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QoreString.cpp:
	  decode_url() function updated to decode UTF-8 characters if the
	  target string is in UTF-8 encoding

2013-12-17 14:19  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreString.h, lib/QoreString.cpp, lib/ql_misc.qpp,
	  qlib/RestClient.qm: + implemented the encode_url() function to
	  correspond to decode_url()
	  + updated the RestClient module to use the new encode_url()
	  function to encode URL paths to ensure that valid requests are
	  sent when spaces, percent characters, and non-ascii characters
	  are used in the URL path

2013-12-16 14:57  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_Condition.qpp,
	  lib/ql_file.qpp: fixed a bug in lchown() where chown() was used
	  interally instead of lchown()
	  fixed typos in the Condition class docs

2013-12-16 10:28  david_nichols

	* qlib/SqlUtil.qm: fixed another recursive call in Table::del()

2013-12-16 09:31  david_nichols

	* lib/thread.cpp: fixed a memory bug with exception handling when
	  shutting down threads when exceptions occur after thread-local
	  data has been deleted and the current timezone is queried for the
	  current program context

2013-12-13 13:27  david_nichols

	* lib/DatasourcePool.cpp: minor fixes to datasourcepool acquisition
	  related to instrumentation changes

2013-12-13 13:04  david_nichols

	* include/qore/intern/DatasourcePool.h, lib/DatasourcePool.cpp:
	  attempts to fix DatasourcePool instrumentation issues - to be
	  verified

2013-12-02 07:59  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/SqlUtil.qm: fixed
	  additional bugs in MySQL create/align table SQL generation with
	  unique indexes that automatically create unique contraints

2013-12-01 15:24  david_nichols

	* README-LICENSE, doxygen/lang/900_release_notes.dox.tmpl,
	  qlib/SqlUtil.qm: fixed a bug in SqlUtil generating "create table"
	  SQL with DBs where unique indexes automatically create unique
	  constraints (ex: MySQL)
	  minor doc updates

2013-12-01 14:26  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/SqlUtil.qm: fixed bugs related to
	  MySQL and some minor table creation SQL construction bugs

2013-11-21 10:22  david_nichols

	* include/qore/intern/DatasourcePool.h,
	  include/qore/intern/QoreLibIntern.h, lib/DatasourcePool.cpp,
	  lib/QC_DatasourcePool.qpp, lib/QoreLib.cpp, lib/ql_time.qpp:
	  updated DatasourcePool max wait time to use microseconds, fixed
	  threading issues with the DatasourcePool callback (callback is no
	  longer called while holding the internal DatasourcePool lock but
	  the check for the callback is always made while the lock is held
	  to ensure a consistent view of the data)

2013-11-19 18:05  david_nichols

	* lib/DatasourcePool.cpp: fixed initialization order

2013-11-19 14:06  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/DatasourcePool.h, lib/DatasourcePool.cpp,
	  lib/QC_DatasourcePool.qpp:
	  DatasourcePool::getWarningCallbackInfo() renamed to
	  getUsageInfo(); connection acquisition statistics are tracked and
	  returned in DatasourcePool::getUsageInfo() (which returns, total
	  requests, hits, maximum wait time, etc)

2013-11-19 10:59  david_nichols

	* include/qore/intern/DatasourcePool.h, lib/DatasourcePool.cpp,
	  lib/QC_DatasourcePool.qpp: added an optional argument to the
	  datasourcepool warning callback

2013-11-19 10:44  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/DatasourcePool.h,
	  include/qore/intern/DatasourceStatementHelper.h,
	  include/qore/intern/QoreLibIntern.h, lib/DatasourcePool.cpp,
	  lib/QC_DatasourcePool.qpp, lib/QoreLib.cpp, lib/ql_time.qpp: new
	  DatasourcePool methods:
	  - DatasourcePool::clearWarningCallback()
	  - DatasourcePool::setWarningCallback()
	  - DatasourcePool::getWarningCallbackInfo()
	  - DatasourcePool::setErrorTimeout()
	  - DatasourcePool::getErrorTimeout()
	  the new methods allow for monitoring DatasourcePool objects for
	  pool contention issues (in case the pool needs to be resized) and
	  for throwing an exception if a connection is not acquired within
	  the error timeout period (new default: 2 minutes)

2013-11-13 21:43  david_nichols

	* include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/ql_crypto.h: removed invalid assert()s,
	  cosmetic changes

2013-11-10 12:34  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/Datasource.h,
	  include/qore/intern/ManagedDatasource.h,
	  include/qore/intern/qore_ds_private.h, lib/Datasource.cpp,
	  lib/DatasourcePool.cpp, lib/ManagedDatasource.cpp: - fixed a bug
	  in the Datasource copy constructor where implicitly-set options
	  were not carried over into the new object
	  - fixed a bug in the DatasourcePool class where implicitly-opened
	  connections would not be guaranteed to have the same server time
	  zone setting as the initial connections (for example, could cause
	  problems with server timezone settings if running in a program
	  context with a different local time zone attribute)

2013-11-08 15:46  david_nichols

	* lib/FunctionCallNode.cpp: fixed a typo in the last commit

2013-11-08 15:34  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreClass.h, include/qore/intern/FunctionCallNode.h,
	  include/qore/intern/QoreClassIntern.h, lib/CallReferenceNode.cpp,
	  lib/FunctionCallNode.cpp, lib/QoreClass.cpp, lib/QoreObject.cpp:
	  fixed a bug where a call to a call reference to a static method
	  across a program boundary with local variables as arguments would
	  cause a crash due to improper setting of the program context
	  before the arguments are evaluated

2013-11-08 09:29  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/ModuleInfo.h, lib/ModuleManager.cpp: the
	  error message now includes the module path used for the search
	  when a module cannot be found in the module path

2013-11-07 17:45  david_nichols

	* qlib/MailMessage.qm, qlib/Util.qm: fixed corner cases when
	  processing multi-line input and some regex issues with hash
	  processing
	  fixed a typo in MailMessage

2013-11-07 16:26  david_nichols

	* examples/sqlutil: added -L,--list-tables to sqlutil

2013-11-05 08:57  subik

	* qlib/SqlUtil.qm: sqlutil: dropViewIfExists implemented

2013-11-04 15:24  subik

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: sqlutil: view info
	  implemented

2013-10-30 18:01  david_nichols

	* qlib/SmtpClient.qm: fixed a regression caused by a recent patch -
	  make sure that we authenticate before sending messages after a
	  QUIT

2013-10-30 11:35  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/Util.qm: added
	  get_byte_size() and get_marketing_byte_size() to Util

2013-10-29 17:20  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/ql_time.qpp:
	  milliseconds() and mcroseconds() are both subject to overflow
	  errors with large arguments

2013-10-29 13:34  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreString.h, lib/QoreLib.cpp, lib/QoreObject.cpp:
	  fixed a bug in v*printf() where '%%' was not handled correctly in
	  all cases

2013-10-28 18:49  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/SqlUtil.qm: fixed
	  an infinitely recursive call in Table::del() in SqlUtil

2013-10-25 15:26  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/SmtpClient.qm:
	  SmtpClient updates: optimized connection and login code;
	  HELO/EHLO and authorization are performed when connecting only,
	  not before each email

2013-10-23 16:14  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, include/qore/common.h:
	  added support to compile on OSX Mavericks

2013-10-23 14:15  david_nichols

	* include/qore/intern/QoreClassIntern.h: disabled unnecessary
	  debugging output

2013-10-23 12:21  david_nichols

	* qlib/CsvUtil.qm: removed %perl-bool-eval from CsvUtil since it's
	  the default anyway

2013-10-23 11:53  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/CsvUtil.qm: fixed a
	  bug where CsvUtil returned an invalid date when used with the
	  "date" type and blank input
	  updated release notes

2013-10-21 15:00  david_nichols

	* lib/QoreSocket.cpp: minor non-functional socket fix

2013-10-21 13:39  david_nichols

	* qlib/CsvUtil.qm: implemented support for the "*int", "*float",
	  "*number", and "*date" types; implemented support for allowing
	  subclasses of CsvFileIterator to implement support for other
	  custom types

2013-10-17 15:42  david_nichols

	* lib/ql_file.qpp: cosmetic non-functional change

2013-10-16 16:51  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreHttpClientObjectIntern.h: fixed a bug in
	  the @ref Qore::HTTPClient::getURL() "HTTPClient::getURL()" and
	  @ref Qore::HTTPClient::getProxyURL() "HTTPClient::getProxyURL()"
	  methods where the URL's path was not given with a leading "/"
	  character

2013-10-15 11:24  david_nichols

	* examples/sqlutil: fixed help for sequence dump

2013-10-15 04:45  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/RegexSubstNode.cpp,
	  lib/scanner.lpp: allow escaping "$" character in regular
	  expression substitution target strings, previously it was
	  impossible to output a literal "$" + a digit, since this would be
	  interpreted as a numbered input pattern expression

2013-10-15 04:24  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/scanner.lpp: fixed a
	  bug parsing octal character constants in the lexer when octal
	  digits followed the octal constant (ex: \c "\0441" meaning \c
	  "$1" would cause an error)

2013-10-15 03:55  david_nichols

	* doxygen/qdx, qlib/RestHandler.qm, qlib/SqlUtil.qm, qlib/Util.qm:
	  doc updates and fixes

2013-10-09 09:10  subik

	* qlib/CsvUtil.qm, test/CsvUtil/test.q: csvutil: in-memory string
	  writer implemented; writers are refactored to use
	  AbstractCsvWriter

2013-10-08 14:28  subik

	* qlib/CsvUtil.qm: CsvUtil: reformatted <tabs> to spaces

2013-10-06 07:17  david_nichols

	* lib/QoreHttpClientObject.cpp: ported duplicate HTTP header
	  handling from trunk to 0.8.8-snapshot, minor non-functional
	  update to trunk regarding duplicate header handling

2013-10-06 07:01  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/Makefile.am,
	  lib/QoreHttpClientObject.cpp, qore.spec: fixed a crashing bug
	  when HTTP messages with duplicate Connection, Content-Encoding,
	  Transfer-Encoding, Location, or Content-Type headers is received

2013-10-04 13:55  david_nichols

	* ChangeLog, configure.ac, qore.spec: updated to v0.8.9 for future
	  release

2013-10-04 10:35  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QoreTimeZoneManager.cpp: fixed a mismatched delete/malloc
	  error with time zone initialization and the localtime file

2013-10-04 10:28  david_nichols

	* Makefile.am: added missing qpp source file to src list

2013-10-04 10:21  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/RestClient.qm, qlib/RestHandler.qm,
	  qlib/SqlUtil.qm, qlib/Util.qm, qlib/WebSocketClient.qm,
	  qlib/WebSocketHandler.qm, qlib/WebSocketUtil.qm, qlib/WebUtil.qm:
	  update initial release dates

2013-10-04 10:16  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qore.spec: doc and
	  release updates

2013-10-04 08:29  david_nichols

	* lib/QoreSocket.cpp: if the SSL connection is closed by the remote
	  end while writing then flag the connection as closed and throw an
	  appropriate exception so that errors can be caught when they
	  happen instead of on the next read / write

2013-10-03 17:40  david_nichols

	* include/qore/Qore.h: doc updates

2013-10-03 07:41  david_nichols

	* COPYING.MIT, Makefile.am, README, README-LICENSE,
	  command-line.cpp, include/qore/common.h, lib/ModuleManager.cpp,
	  qore.spec: updated qore to reflect being released under an MIT
	  open-source license in addition to GPL and LGPL

2013-10-02 11:04  subik

	* qlib/OracleSqlUtil.qm: sqlutils: standard methods for
	  materialized views implemented; docs for OracleMaterializedView
	  public members

2013-09-30 16:01  david_nichols

	* lib/qore_date_private.cpp: always output dates with the same
	  string format for better parsing

2013-09-29 16:27  david_nichols

	* doxygen/lang/120_modules.dox.tmpl, qlib/HttpServer.qm: doc
	  updates

2013-09-29 10:55  david_nichols

	* qlib/CsvUtil.qm: set headers automatically if fields are set and
	  no headers option is given in the constructor (and headerLines is
	  false)

2013-09-27 09:06  david_nichols

	* test/test.q: skip hstat test on windows

2013-09-27 09:04  david_nichols

	* test/test.q: fixed test script for openssl without SHA* hash
	  algorithms

2013-09-26 18:54  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: updated release notes
	  for numeric bugs fixed in last commit

2013-09-26 18:53  david_nichols

	* include/qore/QoreNumberNode.h,
	  lib/QoreLogicalEqualsOperatorNode.cpp,
	  lib/QoreLogicalGreaterThanOperatorNode.cpp,
	  lib/QoreLogicalGreaterThanOrEqualsOperatorNode.cpp,
	  lib/QoreLogicalLessThanOperatorNode.cpp, lib/QoreNumberNode.cpp:
	  fixed comparisons with number values and strings (and other
	  errors with logical numeric comparisons where they were being
	  first converted to doubles, now native comparisons are used)

2013-09-26 14:34  david_nichols

	* qlib/Util.qm: do argument parsing in a sandboxed Program object
	  with PO_LOCKDOWN set

2013-09-26 04:57  david_nichols

	* lib/QoreDir.cpp: fix for windows build

2013-09-23 13:44  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/MysqlSqlUtil.qm,
	  qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added the possibility to get / group by year, year to month, year
	  to day with SqlUtil

2013-09-20 14:51  david_nichols

	* qlib/HttpServer.qm: fixed HTTP argument logging in external
	  handlers

2013-09-17 15:57  subik

	* qlib/SqlUtil.qm: sqlutil: comments and hints for Table class

2013-09-17 14:20  david_nichols

	* examples/sqlutil, qlib/OracleSqlUtil.qm: allow schema qualifiers
	  when finding sequences, dump sequences from sqlutil

2013-09-17 13:31  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: when aligning schemas and
	  adding columns to a table with a new not null constraint and a
	  default value and the table is not empty then update the table
	  and set all existing rows where that column is null to the new
	  default value

2013-09-17 12:55  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: dropped support in
	  OracleSqlUtil for oracle module versions < 3.0, added detection
	  for Oracle 12c and added direct support for limit (fetch) and
	  offset to create simpler paging queries

2013-09-17 11:39  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: fixed SQL query generation
	  order regarding order by, group by, and having, updated SqlUtil
	  to allow orderby to accept column operators

2013-09-16 13:42  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_HTTPClient.qpp:
	  fixed return type of HTTPClient::getConnectionPath()

2013-09-16 13:28  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: implemented support for
	  grouping by columns with column operators; implemented the
	  "year_hour" operator for truncating dates to a certain hour for
	  sorting / grouping

2013-09-13 14:03  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/qore_number_private.h: fixed a bug where
	  number("") was being converted to @NaN@n

2013-09-11 16:33  david_nichols

	* include/qore/QoreHTTPClient.h, lib/QoreHTTPClient.cpp: fixed
	  QoreHTTPClient class to be ABI compatible with old xml and json
	  modules

2013-09-11 16:30  david_nichols

	* qlib/SqlUtil.qm: added support for more column operators (+,-,/,
	  and *)

2013-09-11 09:53  david_nichols

	* qlib/SqlUtil.qm: implemented the avg() column operator

2013-09-09 13:06  subik

	* include/qore/ReferenceHolder.h, qlib/MysqlSqlUtil.qm,
	  qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  sqlutil: features() and constants for special DB features

2013-09-09 06:04  david_nichols

	* qlib/OracleSqlUtil.qm: added support for dblinks to OracleSqlUtil

2013-09-08 20:28  david_nichols

	* qlib/HttpServer.qm: updated HttpServer::getURLFromBind() to
	  support UNIX domain sockets

2013-09-08 20:14  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/HttpServer.qm:
	  fixed starting listeners on UNIX domain sockets on Soalris in the
	  HttpServer module

2013-09-08 20:08  david_nichols

	* qlib/HttpServer.qm: minor cosmetic update to exception info

2013-09-08 19:26  david_nichols

	* include/qore/QoreHttpClientObject.h, lib/QC_HTTPClient.qpp,
	  lib/QoreHttpClientObject.cpp: removed more common methods from
	  the HTTPClient class

2013-09-08 19:03  david_nichols

	* Makefile.am: fixed typo in new file name

2013-09-08 18:58  david_nichols

	* include/qore/QoreLib.h: added a define for the
	  QoreHttpClientObject class

2013-09-08 18:52  david_nichols

	* lib/QC_HTTPClient.qpp: doc updates

2013-09-08 18:45  david_nichols

	* include/qore/QoreHttpClientObject.h, lib/QC_HTTPClient.qpp,
	  lib/QoreHttpClientObject.cpp: removed some redundant methods from
	  the HTTPClient class

2013-09-08 15:48  david_nichols

	* Makefile.am, doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreHTTPClient.h,
	  include/qore/QoreHttpClientObject.h,
	  include/qore/QoreSocketObject.h, include/qore/intern/QC_Socket.h,
	  include/qore/intern/QoreHttpClientObjectIntern.h,
	  lib/Makefile.am, lib/QC_HTTPClient.qpp, lib/QC_Socket.qpp,
	  lib/QoreHTTPClient.cpp, lib/QoreHttpClientObject.cpp,
	  lib/QoreSocket.cpp, lib/QoreSocketObject.cpp, lib/mySocket.cpp,
	  lib/qore-main.cpp, lib/single-compilation-unit.cpp,
	  qlib/WebSocketClient.qm: made the HTTPClient class a subclass of
	  the Socket class, making it easier to implement protocols based
	  on HTTP
	  updated the WebSocketClient class to use the HTTPClient class for
	  connections, making it possible to connect to websocket servers
	  over a proxy, etc

2013-09-06 19:09  david_nichols

	* include/qore/QoreString.h, lib/QoreHTTPClient.cpp,
	  lib/QoreSocket.cpp, lib/QoreString.cpp, lib/QoreURL.cpp,
	  lib/ql_misc.qpp, qlib/HttpServer.qm: added support for UNIX
	  sockets in the HTTPClient and in parse_url() with a format like:
	  http://socket=%2ftmp%2fsocket-file-name

2013-09-04 14:08  david_nichols

	* lib/parser.ypp: compile fix for Oracle Sun Studio CC

2013-09-04 13:51  david_nichols

	* qlib/SqlUtil.qm: aynchronized SqlUtil with trunk

2013-09-03 14:04  david_nichols

	* qlib/SqlUtil.qm: added support for referencing columns more than
	  once in a where clause (ex: > col and <= col) by allowing column
	  specifications to be prefixed by a number and a colon which is
	  just allowed for uniqueness in the where hash and is ignored when
	  building the where clause

2013-09-03 13:47  david_nichols

	* qlib/Util.qm: fixed a bug parsing text to qore values where a
	  date anywhere in the argument would cause the argument to be
	  parsed as a date

2013-09-02 19:54  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, examples/sqlutil,
	  qlib/HttpServer.qm, qlib/SqlUtil.qm, qlib/WebSocketClient.qm:
	  added initial support to SqlUtil for suppressing triggers, foreign
	  constraints, and indexes when aligning and creating tables
	  added initial (non-functional) support to the WebSocketClient
	  module for connecting to a web socket server through a proxy

2013-08-29 21:43  david_nichols

	* include/qore/QoreNothingNode.h, include/qore/QoreNullNode.h,
	  include/qore/intern/ThreadPool.h, lib/QoreNullNode.cpp: fixed a
	  memory leak in the ThreadPool class, fixed boolean(NULL) to
	  return False

2013-08-28 17:58  david_nichols

	* lib/Pseudo_QC_Int.qpp: fixed <int>::encode[ML]sb() with unsigned
	  2 and 4 byte integers

2013-08-23 07:17  david_nichols

	* lib/QoreObject.cpp: minor update to currently disabled /
	  prototyping recursive object reference functionality

2013-08-22 18:18  david_nichols

	* include/qore/intern/QoreObjectIntern.h, lib/QoreObject.cpp: more
	  progress on recursive object reference handling, still disabled
	  by default

2013-08-21 20:25  david_nichols

	* include/qore/QoreObject.h,
	  include/qore/intern/QoreObjectIntern.h,
	  include/qore/intern/Variable.h, lib/QoreObject.cpp,
	  lib/Variable.cpp: major object circular reference progress;
	  working algorithm for maintaining multiple recursive graphs but
	  need to work on locking and graph lifecycle management issues,
	  still disabled by default

2013-08-19 16:21  david_nichols

	* include/qore/intern/QoreObjectIntern.h, lib/QoreObject.cpp: more
	  partial updates on object recursive reference work

2013-08-19 14:56  david_nichols

	* include/qore/AbstractQoreNode.h, include/qore/QoreObject.h,
	  include/qore/QoreRWLock.h, include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreObjectIntern.h,
	  include/qore/intern/QoreValue.h, include/qore/intern/Variable.h,
	  lib/AbstractQoreNode.cpp, lib/QoreObject.cpp, lib/Variable.cpp,
	  scratch/memory-leak-1.q: much better and more formalized but only
	  partially implemented recursive object reference check, still
	  disabled by default, based on determining a cyclic directed graph
	  of objects and handling each graph together, a node in such a
	  graph can only be dereferenced due to recursive references if all
	  members of the graph can be dereferenced

2013-08-18 14:06  david_nichols

	* include/qore/intern/QoreObjectIntern.h, qlib/MysqlSqlUtil.qm,
	  qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  fixed an infinite recursion bug related to index retrieval in
	  *SqlUtil, initial updates for OracleSqlUtil to work with 12c

2013-08-17 11:05  david_nichols

	* include/qore/intern/QoreValue.h, include/qore/intern/Variable.h,
	  lib/Variable.cpp: better lock management for recursive object
	  reference detection, runs with lvalue lock released with
	  temporary referenced lvalue assignment; object iterations happen
	  in object read locks

2013-08-17 07:24  david_nichols

	* test/test.q: added regression tests for floating-point formatting
	  bugs

2013-08-17 07:21  david_nichols

	* include/qore/intern/QoreObjectIntern.h, lib/QoreObject.cpp,
	  lib/Variable.cpp, scratch/memory-leak-1.q: more comprehensive
	  recursive object reference coverage and better lock management,
	  still not thread-safe - still disabled by default

2013-08-17 06:17  david_nichols

	* include/qore/AutoVLock.h, include/qore/intern/LocalVar.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/Variable.h, lib/StaticClassVarRefNode.cpp,
	  lib/VLock.cpp, lib/Variable.cpp: use read-write locks on all
	  lvalues requiring locks for much better read scalability

2013-08-16 18:29  david_nichols

	* include/qore/AutoVLock.h, include/qore/QoreRWLock.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreObjectIntern.h,
	  include/qore/intern/Variable.h, lib/QoreObject.cpp,
	  lib/VLock.cpp, lib/Variable.cpp: much faster & working recursive
	  object reference check but not totally thread safe yet (currently
	  disabled by default), also use a read-write lock for object
	  access giving much improved object read performance in
	  multithreaded programs

2013-08-16 13:39  subik

	* Makefile.am, qlib/Qorize.qm, test/Qorize,
	  test/Qorize/complex.xml, test/Qorize/test-qorize.q: module
	  qorize: initial import

2013-08-16 12:56  subik

	* lib/ql_misc.qpp: docs: makeHexString/parseHexString cross
	  reference

2013-08-16 12:35  david_nichols

	* qlib/WebUtil.qm: doc updates

2013-08-16 11:19  david_nichols

	* lib/QC_TimeZone.qpp, qlib/PgsqlSqlUtil.qm, qlib/WebSocketUtil.qm:
	  doc updates

2013-08-16 10:42  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, include/qore/QoreLib.h,
	  lib/Pseudo_QC_String.qpp, lib/QoreLib.cpp, lib/Variable.cpp: doc
	  updates, added public/external q_mode_to_perm() c++ api

2013-08-15 12:27  subik

	* lib/Pseudo_QC_Bool.qpp, test/test.q: fixed #669
	  <bool>::typeCode() returns boolean instead of NT_BOOLEAN constant

2013-08-12 22:24  david_nichols

	* qlib/OracleSqlUtil.qm: fixed a bug handling oracle indexes in
	  schema upgrades

2013-08-11 17:58  david_nichols

	* doxygen/lang/145_basic_data_types.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, lib/ql_crypto.qpp: doc
	  updates

2013-08-07 14:26  david_nichols

	* lib/QoreLib.cpp: applied Petr's access()-based solution for
	  is_writable() to 0.8.8-snapshot, use access() for is_readable()
	  as well

2013-08-07 13:48  subik

	* configure.ac, lib/ql_file.qpp: is_writable: more complex
	  implementation. It works fine in cases of multiple groups etc.

2013-08-07 11:23  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QoreLib.cpp: fixed a
	  bug in *printf() formatting with floating-point and number values
	  where no digits were displayed right of the decimal point unless
	  a specific number of digits was specified in the format string

2013-08-05 20:01  david_nichols

	* include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreObjectIntern.h, lib/QoreClass.cpp,
	  lib/QoreObject.cpp, lib/Variable.cpp, scratch/memory-leak-1.q:
	  improved recursive object reference detection algorithm; still
	  disabled since it's still not thread safe and also makes object
	  code > 6x slower :(

2013-08-05 12:47  david_nichols

	* include/qore/QoreObject.h, include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreObjectIntern.h,
	  include/qore/intern/qore_program_private.h, lib/QoreObject.cpp,
	  lib/QoreProgram.cpp, scratch/memory-leak-1.q: removed old broken
	  recursive object reference check code, implemented new,
	  non-thread-safe but working recursive object reference detection
	  code, disabled it temporarily

2013-08-03 07:59  david_nichols

	* qlib/WebSocketHandler.qm: fixed typo in last commit

2013-08-02 16:41  david_nichols

	* lib/Pseudo_QC_String.qpp, lib/unicode-charmaps.cpp: much more
	  efficient unaccent implementation

2013-08-02 10:47  david_nichols

	* qlib/WebSocketHandler.qm: doc updates

2013-08-02 06:34  david_nichols

	* qlib/HttpServer.qm, qlib/RestHandler.qm: doc updates

2013-08-01 14:03  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, examples/httpserver.q,
	  include/qore/QoreObject.h, include/qore/intern/ClassRefNode.h,
	  include/qore/intern/QoreClassIntern.h, lib/ClassRefNode.cpp,
	  lib/Operator.cpp, lib/QoreObject.cpp, qlib/HttpServer.qm,
	  qlib/WebUtil.qm: fixed a bug in the instanceof operator when
	  working with objects and classes created from different source
	  @ref Qore::Program "Program" objects
	  doc updates to WebUtil and HttpServer modules
	  added HttpServer::AbstractHttpRequestHandler::redirect()
	  updated httpserver.q example program to use FileHandler

2013-08-01 11:34  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QoreDir.cpp: added
	  path name to error messages in Dir class exception strings

2013-08-01 11:09  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_ReadOnlyFile.qpp,
	  qlib/WebUtil.qm: added ReadOnlyFile::readTextFile() and
	  ReadOnlyFile::readBinaryFile() static methods for easier reading
	  of entire files with one command; major WebUtil updates to handle
	  file-based templates and recompile automatically when the file's
	  access time is updated

2013-07-31 14:13  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: updated release notes

2013-07-31 14:12  david_nichols

	* qlib/HttpServer.qm: implemented a workaround if "QorusServer" is
	  defined to allow the default msg body encoding when no charset
	  spec is included in the content-type to be set to an encoding
	  other than iso-8859-1

2013-07-31 11:44  david_nichols

	* configure.ac: minor configure fix

2013-07-31 11:32  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: added release note for
	  configure fix in last commit

2013-07-31 11:31  david_nichols

	* configure.ac: really fixed the configure error with bison >= 3

2013-07-31 11:27  david_nichols

	* configure.ac: compile fix for bison >= 3

2013-07-29 18:07  david_nichols

	* doxygen/lang/120_modules.dox.tmpl: dox updates

2013-07-26 18:04  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/ReferenceNode.h,
	  include/qore/intern/ParseReferenceNode.h,
	  include/qore/intern/Variable.h,
	  include/qore/intern/qore_thread_intern.h,
	  lib/QoreUnaryMinusOperatorNode.cpp,
	  lib/ReferenceArgumentHelper.cpp, lib/ReferenceNode.cpp,
	  lib/Variable.cpp: fixed a bug where recursive references were
	  allowed and memory leaks would occur due to recursive references;
	  these are now caught at runtime and a \c REFERENCE-ERROR
	  exception is thrown

2013-07-26 12:30  david_nichols

	* include/qore/intern/QoreValue.h,
	  include/qore/intern/qore_number_private.h,
	  lib/QoreUnaryMinusOperatorNode.cpp: fixed a static parse-time
	  memory leak in the unary minus operator with number constants

2013-07-26 11:39  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreString.h, lib/Pseudo_QC_Int.qpp,
	  lib/Pseudo_QC_String.qpp, lib/QoreString.cpp, lib/charset.cpp:
	  added a memory check in QoreEncoding::getByteLen() for non
	  multibyte encodings, added <string>::getUnicode() pseudo-method,
	  made QoreString::getUnicodePoint() much more efficient

2013-07-26 10:51  david_nichols

	* lib/unicode-charmaps.cpp, test/test.q: simplified unicode upper
	  mapping by generating form the reverse of the lower mapping,
	  added regression tests for string pseudo-method enhancements:
	  unaccent(), lwr(), and upr()

2013-07-26 08:37  david_nichols

	* lib/Pseudo_QC_String.qpp: fixed examples in new pseudo-methods

2013-07-26 08:33  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreEncoding.h, include/qore/QoreString.h,
	  include/qore/intern/QoreLibIntern.h, lib/Makefile.am,
	  lib/Pseudo_QC_Int.qpp, lib/Pseudo_QC_String.qpp,
	  lib/QoreString.cpp, lib/charset.cpp, lib/ql_string.qpp,
	  lib/qore-main.cpp, lib/single-compilation-unit.cpp,
	  lib/unicode-charmaps.cpp: added support for <string>::unaccent()
	  to return an equivalent string except with accented characters
	  converted to unaccented characters; added support for a wide
	  range of non-ASCII characters (Latin, Cyrillic, Greek, Armenian,
	  Georgian, etc characters) with toupper(), tolower(),
	  <string>::lwr(), and <string>::upr()

2013-07-25 14:43  subik

	* qlib/SqlUtil.qm: sqlutil: doc fix

2013-07-25 14:33  david_nichols

	* lib/QoreDir.cpp: fixed a regression in Dir::list() created in a
	  recent commit

2013-07-25 14:16  david_nichols

	* qlib/WebUtil.qm: fixed inserting values into templates: NOTHING &
	  NULL -> empty string

2013-07-25 13:55  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_Dir.qpp,
	  lib/QoreDir.cpp: fixed a bug in the Dir class where it was not
	  possible to chdir to the root directory

2013-07-25 12:43  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreDir.h, lib/QC_Dir.qpp, lib/QoreDir.cpp,
	  qlib/HttpServer.qm: Qore::Dir: all list*() methods now take an
	  optional parameter to return a list of @ref stat_hash "file
	  status value hashes" instead of file names since in many cases
	  the files need to be stat()ed anyway
	  doc udpates in HttpServer module

2013-07-25 10:58  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreLibIntern.h, lib/Pseudo_QC_Date.qpp,
	  lib/ql_time.qpp: added the following <date> pseudo-methods:
	  info(), getEpochSeconds(), getEpochSecondsLocalTime()

2013-07-25 09:50  david_nichols

	* qlib/HttpServer.qm, qlib/RestHandler.qm: updated
	  parse_uri_query() to return the documented value when all
	  parameters are key/value pairs

2013-07-25 08:49  david_nichols

	* qlib/WebUtil.qm: render complex data structures with %y in
	  template code

2013-07-24 16:10  david_nichols

	* Makefile.am, doxygen/lang/900_release_notes.dox.tmpl,
	  qlib/HttpServer.qm, qlib/Util.qm: doc updates - moved
	  get_exception_string() from HttpServer -> Util, reexported
	  get_exception_string() from HttpServer for
	  backwards-compatibility

2013-07-24 15:16  david_nichols

	* qlib/HttpServer.qm, qlib/WebUtil.qm: updated parse_uri_query()
	  docs; include hdr and hdr.params in FileHandler to give header
	  info and URI query parameters in hash format if possible in
	  template code

2013-07-24 14:06  david_nichols

	* qlib/RestHandler.qm, qlib/WebUtil.qm: added docs in WebUtil,
	  fixed error message with unimplemented methods in RestHandler

2013-07-24 13:29  david_nichols

	* qlib/HttpServer.qm, qlib/WebUtil.qm: added a simple directory
	  template to the FileHandler for servigin directory contents;
	  updated the error response in the HttpServer to wrap responses in
	  <pre></pre> tags

2013-07-24 09:59  david_nichols

	* doxygen/lang/120_modules.dox.tmpl, qlib/WebUtil.qm: updated
	  WebUtil to always use auto-rendering on templates

2013-07-23 20:37  david_nichols

	* Makefile.am: fixed module doc generation

2013-07-23 19:47  david_nichols

	* doxygen/qdx: fixed comment detection in qdx

2013-07-23 17:55  david_nichols

	* doxygen/lang/245_parse_directives.dox.tmpl: doc updates

2013-07-23 17:22  david_nichols

	* qlib/HttpServer.qm: fixed a bug in HttpServer::getURLFromBind()

2013-07-23 17:12  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, qlib/HttpServer.qm,
	  qlib/WebUtil.qm: major updates to WebUtil; added a FileHandler
	  class; added a AbstractUrlHandler class to HttpServer; updated
	  docs

2013-07-23 16:32  david_nichols

	* include/qore/AbstractQoreNode.h, include/qore/QoreClass.h,
	  include/qore/intern/QoreClassIntern.h: missing files for last
	  commit

2013-07-23 16:32  david_nichols

	* lib/Operator.cpp, lib/QoreClass.cpp, lib/QoreHashNode.cpp,
	  lib/VarRefNode.cpp: fixed bugs where parse exceptions could
	  report the wrong source location:
	  - in hash value expressions
	  - with redeclaring local variable return types
	  - in local variable class declaration instantiations

2013-07-22 18:23  david_nichols

	* qlib/WebUtil.qm: updated TemplateManager with support for
	  returning the Content-Type as well as the rendered template

2013-07-22 15:35  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  qlib/OracleSqlUtil.qm, qlib/WebUtil.qm: Webutil fixes, doc &
	  makefile updates

2013-07-22 11:15  david_nichols

	* test/test.q: added more number regression tests

2013-07-22 10:01  david_nichols

	* include/qore/intern/qore_number_private.h, lib/Operator.cpp,
	  lib/Pseudo_QC_String.qpp, lib/QoreNumberNode.cpp,
	  lib/QoreString.cpp, lib/QoreStringNode.cpp, lib/ql_string.qpp,
	  test/test.q: fixed number rounding errors in trunk and
	  0.8.8-snapshot, fixed regressions in trunk related to substr()

2013-07-21 13:01  david_nichols

	* Makefile.am, doxygen/qdx, qlib/WebSocketHandler.qm: doc updates;
	  updated qdx to allow for multiple tag files per generated
	  Doxyfile; more Makefile rule generators, reduced the number of
	  manual rules further

2013-07-21 08:07  david_nichols

	* Makefile.am, qlib/WebUtil.qm: added initial WebUtil module;
	  greatly simplified Makefile.am by implementing generic build
	  rules for modules

2013-07-20 12:36  david_nichols

	* qlib/RestHandler.qm, qlib/WebSocketHandler.qm: doc updates;
	  started enhancing RestHandler documentation

2013-07-20 11:43  david_nichols

	* Makefile.am, doxygen/qdx, qlib/HttpServer.qm,
	  qlib/RestHandler.qm, qlib/WebSocketClient.qm,
	  qlib/WebSocketHandler.qm: doc updates, qdx fixes: fixed abstract
	  method handling, fixed parameter processing with literal hash
	  default arguments (more of a workaround than a definitive fix)

2013-07-20 10:15  david_nichols

	* qlib/WebSocketClient.qm: set the User-Agent header automatically
	  when making a web socket connection with the WebSocketClient

2013-07-20 09:53  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/RestHandler.qm,
	  qlib/WebSocketClient.qm, qlib/WebSocketUtil.qm: minor doc
	  updates; fixed web socket message masking

2013-07-20 05:43  david_nichols

	* doxygen/lang/000_intro.dox.tmpl,
	  doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, lib/QC_Datasource.qpp,
	  lib/QC_DatasourcePool.qpp, qlib/MysqlSqlUtil.qm,
	  qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm: doc updates

2013-07-19 12:21  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/BinaryNode.cpp,
	  qlib/WebSocketClient.qm, qlib/WebSocketUtil.qm: major
	  WebSocketClient updates, updated %y with binary arg to output
	  yaml format

2013-07-19 11:15  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/ModuleManager.cpp,
	  lib/Pseudo_QC_Float.qpp, lib/Pseudo_QC_Int.qpp,
	  lib/Pseudo_QC_Number.qpp, lib/ql_math.qpp, qlib/Util.qm: added
	  ::abs() pseudo-method to <int>, <float>, and <number> type
	  classes, slightly improved get_random_string() on Windows (ie w/o
	  /dev/random), updated docs

2013-07-19 09:44  david_nichols

	* qlib/Util.qm: fixed get_random_string() to not require
	  PO_PROCESS_CONTROL

2013-07-18 21:16  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, doxygen/qdx,
	  lib/ql_string.qpp, qlib/Util.qm, qlib/WebSocketClient.qm,
	  qlib/WebSocketUtil.qm: added new optional arguments to replace(),
	  added initial WebSocketClient module

2013-07-17 11:19  david_nichols

	* include/qore/intern/QoreValue.h: fixed a bug in the remove
	  operator related to recent QoreValue changes

2013-07-17 10:22  david_nichols

	* lib/QoreStringNode.cpp: fixed the substr() issue with
	  QoreStringNode also

2013-07-17 10:18  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreString.h, lib/Pseudo_QC_String.qpp,
	  lib/QoreString.cpp, lib/ql_string.qpp: fixed a bug where substr()
	  and <string>::substr() were returning @ref nothing if the
	  arguments could not be satisifed contrary to the documentation
	  and the declared return type, now an empty string is returned in
	  those cases

2013-07-16 12:34  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreString.h, lib/Pseudo_QC_String.qpp,
	  lib/QoreString.cpp, qlib/HttpServer.qm: added
	  <string>::equalPartialPath() for more efficient path matching
	  against a template

2013-07-16 11:32  david_nichols

	* doxygen/lang/145_basic_data_types.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreString.h, lib/Pseudo_QC_String.qpp,
	  lib/QC_Socket.qpp, lib/QoreString.cpp, qlib/HttpServer.qm: added
	  <string>::comparePartial() and <string>::equalPartial()
	  implemented support for direct path matches in the HttpServer as
	  an alternative to regular expressions
	  implemented several performance improvements in the HttpServer
	  updated docs

2013-07-16 08:11  david_nichols

	* lib/QC_RangeIterator.qpp: fixed minor typos

2013-07-15 16:52  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/MysqlSqlUtil.qm,
	  qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added support for over/partition by (sql window functions) for
	  oracle and pgsql, added support for column operators for
	  comparing two column values directly, added support for
	  subqueries

2013-07-15 16:50  david_nichols

	* lib/QoreTimeZoneManager.cpp: fixed a bug where qore failed to set
	  the time zone region correctly when set from /etc/localtime and
	  this file is a relative symlink rather than absolute

2013-07-15 13:15  david_nichols

	* include/qore/intern/QoreException.h: only display the exception
	  source line once if the starting and ending lines are the same

2013-07-15 11:19  david_nichols

	* include/qore/intern/QoreValue.h: fixed bugs in lvalue handling
	  with debugging disabled

2013-07-11 08:53  david_nichols

	* qlib/OracleSqlUtil.qm: fixed a bug with the IN operator on Oracle
	  with no argument

2013-07-10 20:12  david_nichols

	* qlib/SqlUtil.qm: doc updates

2013-07-09 16:42  david_nichols

	* include/qore/intern/LocalVar.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreValue.h, include/qore/intern/Variable.h,
	  lib/Variable.cpp, qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: internal QoreValue
	  optimizations, preparations for wider use of QoreValue
	  (eventually to replace QoreBigIntNode, QoreFloatNode, and
	  QoreBoolNode), many doc updates

2013-07-08 09:14  david_nichols

	* Makefile.am: fixed makefile for nwe websocketutil module

2013-07-07 13:10  david_nichols

	* doxygen/qdx, qlib/SqlUtil.qm: workaround in qdx for closures
	  assigned to hash keys

2013-07-06 12:44  david_nichols

	* configure.ac, lib/thread.cpp: only call mpfr_free_cache if MPFR
	  uses TLS

2013-07-06 12:41  david_nichols

	* qlib/SqlUtil.qm: fixed a bug in setting up/creating a table from
	  a hash description

2013-07-06 11:00  david_nichols

	* doxygen/lang/120_modules.dox.tmpl, qlib/WebSocketHandler.qm,
	  qlib/WebSocketUtil.qm: split out basic websocket protocol support
	  from the WebSocketHandler module and put it in the new
	  WebSocketUtil module to enable creating a websocket client module
	  with shared code

2013-07-05 11:40  david_nichols

	* test/test.q: fixed test script for compiles without MDC2 in
	  openssl

2013-07-05 11:27  david_nichols

	* configure.ac, doxygen/lang/220_threading.dox.tmpl,
	  include/qore/intern/ql_crypto.h: compile fixes for openssl < 1.0
	  (ex: with rhel5)

2013-07-04 15:10  david_nichols

	* lib/QoreStringNode.cpp: removed old commented-out code

2013-07-04 15:02  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreString.h, lib/QoreLogicalEqualsOperatorNode.cpp,
	  lib/QoreString.cpp, lib/QoreStringNode.cpp,
	  lib/SwitchStatement.cpp, qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm:
	  much more efficient string equality checks
	  "hard" string comparisons now perform encoding conversions if
	  necessary (however as usual different data types cause the
	  comparison to fail)
	  bug fix in oracle "in" operator implementation
	  implement support for negating "where" operators in SqlUtil

2013-07-02 17:54  david_nichols

	* qlib/RestHandler.qm: minor logging update

2013-07-02 10:38  david_nichols

	* qlib/RestHandler.qm: don't return "OK" when REST methods return
	  no body; just return no body

2013-07-01 11:20  subik

	* qlib/CsvUtil.qm, test/CsvUtil, test/CsvUtil/test.csv,
	  test/CsvUtil/test.q: csvutil: file writer implemented

2013-06-28 12:17  david_nichols

	* qlib/HttpServer.qm: minor updates in getURLFromBind()

2013-06-28 08:56  david_nichols

	* doxygen/lang/195_statements.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, lib/SwitchStatement.cpp:
	  fixed the switch statement to use soft comparisons when both
	  operands are strings in order to match strings with different
	  encodings

2013-06-28 08:39  david_nichols

	* qlib/Mime.qm: added constants for css and js files + more
	  extension -> mime type mappings

2013-06-27 15:11  david_nichols

	* qlib/SqlUtil.qm: removed debugging stmt

2013-06-27 15:09  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, include/qore/QoreType.h,
	  include/qore/intern/LocalVar.h,
	  include/qore/intern/QoreTypeInfo.h,
	  include/qore/intern/ReferenceHelper.h,
	  include/qore/intern/Variable.h, lib/CallReferenceNode.cpp,
	  lib/Function.cpp, lib/QoreAssignmentOperatorNode.cpp,
	  lib/QoreTypeInfo.cpp, lib/StatementBlock.cpp, qlib/SqlUtil.qm,
	  test/test.q: - fixed bugs handling arguments declared as type
	  @ref reference_or_nothing_type "*reference" (reference or
	  nothing)
	  - fixed bugs in executing code accross @ref Qore::Program
	  "Program" object barriers with reference arguments
	  - implemented support for logging SQL data operations with a
	  callback

2013-06-27 12:08  david_nichols

	* qlib/SqlUtil.qm: implemented support for the "having" option in
	  SQL queries for filtering queries using aggregate functions

2013-06-27 11:12  david_nichols

	* qlib/SqlUtil.qm: commented out debugging line

2013-06-27 11:12  david_nichols

	* qlib/SqlUtil.qm: fixed argument-handling issues in SqlUtil

2013-06-26 15:47  david_nichols

	* qlib/PgsqlSqlUtil.qm: removed logic to update rows with the
	  default value when changed - can implement this later with an
	  option

2013-06-26 12:48  subik

	* include/qore/intern/ql_crypto.h, lib/ql_crypto.qpp, test/test.q:
	  crypto: HMAC functions implemented

2013-06-26 12:42  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: fixed the in operator
	  with Oracle

2013-06-25 16:30  david_nichols

	* include/qore/intern/QoreClassIntern.h, lib/QoreNamespace.cpp,
	  qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm:
	  updated "where" operators to use a flexible implementation that
	  can be overridden and extended in subclasses

2013-06-25 13:53  david_nichols

	* qlib/SqlUtil.qm: fixed the count operator as the previous
	  implementation allowed direct sql injections

2013-06-25 13:52  david_nichols

	* qlib/SqlUtil.qm: implemented "groupby" query option, fixed column
	  operators with no column expression

2013-06-25 13:20  david_nichols

	* include/qore/intern/ConstantList.h, lib/ConstantList.cpp,
	  lib/QoreClass.cpp, qlib/SqlUtil.qm: fixed flexible column
	  operator implementation

2013-06-25 12:41  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QoreDotEvalOperatorNode.cpp, qlib/MysqlSqlUtil.qm,
	  qlib/SqlUtil.qm: fixed bugs where parse exceptions in methods
	  calls could be reported at the wrong source location
	  updated SqlUtil to use more flexible column operator
	  implementation - column operator checks are now O(ln(n)) in the
	  worst case, also driver-specific column operators can now be
	  implemented generically

2013-06-25 11:40  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/SqlUtil.qm: fixed mysql sequence
	  processing and column options

2013-06-25 11:08  david_nichols

	* qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: implemented initial
	  support for the "distinct" column operator
	  make sure and manually update existing column values when setting
	  a new default value for a pgsql column

2013-06-21 17:42  david_nichols

	* qlib/HttpServer.qm, qlib/WebSocketHandler.qm: fixed the dedicated
	  socket handler API for the HttpServer, now when a listener is
	  stopped, only those connections handled by the listener are
	  stopped

2013-06-21 15:29  david_nichols

	* qlib/RestClient.qm: added the possibility to send customer
	  headers with REST requests

2013-06-21 12:59  david_nichols

	* qlib/RestHandler.qm: correct subclass in makeResponse static
	  method call

2013-06-21 12:53  david_nichols

	* lib/Pseudo_QC_Object.qpp, qlib/HttpServer.qm: minor updates from
	  the last commit

2013-06-21 12:48  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  lib/Pseudo_QC_Object.qpp, qlib/HttpServer.qm,
	  qlib/RestHandler.qm: http improvements; include "X-Powered-By"
	  header by default in responses, return a user-friendly 405
	  response when an invalid HTTP method is used with a REST method
	  that takes other methods, other minor fixes

2013-06-21 11:34  david_nichols

	* include/qore/intern/ThreadPool.h, lib/BinaryNode.cpp,
	  lib/QC_ThreadPool.qpp, lib/QoreRegexNode.cpp, lib/QoreSocket.cpp,
	  qlib/HttpServer.qm: updates for signed/unsigned comparison
	  warnings, other minor updates

2013-06-21 11:13  david_nichols

	* include/qore/intern/QoreClassIntern.h, lib/Pseudo_QC_Object.qpp,
	  lib/QoreClass.cpp, qlib/RestHandler.qm: added new object
	  pseudo-methods to determine if methods are accessible

2013-06-20 18:36  david_nichols

	* qlib/HttpServer.qm: more flexible HTTP handling, allow dedicated
	  listeners to have multiple handlers

2013-06-20 15:50  david_nichols

	* qlib/HttpServer.qm: non-functional changes in commented-out
	  debugging lines

2013-06-18 13:57  david_nichols

	* lib/QoreSocket.cpp: set body-content-type even when no charset
	  decl is present

2013-06-17 19:58  david_nichols

	* lib/QC_Socket.qpp, lib/QoreSocket.cpp, lib/QoreString.cpp,
	  qlib/HttpServer.qm, testbed/httpd.cc: many optimizations for
	  faster/more efficient HTTP processing, particularly server-side
	  processing

2013-06-15 17:24  david_nichols

	* Makefile.am, include/qore/QoreHashNode.h,
	  include/qore/intern/QoreHashIterator.h,
	  include/qore/intern/QoreHashNodeIntern.h,
	  include/qore/intern/ThreadPool.h, include/qore/qlist,
	  lib/QoreHashNode.cpp, lib/QoreSocket.cpp, testbed/httpd.cc:
	  completely rewritten hash node internals using std::list
	  added qlist wrapper for std::list that maintains size, use in
	  hash node internal implementation and in the thread pool
	  buffered read fixes for the socket class

2013-06-14 14:01  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QoreSocket.cpp,
	  testbed/Makefile, testbed/httpd.cc: massive socket read
	  performance gains for HTTP methods by implementing global private
	  read buffering - up to 10x faster read performance

2013-06-14 13:09  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: fixed bugs in the "in"
	  operator when the expression was empty

2013-06-13 15:22  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreSocket.h, include/qore/intern/QC_Socket.h,
	  lib/QC_Socket.qpp, lib/QoreSocket.cpp, lib/mySocket.cpp,
	  testbed/httpd.cc: Qore::Socket::getPeerInfo() and
	  Qore::Socket::getSocketInfo() methods now take an optional
	  argument to avoid name lookups
	  Qore::Socket::readHTTPHeaderString(): new method
	  http server testbed updates
	  

2013-06-13 13:19  david_nichols

	* testbed/Makefile: added a makefile for the http server testbed

2013-06-13 13:19  david_nichols

	* qlib/WebSocketHandler.qm: commented out debugging msgs

2013-06-13 11:21  david_nichols

	* testbed, testbed/httpd.cc: added new c++ http testbed for
	  performance testing

2013-06-13 07:31  david_nichols

	* qlib/WebSocketHandler.qm: web socket fixes - allow socket
	  communication only in the dedicated connection thread for the web
	  socket connection; implement better APIs to allow for more
	  efficient sending of the same message to multiple receivers

2013-06-12 14:33  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/Sequence.h, lib/QoreSocket.cpp,
	  qlib/HttpServer.qm: minor HttpServer log improvements
	  minor socket updates
	  doc updates

2013-06-12 08:34  subik

	* lib/ql_string.qpp: regex_subst: an advanced example

2013-06-10 17:19  david_nichols

	* qlib/HttpServer.qm: made ThreadPool usage the default due to
	  concrete performance benefits

2013-06-10 16:48  david_nichols

	* qlib/HttpServer.qm, qlib/MailMessage.qm: HttpServer: added cid to
	  many log messages
	  MailMessage: set message body from any explicitly-set
	  Content-Type header when serializing with attachements as a Mime
	  multipart msg

2013-06-09 20:58  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, examples/email.q,
	  qlib/MailMessage.qm, qlib/Mime.qm: fixed bugs in the SmtpClient
	  and MailMessage modules where mail messages were being serialized
	  incorrectly if there were no attachments (there was no
	  possibility to set the content transfer encoding) and also where
	  it was not possible to set the content-type for the message body
	  when it was sent as a part of a multipart message

2013-06-09 17:06  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/ThreadPool.h: doc udpates; added release_ms
	  to ThreadPool::toString() output

2013-06-09 16:54  david_nichols

	* lib/QC_ThreadPool.qpp: thread pool doc updates

2013-06-09 16:41  david_nichols

	* include/qore/intern/ThreadPool.h, lib/QC_ThreadPool.qpp,
	  lib/QoreHTTPClient.cpp: fixed release_ms handling in thread pools

2013-06-09 16:14  david_nichols

	* include/qore/intern/ThreadPool.h, lib/QC_ThreadPool.qpp: added a
	  delay period to the thread pool to terminate a single idle thread
	  for each delay period while the number of idle threads is >
	  minindle and no tasks are added to the pool

2013-06-07 11:33  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_Condition.qpp:
	  fixed a bug with Condition::wait() on Darwin with negative
	  timeout values where a short timeout was used instead of an
	  indefinite wait

2013-06-07 11:14  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_Counter.qpp,
	  lib/QC_ThreadPool.qpp, lib/QoreCounter.cpp: added additional
	  safety checks for the Counter class to catch common errors (bad
	  initialization, unbalanced dec() calls)
	  updated docs for ThreadPool

2013-06-07 10:27  david_nichols

	* include/qore/intern/ThreadPool.h, lib/QC_ThreadPool.qpp: added
	  missing files; implemented task cancelation for ThreadPool tasks
	  when the ThreadPool is shut down before the task can be executed

2013-06-06 16:50  david_nichols

	* Makefile.am, doxygen/lang/900_release_notes.dox.tmpl,
	  examples/email.q, include/qore/qore_thread.h, lib/Makefile.am,
	  lib/QoreSocket.cpp, lib/single-compilation-unit.cpp,
	  lib/thread.cpp, qlib/HttpServer.qm, qlib/MailMessage.qm,
	  qlib/SmtpClient.qm: added a ThreadPool class
	  started making fixes to the MailMessage and SmtpClient modules
	  for properly serializing mail message bodies (still more work to
	  do)
	  converted the HttpServer class to use the new builtin ThreadPool
	  class for quickly allocating threads to incoming connections

2013-06-05 11:43  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreSocket.h, include/qore/intern/QC_Socket.h,
	  lib/QC_Socket.qpp, lib/QoreSocket.cpp, lib/mySocket.cpp,
	  lib/thread.cpp, qlib/HttpServer.qm: do not call mpfr_free_cache()
	  id MPFR was not built with TLS support
	  implemented a "backlog" argument for Socket::listen(); default
	  changed from 5 -> 20

2013-06-04 18:57  david_nichols

	* qlib/HttpServer.qm: non-functional changes

2013-06-04 18:11  david_nichols

	* scratch/ThreadPool: added an experimental generic thread pool
	  implementation

2013-06-04 18:06  david_nichols

	* qlib/HttpServer.qm: commented out debugging line

2013-06-04 18:05  david_nichols

	* lib/QoreSocket.cpp, qlib/HttpServer.qm: minor socket fixes,
	  implemented a disabled simple thread pool for the HttpServer
	  module for performance testing purposes, HttpServer performance
	  optimizations and minor socket communication improvements

2013-06-04 12:31  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreQueue.h, lib/QC_Queue.qpp: added the
	  Queue::empty() method

2013-06-04 09:26  david_nichols

	* qlib/HttpServer.qm: HTTP server efficiency improvements

2013-06-03 18:48  david_nichols

	* qlib/HttpServer.qm: updated loging with debugging enabled for
	  dedicated socket listener errors

2013-06-02 12:30  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QC_DatasourcePool.qpp, lib/inet_ntop.cpp, qlib/HttpServer.qm:
	  implemented DatasourcePool::copy()
	  updated logging in HttpServer, doc and warning updates

2013-05-31 11:52  david_nichols

	* configure.ac: do not use -O3 with mingw32 cross-compiling as it
	  leads to segfaults, -O2 is OK

2013-05-31 09:21  david_nichols

	* BUILD, README-BINARIES, RELEASE-NOTES: updated docs for FreeBSD

2013-05-31 09:11  david_nichols

	* configure.ac: configure fixes to allow qore to compile without
	  any flags or environment variables on FreeBSD assuming all
	  prerequisites are installed

2013-05-31 08:18  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QoreHTTPClient.cpp,
	  lib/QoreSocket.cpp: implemented more strict adherence to rfc 2616
	  (HTTP 1.1) regarding message-body handling in requests and
	  response message generation and parsing

2013-05-31 07:24  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/qore_number_private.h: fixed a bug setting
	  the precision for arbitrary-precision numbers with very large
	  exponents (like "1e100n")

2013-05-30 13:10  david_nichols

	* qlib/HttpServer.qm: authentication fixes

2013-05-30 12:53  david_nichols

	* qlib/Util.qm: fixed a bug parsing strings to qore values

2013-05-30 12:41  david_nichols

	* qlib/RestClient.qm: minor error-handling fixes

2013-05-30 12:03  david_nichols

	* qlib/HttpServer.qm, qlib/RestHandler.qm: updated authentication
	  infrastructure, turned off default debug header logging in rest
	  handler

2013-05-30 08:31  david_nichols

	* lib/QC_Socket.qpp, lib/ql_lib.qpp, qlib/HttpServer.qm: doc
	  updates, improved HttpServer::add*Listener*() methods

2013-05-30 07:09  david_nichols

	* qlib/RestHandler.qm: disabled debugging line

2013-05-29 19:37  david_nichols

	* configure.ac: set optimization level to -O1 on freebsd because
	  otherwise qore segfaults when setting up signals before a fork
	  (freebsd only)

2013-05-29 16:37  david_nichols

	* qlib/HttpServer.qm: cosmetic updates

2013-05-29 12:15  david_nichols

	* lib/QoreSocket.cpp, qlib/HttpServer.qm: added new "family"
	  parameter to the HttpServer::addINETListeners() method to allow
	  the address family to be specified to expicitly bind either IPv4
	  or IPv6 addresses (useful for when ipv4-mapped address mapping is
	  not available such as by default in FreeBSD)

2013-05-29 11:15  david_nichols

	* test/test.q: fixed test.q to work on all platforms (verified on
	  freebsd)

2013-05-28 15:53  david_nichols

	* lib/RegexSubstNode.cpp, qlib/RestHandler.qm: minor fixes

2013-05-28 15:43  david_nichols

	* qlib/RestHandler.qm: fixed html serialization

2013-05-28 15:07  david_nichols

	* qlib/RestClient.qm, qlib/RestHandler.qm: rest handling updates

2013-05-28 13:32  david_nichols

	* lib/QC_HTTPClient.qpp, lib/QoreHTTPClient.cpp,
	  qlib/HttpServer.qm, qlib/RestClient.qm, qlib/RestHandler.qm:
	  fixed REST error handling; exceptions returned from the REST
	  server can now be deserialized and rethrown on the client side

2013-05-28 11:27  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreLibIntern.h, lib/QoreHTTPClient.cpp:
	  fixed a bug where references were not being written to the output
	  variable if an exception was active when the code block exited

2013-05-27 13:46  david_nichols

	* include/qore/intern/QoreClassIntern.h, lib/QoreClass.cpp: fixed a
	  memory leak with overridden abstract methods

2013-05-27 12:59  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreTypeInfo.h,
	  include/qore/intern/QoreValue.h, lib/QoreTypeInfo.cpp,
	  lib/Variable.cpp: fixed a bug where an invalid guard condition in
	  critical lvalue storage code can cause unreferenced data to be
	  returned while in a lock which can cause a crash in a
	  multithreaded program

2013-05-25 16:33  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/ModuleManager.h, include/qore/intern/ModuleInfo.h,
	  include/qore/intern/qore_program_private.h,
	  lib/ModuleManager.cpp, lib/QoreProgram.cpp, qlib/RestHandler.qm,
	  qlib/SqlUtil.qm: fixed a bug managing feature/module lists in
	  inherited Program objects; user modules were listed in the child
	  Program object even though user module code is not imported in
	  child Program objects
	  SqlUtil join fixes and other cosmetic fixes

2013-05-24 05:45  david_nichols

	* qlib/Util.qm: fixed a bug in Util introduced in the last commit

2013-05-24 05:29  david_nichols

	* qlib/Util.qm: added link in docs to new function in the Util
	  module

2013-05-24 05:29  david_nichols

	* qlib/Util.qm: added parse_to_qore_value() function to the Util
	  module

2013-05-23 15:43  david_nichols

	* qlib/HttpServer.qm, qlib/WebSocketHandler.qm: updates to allow
	  for more flexible handling of web socket connections

2013-05-23 12:57  david_nichols

	* qlib/HttpServer.qm: more loggging improvements; include handler
	  name in log messages; log error responses consistently

2013-05-23 12:15  david_nichols

	* qlib/HttpServer.qm, qlib/Mime.qm: improved HTTP logging with
	  error responses; implemented get_mime_type_from_ext() in the Mime
	  module

2013-05-23 11:31  david_nichols

	* qlib/WebSocketHandler.qm: removed \n from error log msg

2013-05-22 15:50  david_nichols

	* qlib/HttpServer.qm: more logging updates

2013-05-22 11:25  david_nichols

	* qlib/HttpServer.qm: more logging improvements

2013-05-22 11:05  david_nichols

	* qlib/HttpServer.qm: more mimor http logging improvements

2013-05-22 10:55  david_nichols

	* qlib/HttpServer.qm: minor http logging improvement

2013-05-22 09:05  david_nichols

	* qlib/RestHandler.qm: commented out debugging line

2013-05-22 08:35  david_nichols

	* qlib/HttpServer.qm, qlib/Mime.qm, qlib/RestClient.qm,
	  qlib/RestHandler.qm: minor REST, MIME, and HTTP updates

2013-05-22 08:25  david_nichols

	* qlib/Pop3Client.qm: Pop3Client module: uncommented the
	  "connected" debug message; updated version to 1.2

2013-05-21 16:37  david_nichols

	* qlib/SqlUtil.qm: drop all unneeded indexes and constraints before
	  aligning columns when executing table alignment

2013-05-21 11:33  david_nichols

	* qlib/HttpServer.qm, qlib/RestHandler.qm: HTTP logging
	  improvements; rest fixes

2013-05-21 07:15  david_nichols

	* qlib/RestClient.qm, qlib/RestHandler.qm: minor rest fixes; for
	  convenience, make sure that the msg body is reflected in the
	  arguments if there are no uri args and the body is a hash

2013-05-20 18:20  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreHTTPClient.h, lib/QC_HTTPClient.qpp,
	  lib/QoreHTTPClient.cpp, qlib/RestClient.qm: http and rest client
	  fixes and improvements

2013-05-20 14:47  david_nichols

	* lib/ql_time.qpp, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: doc
	  updates

2013-05-20 14:13  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: doc updates

2013-05-17 15:55  david_nichols

	* include/qore/intern/qore_program_private.h, lib/QoreProgram.cpp,
	  lib/qore-main.cpp: address some race conditions with Program
	  shutdown and clearing thread-local data

2013-05-17 15:02  david_nichols

	* qlib/SqlUtil.qm: fixed *Table::update() methods

2013-05-17 13:02  david_nichols

	* qlib/SqlUtil.qm: fixed join options for join on partition for
	  oracle

2013-05-17 12:02  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: implemented support for
	  selecting from a partition and joining on a partition on oracle

2013-05-17 10:54  david_nichols

	* qlib/OracleSqlUtil.qm: fixed a bug handling partitioned tables in
	  oracle

2013-05-17 09:11  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/qore-main.cpp:
	  initialize static openssl crypto locks for multi-threaded openssl
	  library access; without this crashes can result (for example in
	  error queue management)

2013-05-16 13:17  david_nichols

	* qlib/SqlUtil.qm: doc updates

2013-05-16 13:13  david_nichols

	* qlib/SqlUtil.qm: doc updates and minor parameter fixes

2013-05-16 12:34  david_nichols

	* examples/sqlutil, qlib/SqlUtil.qm: *Table::insertFrom*() and
	  *Table::upsertFrom*() API updates; implemented commit windows;
	  major doc updates

2013-05-16 08:26  david_nichols

	* examples/sqlutil, qlib/OracleSqlUtil.qm: sqlutil: allow table
	  alignment to be performed from glob-like wildcards
	  OracleSqlUtil: list tables available through synonyms

2013-05-16 08:11  david_nichols

	* qlib/OracleSqlUtil.qm: use "keep index" when dropping the primary
	  key constraint to ensure that indexes are maintained for
	  consistency's sake

2013-05-16 04:36  david_nichols

	* qlib/OracleSqlUtil.qm: fixed a bug creating column comments

2013-05-15 15:01  david_nichols

	* examples/sqlutil: callback updates

2013-05-15 14:32  david_nichols

	* examples/sqlutil, qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: fixed
	  oracle number column handling with no precision given;
	  implemented "UpsertAuto" as the default upsert method - if the
	  target table is empty then UpsertInsertFirst is used, otherwise
	  UpsertSelectFirst; added new options to sqlutil to allow for
	  synchronizing table structures and data between databases

2013-05-15 13:14  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QC_FileLineIterator.qpp, qlib/CsvUtil.qm: fixed many bugs in
	  CsvUtil, doc updates

2013-05-15 12:04  david_nichols

	* include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreObjectIntern.h, lib/QoreClass.cpp,
	  lib/QoreObject.cpp: fixed a bug where private members of a common
	  base class were not accessible by objects of subclasses sharing
	  the common base class

2013-05-15 07:02  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: made info callback
	  programmatic / removed ok callback and merged functionality into
	  info_callback

2013-05-15 04:45  david_nichols

	* qlib/SqlUtil.qm: implemented support for the "ok_callback" for
	  feedback when nothing is changed (for long-running alignment
	  actions)

2013-05-14 17:35  david_nichols

	* qlib/WebSocketHandler.qm: close the connection on socket errors
	  in recvui instead of continuiing indefinitely

2013-05-14 12:45  david_nichols

	* doxygen/qdx, qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: doc updates

2013-05-14 11:37  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/SqlUtil.qm: doc updates; removed
	  support for check constraints in mysql since they are not
	  supported

2013-05-14 04:45  david_nichols

	* qlib/SqlUtil.qm: doc updates and minor corrections

2013-05-13 19:35  david_nichols

	* qlib/SqlUtil.qm: doc fixes and fixes for new insert from iterator
	  methods

2013-05-13 16:16  david_nichols

	* qlib/SqlUtil.qm: implemented *Table::insertFromIterator*()
	  methods

2013-05-13 12:49  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: doc
	  updates, added the selectRow() method to the *Table classes

2013-05-13 09:34  david_nichols

	* doxygen/lang/155_data_type_declarations.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreTypeInfo.h, qlib/OracleSqlUtil.qm,
	  qlib/SqlUtil.qm: - updated "or nothing" types to map NULL ->
	  NOTHING
	  - SqlUtil doc updates and corrections

2013-05-11 19:40  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/SqlUtil.qm: mysql updates to handle
	  auto_increment columns

2013-05-11 14:34  david_nichols

	* examples/schema, qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/SqlUtil.qm: minor bug fixes, doc updates, added a "pk" flag
	  to MysqlNumericColumn as progress on supporting auto_increment
	  columns, do not create the primary key constraint if there is an
	  auto_increment column with the "primary key" tag (indexes and
	  unique constraints not handled yet)

2013-05-10 15:22  david_nichols

	* qlib/SqlUtil.qm: commented-out debugging lines

2013-05-10 14:44  david_nichols

	* qlib/OracleSqlUtil.qm: fixed oracle package alignment / equality
	  check

2013-05-10 06:41  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  minor additional functionality, doc updates, and fixed 2 typos

2013-05-09 15:23  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, examples/schema,
	  lib/QC_AbstractDatasource.qpp, qlib/MysqlSqlUtil.qm: added
	  "schema" example, implemented auto_increment handling for mysql,
	  added getConfigString() and getConfigHash() abstract methods to
	  AbstractDatasource

2013-05-09 15:00  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: implemented sequence
	  emulation for mysql; added a new *Datasource method:
	  getNextSequenceValue()

2013-05-08 19:36  david_nichols

	* qlib/SqlUtil.qm: implemented joins on tables other than the main
	  table

2013-05-08 18:06  david_nichols

	* qlib/SqlUtil.qm: implemented support for "OR" logic in where
	  clauses

2013-05-08 11:36  david_nichols

	* lib/QC_Condition.qpp, qlib/SmtpClient.qm: doc updates

2013-05-07 17:12  david_nichols

	* qlib/SqlUtil.qm: doc updates; fixed Database::makeTable() method

2013-05-07 15:36  david_nichols

	* qlib/SqlUtil.qm: major doc updates; some minor new functionality
	  in SqlUtil

2013-05-07 12:41  david_nichols

	* qlib/SqlUtil.qm: major doc updates; added new function for batch
	  "upserting" + optionally deleting data that do not exist

2013-05-07 06:24  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/BackquoteNode.h, lib/BackquoteNode.cpp,
	  lib/ql_misc.qpp: added an optional reference to the backquote()
	  function to return the return code of the program executed

2013-05-06 15:56  david_nichols

	* lib/ql_lib.qpp, lib/ql_misc.qpp: added cross-references to
	  backquote() and system()

2013-05-06 14:34  david_nichols

	* doxygen/lang/120_modules.dox.tmpl, qlib/SqlUtil.qm: many doc
	  updates

2013-05-06 12:16  david_nichols

	* include/qore/QoreSocket.h, include/qore/intern/QC_Socket.h,
	  lib/QC_Socket.qpp, lib/QoreSocket.cpp, lib/mySocket.cpp:
	  additional error-handling for select-based socket methods
	  isDataAvailable() and isWriteFinished() to avoid inifinite loops

2013-05-06 06:52  david_nichols

	* lib/QoreSocket.cpp: check for EBADF in select response and mark
	  the socket as closed if found

2013-05-05 22:15  david_nichols

	* qlib/SqlUtil.qm: more schema management and query bug fixes

2013-05-05 21:45  david_nichols

	* qlib/SqlUtil.qm: removed debugging stmts

2013-05-05 21:44  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: updates to rename
	  constraints and references when renaming tables

2013-05-05 14:54  david_nichols

	* qlib/SqlUtil.qm: implemented support for ensted functions with
	  column functions; implemented support for update functions (also
	  for nested update functions); many doc updates

2013-05-05 12:41  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QoreSocket.cpp,
	  qlib/HttpServer.qm: fixed a bug where the wrong error was being
	  returned after a connection reset (remote connection close) in
	  sockets with integer recv*() methods which could in some cases
	  lead to an infinite loop

2013-05-02 20:24  david_nichols

	* qlib/SqlUtil.qm: minor doc updates

2013-05-02 20:06  david_nichols

	* doxygen/qdx, qlib/SqlUtil.qm: more doc updates; ignore/strip html
	  comments <!--.*--> in dox output files to allow for */ in @code
	  blocks like *<!---->/ for example

2013-05-02 12:58  david_nichols

	* qlib/SqlUtil.qm: major doc updates for the SqlUtil module

2013-05-01 20:15  david_nichols

	* qlib/SqlUtil.qm: minor doc update

2013-05-01 20:10  david_nichols

	* doxygen/qdx, qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: fixed a problem parsing $#
	  in qdx; doc updates in *SqlUtil modules

2013-05-01 14:15  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added schema support to PgsqlSqlUtil tables; fixed support for
	  default character values in pgsql columns

2013-05-01 12:29  david_nichols

	* include/qore/intern/QoreClassIntern.h, lib/QoreClass.cpp: more
	  reference fixes for abstract variant management

2013-05-01 12:12  david_nichols

	* lib/QoreClass.cpp: fixed a reference issue with abstract
	  variants; abstract variants can no longer piggyback on the
	  reference from the normal method list entry; each abstract
	  variant must be referenced for the abstract method entry
	  independently

2013-04-30 17:32  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: updated to use better
	  unique constraint <-> index matching to support the situation
	  when aligning a db schema to a template and an unexpected index
	  supports a unique constraint

2013-04-30 13:43  david_nichols

	* qlib/MysqlSqlUtil.qm: more mysql fixes

2013-04-30 13:40  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: mysql fixes

2013-04-30 12:37  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/SqlUtil.qm: more mysql fixes

2013-04-30 11:47  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/SqlUtil.qm: mysql updates

2013-04-30 05:34  david_nichols

	* qlib/MysqlSqlUtil.qm: more mysql progress

2013-04-29 15:24  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/SqlUtil.qm: minor bug fixes

2013-04-29 13:47  david_nichols

	* qlib/MysqlSqlUtil.qm, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: mysql updates; make sure
	  and support explicit schemas for mysql

2013-04-29 08:01  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreNumberNode.h,
	  include/qore/intern/RangeIterator.h, lib/Pseudo_QC_All.qpp,
	  lib/Pseudo_QC_List.qpp, lib/Pseudo_QC_Nothing.qpp,
	  lib/QoreNumberNode.cpp: added the following pseudo-methods:
	  - <list>::rangeIterator()
	  - <nothing>::rangeIterator()
	  - <value>::toNumber()

2013-04-29 05:11  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/RangeIterator.h, lib/QC_RangeIterator.qpp:
	  fixed the RangeIterator class by adding a valid method

2013-04-26 14:55  david_nichols

	* qlib/MysqlSqlUtil.qm: type corrections

2013-04-26 14:26  david_nichols

	* qlib/MysqlSqlUtil.qm: more mysql progress

2013-04-26 13:45  david_nichols

	* qlib/MysqlSqlUtil.qm: more progress on pgsql -> mysql porting

2013-04-26 09:42  david_nichols

	* qlib/MysqlSqlUtil.qm: more porting from pgsql -> mysql

2013-04-26 08:21  david_nichols

	* Makefile.am, qlib/MysqlSqlUtil.qm: added initial prototype
	  MysqlSqlUtil module

2013-04-26 06:55  david_nichols

	* qlib/SqlUtil.qm: initial partially-functional mysql SqlUtil
	  module (only column descriptions ported so far)

2013-04-26 05:50  david_nichols

	* qlib/SqlUtil.qm: added select method, added optional output
	  paramter to SQL methods to optionally return the SQL string
	  generated

2013-04-25 20:20  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: try
	  to automatically rename indexes and constraints when aligning
	  schemas if identical objects are found with different names

2013-04-25 15:15  david_nichols

	* qlib/SqlUtil.qm: make sure and call getColumnsUnlocked() when
	  processing the where clause for any query

2013-04-25 15:08  david_nichols

	* qlib/SqlUtil.qm: make sure and call describe() before trying to
	  access a table's "column" attribute when processing join
	  arguments

2013-04-25 15:03  david_nichols

	* qlib/OracleSqlUtil.qm: fixed descening orderby on Oracle

2013-04-25 14:56  david_nichols

	* qlib/SqlUtil.qm, qlib/WebSocketHandler.qm: commented-out debug
	  msg

2013-04-25 06:57  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm: fixed typos in
	  pseudo-method calls

2013-04-24 18:07  david_nichols

	* qlib/SqlUtil.qm: added additional join verification logic; moved
	  the order of the "alias" argument in join functions to the 2nd
	  position

2013-04-24 17:19  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: added working complex
	  joins with automatic join criteria based on primary keys and
	  foreign key constraints, supports aliases and all column and
	  "where" functions also in the join clause (useful for left and
	  right outer joins)

2013-04-24 16:04  david_nichols

	* include/qore/intern/BarewordNode.h, lib/BarewordNode.cpp,
	  lib/parser.ypp: fixed issues where the source position was not
	  being displayed when bare references could not be resolved

2013-04-24 12:10  david_nichols

	* qlib/SqlUtil.qm: fixed orderby processing in select queries

2013-04-24 11:30  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: fixed issues with
	  "offset" in oracle queries, implemented column operator for "as",
	  fixed using "limit" with "orderby" in selects

2013-04-23 15:13  david_nichols

	* qlib/WebSocketHandler.qm: updated docs

2013-04-23 10:56  david_nichols

	* qlib/OracleSqlUtil.qm: make sure and set oracle columns with
	  nullable = False if there is an enabled but not validated not
	  null constraint on the column

2013-04-23 05:09  david_nichols

	* qlib/HttpServer.qm: fixed parsing uri query args when the
	  argument exists but evaluates to false

2013-04-22 16:06  david_nichols

	* qlib/SqlUtil.qm: align dropPrimaryKey() functionality and docs
	  with getDropPrimaryKeySql()

2013-04-22 15:40  david_nichols

	* include/qore/intern/QoreClassIntern.h, lib/Function.cpp,
	  lib/QoreClass.cpp, qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: fixed
	  additional out-of-order parse initialization issues

2013-04-22 11:49  david_nichols

	* include/qore/intern/QoreClassIntern.h, lib/QoreClass.cpp: fixed
	  another issue with out-of-order parsing

2013-04-22 09:08  david_nichols

	* lib/QoreClass.cpp: fixed parse initialization order regarding
	  finding new concrete variants in parent classes for abstract
	  variants

2013-04-22 08:19  david_nichols

	* qlib/SqlUtil.qm: fixed call to drop trigger

2013-04-21 18:49  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm: fixed base class
	  method calls

2013-04-21 18:02  david_nichols

	* lib/QoreClass.cpp: fixed a bug related to out of order parseing
	  when setting the parse class context when initializing class
	  methods

2013-04-21 16:10  david_nichols

	* include/qore/intern/BarewordNode.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreNamespaceIntern.h, lib/BarewordNode.cpp,
	  lib/QoreClass.cpp, lib/QoreException.cpp, lib/QoreLib.cpp,
	  lib/QoreNamespace.cpp, lib/StatementBlock.cpp: resolved issues
	  with out-of-order parse initialization of class members with
	  closures

2013-04-21 14:10  david_nichols

	* qlib/HttpServer.qm: also include exception handling when calling
	  the stop notification closure when an HTTP listener is shut down

2013-04-21 13:46  david_nichols

	* qlib/HttpServer.qm: handle exceptions when writting to user logs
	  in the listener

2013-04-21 10:14  david_nichols

	* include/qore/intern/ForEachStatement.h,
	  include/qore/intern/LocalVar.h,
	  include/qore/intern/QoreObjectIntern.h,
	  include/qore/intern/VarRefNode.h,
	  include/qore/intern/qore_thread_intern.h, lib/Function.cpp,
	  lib/QoreHashNode.cpp, lib/ReferenceNode.cpp, qlib/SqlUtil.qm:
	  non-functional updates for compile warnings and debugging

2013-04-20 17:28  david_nichols

	* include/qore/intern/VarRefNode.h: additional assert()s for
	  debugging

2013-04-20 17:14  david_nichols

	* include/qore/intern/QoreValue.h: additional assert()s to catch
	  possible memory leaks

2013-04-20 16:14  david_nichols

	* include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreValue.h, lib/QoreHashNode.cpp,
	  lib/QoreSocket.cpp: minor non-functional changes, simplifying
	  internal apis

2013-04-20 14:47  david_nichols

	* qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: use common inherited code
	  for pgsql unique constraints

2013-04-20 14:05  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/QoreClass.h, include/qore/intern/Function.h,
	  include/qore/intern/QoreClassIntern.h, lib/QoreClass.cpp: made it
	  possible to inherit concrete versions of abstract method variants
	  from a parent class, making it easier to share code in a complex
	  multiple inheritance hierarchy

2013-04-19 15:48  david_nichols

	* include/qore/intern/Function.h, include/qore/intern/QC_File.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/qore_program_private.h, lib/BinaryNode.cpp,
	  lib/CallReferenceNode.cpp, lib/Function.cpp,
	  lib/QC_FileLineIterator.qpp, lib/QC_Program.qpp,
	  lib/QC_ReadOnlyFile.qpp, lib/QoreClosureNode.cpp,
	  lib/QoreHashNode.cpp, lib/QoreListNode.cpp, lib/QoreObject.cpp,
	  lib/QoreStringNode.cpp, lib/ReturnStatement.cpp, lib/parser.ypp:
	  fixed most parse option issues with the last commit

2013-04-19 14:26  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: fixed typo

2013-04-19 14:23  david_nichols

	* include/qore/intern/Function.h,
	  include/qore/intern/FunctionCallNode.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreQuestionMarkOperatorNode.h,
	  include/qore/intern/qore_thread_intern.h,
	  lib/AbstractStatement.cpp, lib/CallReferenceNode.cpp,
	  lib/FunctionCallNode.cpp, lib/Operator.cpp, lib/QC_Program.qpp,
	  lib/QoreNamespace.cpp, lib/QoreObject.cpp,
	  lib/StatementBlock.cpp, lib/parser.ypp, lib/ql_misc.qpp,
	  lib/thread.cpp, qlib/HttpServer.qm: fixed sandboxing / protection
	  errors with inehrited code; subclasses inheriting code from a
	  parent class with different parse options would cause the child
	  parse options to be used when running the parent class code which
	  caused errors; now parse options are enforced properly on the
	  block level

2013-04-19 12:02  david_nichols

	* include/qore/intern/AbstractStatement.h, lib/Function.cpp,
	  lib/QoreClass.cpp, lib/StatementBlock.cpp, lib/TryStatement.cpp,
	  lib/VarRefNode.cpp: fixed more bugs where the incorrect source
	  location could be displayed in parse errors when parsing
	  function/method/closure arguments

2013-04-19 10:39  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/parser.ypp: fixed a
	  bug where a non-variable-reference member of an "our" variable
	  declaration list would cause a crash due to passing the incorrect
	  argument in sprintf()

2013-04-19 10:30  subik

	* qlib/RestClient.qm: rest: ereverted application/xml handling

2013-04-19 10:02  subik

	* qlib/RestClient.qm: rest: some servers returns XML as
	  application/xml instead of text/xml

2013-04-18 17:52  david_nichols

	* qlib/SqlUtil.qm: doc updates, new methods, minor fixes, etc

2013-04-18 11:09  david_nichols

	* qlib/HttpServer.qm: stop dedicated socket connections in dynamic
	  handlers when removing the dynamic handler

2013-04-18 10:27  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: added new methods, docs,
	  add oracle optimizer hint when selecting with a limited amount of
	  rows

2013-04-18 07:51  david_nichols

	* Makefile.am, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: implemented
	  operators for where clauses; fixed doc building; fixed pgsql
	  triggers

2013-04-18 06:48  david_nichols

	* qlib/SqlUtil.qm: starting adding support for operators in the
	  where clause

2013-04-17 17:54  david_nichols

	* qlib/SqlUtil.qm: minor fixes and commented out debugging stmts

2013-04-17 14:51  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  many fixes, some enhancements

2013-04-17 14:43  subik

	* doxygen/lang/Doxyfile.tmpl, lib/QC_FileLineIterator.qpp,
	  lib/QC_HashIterator.qpp, lib/QC_HashKeyIterator.qpp,
	  lib/QC_HashKeyReverseIterator.qpp, lib/QC_HashListIterator.qpp,
	  lib/QC_HashListReverseIterator.qpp, lib/QC_HashPairIterator.qpp,
	  lib/QC_HashPairReverseIterator.qpp,
	  lib/QC_HashReverseIterator.qpp, lib/QC_ListHashIterator.qpp,
	  lib/QC_ListHashReverseIterator.qpp, lib/QC_ListIterator.qpp,
	  lib/QC_ListReverseIterator.qpp, lib/QC_ObjectIterator.qpp,
	  lib/QC_ObjectKeyIterator.qpp,
	  lib/QC_ObjectKeyReverseIterator.qpp,
	  lib/QC_ObjectPairIterator.qpp,
	  lib/QC_ObjectPairReverseIterator.qpp,
	  lib/QC_ObjectReverseIterator.qpp, lib/QC_RangeIterator.qpp,
	  lib/QC_SingleValueIterator.qpp: docs: doxyfile updated; basic
	  examples for all iterators

2013-04-16 17:23  david_nichols

	* qlib/SqlUtil.qm: disabled debugging output

2013-04-16 17:22  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  many new methods & fixes

2013-04-15 14:47  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  started adding inter-table schema management infrastructure

2013-04-15 11:23  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  oracle fixes and other minor fixes

2013-04-15 11:22  david_nichols

	* qlib/PgsqlSqlUtil.qm: really fixed foreign constraint column
	  order - have to use original order in array value in pgsql column
	  and not the attribute number

2013-04-15 09:05  david_nichols

	* qlib/PgsqlSqlUtil.qm: fixed column order when retrieving foreign
	  constraints on pgsql

2013-04-15 05:56  david_nichols

	* qlib/SqlUtil.qm: fixed Table::getRowIterator() call + docs

2013-04-15 05:52  david_nichols

	* qlib/HttpServer.qm: commented out debugging statement

2013-04-15 05:33  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  many new methods and fixes

2013-04-12 20:04  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  more abstract table methods

2013-04-11 19:40  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  allow setting a flag to indicate that sql_callbacks actually
	  execute the SQL (so that changes are also effected internally),
	  simplified abstract interface, pgsql foreign constraint fixes,
	  fixed renaming indexes linked to constraints on dbs that forcibly
	  link constraints and indexes (ex: pgsql)

2013-04-10 17:51  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/Function.cpp,
	  lib/ReturnStatement.cpp: fixed a bug related to out-of-order
	  parse initialization for functions and methods which resulted in
	  the wrong return type being returned for a method with more than
	  1 variant where the variant could not be matched at parse time

2013-04-10 13:39  david_nichols

	* lib/FunctionCallNode.cpp, lib/ReturnStatement.cpp,
	  qlib/SqlUtil.qm: misc debugging changes

2013-04-10 12:38  david_nichols

	* qlib/RestHandler.qm: fixed method name calculation when the
	  action is in the msg body

2013-04-10 11:16  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/qore_program_private.h,
	  lib/ReturnStatement.cpp: fixed bugs where parse exceptions and
	  warnings when validating types used with the return statement
	  could be reported at the wrong source location

2013-04-10 05:55  david_nichols

	* qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: drop triggers when
	  dropping trigger functions on pgsql when aligning schemas

2013-04-09 19:19  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  pgsql fixes - fixed constraint renaming, fixed upsert, etc

2013-04-09 15:30  david_nichols

	* qlib/OracleSqlUtil.qm: fixed callbacks for table column comments
	  on oracle

2013-04-09 15:21  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: implemented support for
	  Oracle materialized views

2013-04-09 13:29  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  support for dropping schemas according to a template

2013-04-09 11:27  david_nichols

	* qlib/SqlUtil.qm: make sure and use execRaw() instead of exec()
	  when executing generated SQL

2013-04-09 10:44  david_nichols

	* qlib/SqlUtil.qm: added new *Table methods

2013-04-09 07:23  david_nichols

	* qlib/SqlUtil.qm: doc updates

2013-04-08 19:27  david_nichols

	* qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: upsert fixes and other
	  enhancements

2013-04-08 15:30  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/Pseudo_QC_Hash.qpp,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm, qlib/WebSocketHandler.qm:
	  implemented <hash>::compareKeys(), implemented more generic
	  upsert support minor doc changes

2013-04-08 12:43  david_nichols

	* qlib/WebSocketHandler.qm: fixed unmasking websocket messages
	  received

2013-04-08 12:14  david_nichols

	* lib/QC_Socket.qpp, qlib/HttpServer.qm, qlib/WebSocketHandler.qm:
	  WebSocket support enhancements, doc updates

2013-04-07 20:55  david_nichols

	* qlib/HttpServer.qm, qlib/WebSocketHandler.qm: allow the
	  websockethandler to broadcast events to all connections

2013-04-07 15:52  david_nichols

	* doxygen/lang/180_operators.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/BinaryNode.h, lib/BinaryNode.cpp,
	  lib/Pseudo_QC_Binary.qpp, lib/QoreExtractOperatorNode.cpp,
	  lib/QoreSpliceOperatorNode.cpp, lib/ql_string.qpp,
	  qlib/HttpServer.qm, qlib/WebSocketHandler.qm: implemented support
	  for binary data in the splice and extract operators, implemented
	  variants of substr() that work on binary data, implemented new
	  <binary>::substr() pseudo-methods, fixed a deadlock in shutting
	  down listeners with dedicated socket connections in the
	  HttpServer module; added some support for processing close
	  messages in the WebSocketHandler module

2013-04-06 15:00  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  lib/Pseudo_QC_Binary.qpp, lib/Pseudo_QC_String.qpp,
	  lib/QC_Socket.qpp, lib/QoreSocket.cpp, lib/ql_misc.qpp,
	  qlib/HttpServer.qm, qlib/RestHandler.qm,
	  qlib/WebSocketHandler.qm: - fixed bugs in the integer
	  Socket::recv*() methods where a \c SOCKET-CLOSED exception was
	  not thrown when the remote end closed the connection
	  - added an initial WebSocketHandler module
	  - updated the HttpServer module to allow for dedicated socket
	  handlers (added the AbstractHttpSocketHandler class)
	  - added the following pseudo-methods:
	  - <binary>::toBase64()
	  - <binary>::toHex()
	  - <string>::toBase64()
	  - <string>::toHex()

2013-04-05 16:55  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/Pseudo_QC_Int.qpp:
	  added new pseudo-methods to the <int> pseudo-class: encodeMsb()
	  and encodeLsb()

2013-04-05 15:59  david_nichols

	* qlib/RestHandler.qm: fixed Accept handling (for good this time I
	  hope!)

2013-04-05 15:48  david_nichols

	* qlib/Mime.qm, qlib/RestHandler.qm: fixed RestHandler Accept
	  header handling; uses serialization preference in request order;
	  minor update to the Mime module

2013-04-05 15:01  david_nichols

	* qlib/RestHandler.qm: serialize with json by default

2013-04-05 08:51  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreObjectIntern.h: - fixed a bug where
	  slices could be made of objects from outside the class including
	  private members
	  - fixed a bug where @ref Qore::SQL::SQLStatement::memberGate()
	  "memberGate() methods" were not being respected when taking a
	  slice of an object

2013-04-05 08:45  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  initial single-row "upsert" support

2013-04-04 20:22  david_nichols

	* lib/QoreRegexNode.cpp: fixed regex extract with global flag

2013-04-04 14:40  david_nichols

	* doxygen/lang/185_qore_regex.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreRegexBase.h,
	  include/qore/intern/QoreRegexNode.h, lib/Pseudo_QC_String.qpp,
	  lib/QoreRegexNode.cpp, lib/RegexSubstNode.cpp, lib/ql_string.qpp,
	  lib/scanner.lpp: implemented support for extracting all matches
	  of a pattern in a string with the regex extraction operator,
	  regex_extract(), and <string>::regexExtract() by setting the
	  global flag (/g or by using RE_Global)

2013-04-03 13:30  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added new methods for dropping objects conditional on their
	  existence, improved package support in oracle

2013-04-03 12:11  david_nichols

	* lib/QoreException.cpp: only output a maximum of 10 exception in
	  the default exception handler

2013-04-03 09:23  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added support for oracle types + initial function support, doc
	  updates

2013-04-03 07:42  subik

	* COPYING.GPL, COPYING.LGPL: COPYING.* files updated to the latest
	  content (it fixes rpmlint warnings for outdated FSF address)

2013-04-03 07:33  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: minor updates

2013-04-02 15:55  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  implemented callbacks to allow for summary informtion to be
	  logged while the schema is being updated and to allow for the sql
	  to be executed as it is generated

2013-04-02 14:50  david_nichols

	* lib/Operator.cpp: implicit index operators now work with the map
	  and select operators with lists and iterators

2013-04-02 11:51  david_nichols

	* qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: implemented processing
	  function definition when aligning schemas; implemented better
	  heuristics for matching postgresql functions; the matching
	  algorithm accepts a more flexible function definition syntax

2013-04-02 08:50  david_nichols

	* qlib/PgsqlSqlUtil.qm: added "cascade" option when generating
	  delta SQL for pgsql types

2013-04-02 08:47  david_nichols

	* qlib/PgsqlSqlUtil.qm: removed debugging printf

2013-04-02 08:43  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  implemented support for postgresql types including generating
	  modification SQL for type changes

2013-04-02 06:11  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/StatementBlock.cpp,
	  lib/parser.ypp: fixed a bug where parse exceptions for empty
	  blocks with a missing return statement would be reported at the
	  wrong source location; now an empty StatementBlock structure is
	  saved even with empty blocks just to store the parse location of
	  the block

2013-04-01 20:16  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  fixed makeSequence* arguments

2013-04-01 20:13  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, qlib/OracleSqlUtil.qm,
	  qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: implement support for
	  sequence management with oracle & pgsql

2013-04-01 18:47  david_nichols

	* qlib/RestHandler.qm: fixed Accept header parsing

2013-04-01 18:38  david_nichols

	* lib/QoreClass.cpp: fixed bugs where public members and static
	  variables of privately-inherited classes were incorrectly treated
	  as public attributes of the child class

2013-04-01 15:34  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  fixed constraint <-> index matching when no indexes are present,
	  added initial support for entire schema comparison from a schema
	  description hash

2013-04-01 14:21  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  implemented support for disabling constraints affected by
	  recreating indexes and automatically re-enabling them after the
	  index has been created

2013-03-31 16:43  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  initial updated to support function indexes on oracle and pgsql

2013-03-31 13:32  david_nichols

	* qlib/SqlUtil.qm: when creating tables from table descriptions,
	  set primary key and unique constraints to be based on any indexes
	  with the same name and columns

2013-03-31 12:48  david_nichols

	* qlib/OracleSqlUtil.qm: fixed create + align table options for
	  oracle

2013-03-31 12:37  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: do
	  not drop unique indexes with the same names as primary key and
	  unique constraints when aligning tables; instead set the index
	  name as the base index for the constraint

2013-03-31 12:29  david_nichols

	* lib/FunctionCallNode.cpp: fixed a bug where parse exceptions in
	  base class constructor arguments could be reported at the wrong
	  source location

2013-03-31 09:41  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/Function.h, lib/Function.cpp,
	  lib/QoreClass.cpp, qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm,
	  qlib/SqlUtil.qm: - fixed a bug where a parse-time crash would
	  occur when calling the copy() method for a class that does not
	  implement an explicit copy() method
	  - fixed a bug where arguments passed to a copy method were
	  ignored; now an exception is thrown

2013-03-31 08:35  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QoreDotEvalOperatorNode.cpp: fixed a bug where a parse-time
	  crash would occur when calling the copy() method for a class that
	  does not implement an explicit copy() method

2013-03-31 07:28  david_nichols

	* qlib/PgsqlSqlUtil.qm: set tablespace names in unique and primary
	  key constraints when matching indexes are found; do not register
	  the indexes as they are created automatically on pgsql

2013-03-30 20:38  david_nichols

	* qlib/PgsqlSqlUtil.qm: retrieve unique constraints for pgsql; do
	  not register unique indexes with the same names and columns as
	  unique constraints since creating a unique constraint
	  automatically creates the unique index as well

2013-03-30 19:09  david_nichols

	* qlib/OracleSqlUtil.qm: fixed unique constraint retrieval on
	  oracle

2013-03-30 19:02  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  implemented support for unique constraints - also in table
	  creation from a table hash description

2013-03-30 16:40  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  respect coumn option swhen creating tables based on a description
	  hash, added support for foreign constraints in the description
	  hash, fixed a bug in foreign constraint object creation when
	  created based on db-analysis on oracle

2013-03-30 10:53  david_nichols

	* qlib/PgsqlSqlUtil.qm, scratch/schema: fixed pgsql null/not null
	  column modifications

2013-03-29 15:23  david_nichols

	* qlib/SqlUtil.qm: minor doc update

2013-03-29 15:16  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lib/Doxyfile.tmpl, doxygen/qlib/Doxyfile.tmpl,
	  qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm,
	  scratch/schema: implemented support for creating tables based on
	  a db-independent hash description, fixed SQL table alignment vs a
	  template for pgsql regarding trigger functions, many doc updates

2013-03-29 10:28  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  qlib/PgsqlSqlUtil.qm, qlib/RestHandler.qm, scratch/schema: doc
	  updates, added PgsqlUtil and OracleSqlUtil to doc framework

2013-03-28 16:10  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added "delta-function" support to the Database class

2013-03-28 15:37  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  compare columns, indexes, all constraints, triggers, pgsql
	  functions changed so that the name contains the arguments since
	  pgsql functions are overloaded

2013-03-28 06:20  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  when renaming columns, maintain the key order in in internal data
	  structures, also rename columns in primary key and foreign table
	  constraints, doc updates

2013-03-27 19:01  david_nichols

	* qlib/SqlUtil.qm: also lock template table when aligning tables

2013-03-27 18:48  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  fixed oracle column null/not null modifications, added initial
	  table alignment code (name & columns covered so far - missing
	  constraints, indexes, and table comments, etc)

2013-03-27 16:26  david_nichols

	* qlib/PgsqlSqlUtil.qm: allow trigger functions to be created and
	  stored against the table manually

2013-03-27 15:16  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: fixed trigger and index
	  creation on oracle; fixed adding indexes to a table when no
	  indexes exist; fixed respecting SQL generation options when
	  generating table SQL

2013-03-27 14:10  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  removed disable-warning non-existent-method-call, fixed
	  constraint renaming

2013-03-27 13:56  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  updated AbstractFunction definition to allow for multiple create
	  lines to be returned; implemented support for retrieving oracle
	  packages

2013-03-27 10:31  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  updated to allow for multiple functions/procedures to be returned
	  with the same name (ex: pgsql overloaded functions)

2013-03-27 08:45  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  started adding function and procedure retrieving (not working now
	  for pgsql with overloaded functions)

2013-03-26 18:08  david_nichols

	* qlib/SqlUtil.qm: fixed adding default values

2013-03-26 16:07  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added support for Database methods to list objects

2013-03-26 14:19  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added support for renaming tables, columns, and constraints

2013-03-26 13:12  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  simplified the AbstractColumn implementation, moved comments to
	  the global definition, made subclasses for numeric types, use
	  "size" for precision, "scale" now only in numeric subclasses

2013-03-26 10:27  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  implemented support for modifying columns, fixed column comment
	  support on oracle

2013-03-25 17:50  david_nichols

	* qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: fixed locking errors in
	  sql generation and pgsql trigger handling

2013-03-25 17:36  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  greatly simplified the trigger classes; implemented add and drop
	  trigger methods, starting adding Database infrastructure

2013-03-25 15:29  david_nichols

	* qlib/RestHandler.qm: a 409 Conflict error is returned if an
	  exception occurs, also now it is possible for class handlers to
	  encode the response message directly

2013-03-25 10:56  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added support for dynamically adding check constraints to a Table

2013-03-24 21:29  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  major documentation and API updates, the SqlUtil module contains
	  more common code to make driver-specific modules simpler and
	  easier to write

2013-03-24 16:50  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/SqlUtil.qm: added the
	  dropConstraint() table method, made AbstractPrimaryKey a child of
	  AbstractConstraint, added support for the "compute_statistics"
	  index option on oracle

2013-03-24 16:01  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm,
	  qlib/Util.qm: added support for adding and dropping indexes and
	  foreign key constraints, doc updates

2013-03-24 13:32  david_nichols

	* examples/rest, qlib/HttpServer.qm, qlib/RestHandler.qm: rest
	  updates; minor update in HTTP server for more efficient
	  accept-encoding matches

2013-03-24 07:27  david_nichols

	* examples/rest, examples/restserver.q, lib/QoreHTTPClient.cpp,
	  qlib/HttpServer.qm, qlib/RestClient.qm, qlib/RestHandler.qm:
	  fixed RestClient to not append a "/" to the path; updated
	  RestHandler to add args and body to arg list when looking for
	  subclasses, other minor updates

2013-03-23 16:27  david_nichols

	* qlib/Util.qm: doc updates

2013-03-23 16:21  david_nichols

	* qlib/RestClient.qm: updated RestClient docs

2013-03-23 16:17  david_nichols

	* qlib/RestClient.qm: made reference arguments optional in the
	  RestClient module; added example code in the module's
	  documentation main page

2013-03-23 16:01  david_nichols

	* examples/rest, qlib/RestClient.qm, qlib/RestHandler.qm:
	  RestClient updates, added "rest" example program using the
	  RestClient module

2013-03-22 17:48  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  qlib/RestClient.qm, qlib/RestHandler.qm, qlib/SqlUtil.qm: added
	  RestClient module, added exception handling in RestHandler, fixed
	  content-type in RestHandler responses

2013-03-22 08:17  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  allow SQL to be retrieved when modifying tables; abstract
	  hierarchy updates

2013-03-21 17:12  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  more SqlUtil updates - added primary key functionality

2013-03-21 13:48  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm: new
	  SqlUtil functionality, more efficient interfaces (more code in
	  SqlUtil, less in db-specific modules), Pgsql supports addColumn,
	  insert method implemented

2013-03-20 17:07  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  added additional support for more SQL operations including
	  creating tables, adding and dropping columns, truncating tables,
	  dropping tables, etc

2013-03-20 12:42  david_nichols

	* Makefile.am, lib/scanner.lpp, qlib/OracleSqlUtil.qm,
	  qlib/SqlUtil.qm: allow find() to be used as a function/method
	  name
	  added find() methods to the Table and AbstractTable classes

2013-03-20 10:41  david_nichols

	* qlib/OracleSqlUtil.qm, qlib/PgsqlSqlUtil.qm, qlib/SqlUtil.qm:
	  implemented pluggable API for SqlUtil so specific drivers can be
	  loaded on demand

2013-03-20 10:13  david_nichols

	* qlib/Util.qm: converted the Util module to old style

2013-03-20 09:59  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, qlib/SqlUtil.qm,
	  qlib/Util.qm: added the Util module with some generally useful
	  functions
	  updated SqlUtil to use the Util module for compare_version
	  updated docs

2013-03-20 09:28  david_nichols

	* lib/QoreRegexBase.cpp, lib/scanner.lpp: fixed a bug where it was
	  impossible to output a single '\' character in regex substitution
	  expressions; '\' was taken as an escape character, and '\\' was
	  output literally, now '\\' is output as '\'

2013-03-19 17:30  david_nichols

	* examples/restserver.q, qlib/RestHandler.qm: implemented a working
	  rest example program; fixed support for the DELETE method in the
	  RestHandler; made it possible also to have programmatic top-level
	  rest classes in the RestHandler

2013-03-19 15:35  david_nichols

	* doxygen/lang/120_modules.dox.tmpl, examples/httpserver.q,
	  examples/restserver.q, lib/ql_misc.qpp, lib/ql_object.qpp,
	  qlib/HttpServer.qm, qlib/RestHandler.qm, qlib/SqlUtil.qm: various
	  documentation fixes, starting to add RestHandler docs, added
	  initial non-functional restserver.q example

2013-03-19 14:47  david_nichols

	* examples/sqlutil, qlib/SqlUtil.qm: added support for pgsql
	  trigger functions

2013-03-19 10:49  david_nichols

	* qlib/SqlUtil.qm: starting to add support for pgsql trigger
	  functions

2013-03-19 10:29  david_nichols

	* examples/sqlutil, qlib/SqlUtil.qm: added support for postgresql
	  triggers (currently without trigger functions)

2013-03-19 09:56  david_nichols

	* qlib/SqlUtil.qm: fixed oracle trigger sql generation

2013-03-19 09:23  david_nichols

	* qlib/SqlUtil.qm: implemented support for oracle table triggers

2013-03-19 08:47  david_nichols

	* qlib/SqlUtil.qm: do not retrieve system check constraints on
	  oracle

2013-03-18 14:22  david_nichols

	* qlib/SqlUtil.qm: added check constraint support on oracle with
	  oracle driver >= 3.0

2013-03-17 18:22  david_nichols

	* Makefile.am, qlib/SqlUtil.qm: really added the RestHandler and
	  SqlUtil modules to Makefile, started adding support for oracle
	  constraints

2013-03-17 17:33  david_nichols

	* examples/sqlutil, qlib/SqlUtil.qm: added the RestHandler and
	  SqlUtil user modules to the Makefile for installation and
	  documentation generation, added sqlutil example script

2013-03-17 17:07  david_nichols

	* qlib/SqlUtil.qm: major updates - better postgres support, support
	  for check constraints & column comments, etc

2013-03-16 18:01  david_nichols

	* qlib/SqlUtil.qm: added infrastructure to generate sql for primary
	  keys and indexes - other fixes

2013-03-16 12:32  david_nichols

	* qlib/SqlUtil.qm: added initial support for generate "create
	  table" sql from Table objects

2013-03-16 10:15  david_nichols

	* qlib/SqlUtil.qm: retrieve comments on oracle tables and columns

2013-03-16 10:03  david_nichols

	* qlib/SqlUtil.qm: oracle tables work with an explicit schema name

2013-03-16 07:31  david_nichols

	* qlib/SqlUtil.qm: update to allow OracleTable to work with
	  DatasourcePool objects (where there is no open() method) and to
	  use the data_size for number columns without a precision

2013-03-16 06:48  david_nichols

	* qlib/SqlUtil.qm: added getSchemaName() method to OracleTable

2013-03-16 06:47  david_nichols

	* qlib/SqlUtil.qm: updated oracle tables to recognize and work with
	  synonyms and store the schema owner of the table as well

2013-03-14 13:40  david_nichols

	* qlib/SqlUtil.qm: implemented the "native-case" option and by
	  default all db object names are reported in lower-case to remain
	  compatible with DB drivers (ex: column names are returned in
	  lower case by all drivers)

2013-03-14 12:53  david_nichols

	* lib/QC_AbstractSmartLock.qpp: corrected example for
	  AbstractSmartLock::lockOwner()

2013-03-13 19:14  david_nichols

	* Makefile.am, doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QoreSocket.cpp, qlib/RestHandler.qm: + really fixed the bug
	  thought to be fixed in 0.8.7 "where SSL errors would cause the
	  affected thread to go into a infinite loop using 100% CPU" - this
	  turned out to be easily reproducible on all platforms; when the
	  SSL connection was shut down cleanly by the remote end before a
	  response message was returned, an infinite loop would result
	  + fixed processing of requests without any Accept: header in the
	  RestHandler module

2013-03-13 14:55  david_nichols

	* qlib/SqlUtil.qm: updated to allow for tables with no indexes or
	  constraints

2013-03-13 11:48  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreNamespaceIntern.h,
	  include/qore/intern/VarRefNode.h, lib/QoreNamespace.cpp,
	  lib/VarRefNode.cpp: fixed a bug where parse exceptions resolving
	  global variables could be reported at the wrong source location

2013-03-12 18:07  david_nichols

	* include/qore/intern/QoreClassIntern.h, lib/QoreClass.cpp,
	  qlib/RestHandler.qm: fixed a regression with abstract method
	  handling where it was possible under some circumstances to
	  instantiate a class with unimplemented inherited abstract methods
	  updated the AbstractRestClass class to have a concrete
	  implementation of subClass() that returns NOTHING by default in
	  the RestHandler module

2013-03-11 15:11  david_nichols

	* qlib/RestHandler.qm: if there is no message body then copy the
	  URI args to the body

2013-03-11 15:11  david_nichols

	* qlib/HttpServer.qm: cosmetic/formatting changes

2013-03-11 14:50  david_nichols

	* qlib/RestHandler.qm: log headers and body received as debug
	  messages

2013-03-11 14:25  david_nichols

	* qlib/RestHandler.qm: updated the RestHandler to use the action
	  also given in any message body deserialized as a hash

2013-03-11 14:22  david_nichols

	* qlib/HttpServer.qm, qlib/RestHandler.qm: HttpServer: fixed
	  handler matching to use a score for each handler and to check
	  dynamic handlers also for a match if the fixed handlers don't
	  provide a perfect match
	  RestHandler: fixed deserialization of request bodies (was broken
	  due to type errors)

2013-03-11 13:10  david_nichols

	* qlib/HttpServer.qm: oops- include message body when calling
	  handlers

2013-03-11 13:00  david_nichols

	* qlib/HttpServer.qm: added "PUT" method

2013-03-11 12:59  david_nichols

	* qlib/HttpServer.qm: really implemented the PUT and DELETE methods
	  and optional bodies for all methods

2013-03-11 12:37  david_nichols

	* qlib/HttpServer.qm: added support for the PUT and DELETE methods
	  and for optional message bodies independent of the HTTP method

2013-03-11 10:17  david_nichols

	* qlib/RestHandler.qm: changed getSubClass() to subClass() to
	  eliminate automatically calling that function with a URI like
	  ...?action=subClass
	  which would result in an error

2013-03-11 09:56  david_nichols

	* qlib/RestHandler.qm: updated to allow message bodies deserialized
	  as hashes with non-GET requests to be merged with the URI
	  parameters to support lazy clients that pass arguments in the URI
	  with PUT & POST

2013-03-11 09:38  david_nichols

	* qlib/SqlUtil.qm: oracle & pgsql updates and fixes

2013-03-09 21:02  david_nichols

	* qlib/SqlUtil.qm: added char_size Column attribute to give the
	  size in characters

2013-03-09 20:48  david_nichols

	* qlib/SqlUtil.qm: implemented the Table class wrapping the
	  AbstractTable hierarchy

2013-03-09 13:56  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/Function.h,
	  include/qore/intern/FunctionCallNode.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/VarRefNode.h, lib/Function.cpp,
	  lib/FunctionCallNode.cpp, lib/QoreClass.cpp, lib/VarRefNode.cpp,
	  lib/parser.ypp, lib/ql_object.qpp, lib/support.cpp: added the
	  call_pseudo_args() function
	  fixed a bug where the parse location was shown incorrectly for
	  some type errors matching arguments to parameter types

2013-03-09 13:55  david_nichols

	* qlib/SqlUtil.qm: updated the SqlUtil class to use well-defined
	  objects as return types; mysql and sqllite3 are commented out for
	  now...

2013-03-08 14:38  david_nichols

	* qlib/RestHandler.qm: ensure that there is always a response body
	  even if the REST method did not return one (return "OK" in case
	  no response was returned by the REST method)

2013-03-08 10:09  david_nichols

	* qlib/RestHandler.qm: renamed the abstract getName() method to
	  name() since getName() would also be called with a GET
	  "...?action=name" request and would result in an HTTP error due
	  to the incompatible return type

2013-03-07 17:14  david_nichols

	* qlib/RestHandler.qm: added a public block in the
	  AbstractRestClass definition to catch typos in member names in
	  derived classes

2013-03-07 13:01  david_nichols

	* qlib/HttpServer.qm, qlib/RestHandler.qm: fixed URI parameter
	  parsing in RestHandler; fixed parse_uri_query() to accept both
	  "&" and ";" as argument separators; recognize Accept: */* as
	  meaning that all encodings in the response are accept for
	  serializing the response body

2013-03-07 11:17  david_nichols

	* qlib/RestHandler.qm: updated RestHandler implementation to allow
	  for generic class hierarchies, eliminated the AbstractRestObject
	  class; everything is a class and now classes can be stacked in
	  arbitrary hierarchies, corrected error handling, added message
	  body deserialization support

2013-03-07 10:27  david_nichols

	* qlib/RestHandler.qm: removed code requiring an argument for a
	  rest on a REST object

2013-03-07 10:15  temnor

	* qlib/RestHandler.qm: Action arg should be optional

2013-03-06 18:35  david_nichols

	* qlib/RestHandler.qm: fixed bug in rest call dispatching

2013-03-06 16:07  david_nichols

	* qlib/HttpServer.qm: minor update to argument parsing in
	  parse_uri_query()

2013-03-06 16:04  david_nichols

	* qlib/RestHandler.qm: simplified argument handling for RestHandler

2013-03-06 15:44  david_nichols

	* qlib/RestHandler.qm: fixed dispatching with no arguments

2013-03-06 15:43  david_nichols

	* qlib/RestHandler.qm: updated RestHandler to support HTTP methods
	  directly on rest class objects, no more "default action" for
	  classes

2013-03-06 13:16  david_nichols

	* qlib/RestHandler.qm: implemented support default actions for REST
	  classes

2013-03-06 13:05  subik

	* qlib/SqlUtil.qm: SqlUtils: table desc for sqlite3

2013-03-06 13:02  david_nichols

	* qlib/RestHandler.qm: made the RestHandler module easier to use to
	  implement REST services

2013-03-05 21:04  david_nichols

	* qlib/RestHandler.qm: added initial RestHandler user module

2013-03-05 17:11  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: updated release notes

2013-03-05 17:09  david_nichols

	* qlib/HttpServer.qm: fixed a bug in parsing argument in
	  parse_uri_query()

2013-03-05 15:15  david_nichols

	* qlib/CsvUtil.qm, qlib/HttpServer.qm, qlib/MailMessage.qm,
	  qlib/Mime.qm, qlib/Pop3Client.qm, qlib/SmtpClient.qm,
	  qlib/SqlUtil.qm, qlib/TelnetClient.qm: updated copyright
	  statements

2013-03-05 14:39  david_nichols

	* qlib/SqlUtil.qm: added support for PostgreSQL table descriptions

2013-03-04 16:45  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/Datasource.h, include/qore/ModuleManager.h,
	  include/qore/intern/DatasourcePool.h, lib/Datasource.cpp,
	  lib/DatasourcePool.cpp, lib/Makefile.am, lib/ModuleManager.cpp,
	  lib/QC_Datasource.qpp, lib/QC_DatasourcePool.qpp, qore.spec: -
	  new Datasource and DatasourcePool methods:
	  - Qore::SQL::Datasource::getConfigHash()
	  - Qore::SQL::Datasource::getConfigString()
	  - Qore::SQL::DatasourcePool::getConfigHash()
	  - Qore::SQL::DatasourcePool::getConfigString()
	  - updated library API and module API

2013-03-04 15:06  david_nichols

	* qlib/SqlUtil.qm: added initial SqlUtil user module

2013-03-04 12:35  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QoreClass.cpp: Fixed
	  method resolution order; it's now possible to call pseudo-methods
	  directly on classes that implement methodGate() methods

2013-03-04 12:14  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreNamespaceIntern.h, lib/QoreNamespace.cpp,
	  lib/parser.ypp: fixed a parser bug where out-of-line class method
	  definitions could not be defined in a namespace block

2013-03-04 09:50  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreClassIntern.h, lib/QoreClass.cpp: fixed a
	  bug where classes with unimplemented inherited abstract variants
	  would sometimes cause runtime exceptions to be thrown when
	  instantiated but should have instead been caught at parse time

2013-03-02 06:25  david_nichols

	* include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreQuestionMarkOperatorNode.h,
	  lib/Operator.cpp, lib/parser.ypp: fixed the new ?: operator
	  implementation to report side effects properly at parse time

2013-03-01 12:31  david_nichols

	* Makefile.am, doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreOperatorNode.h,
	  include/qore/intern/QoreQuestionMarkOperatorNode.h,
	  lib/Operator.cpp, lib/parser.ypp: fixed a bug where the ?:
	  operator could thrown spurious exceptions when parsing because it
	  would return the type of the initial boolean expression as the
	  return type of the operator

2013-02-27 09:32  david_nichols

	* include/qore/intern/ThreadResourceList.h,
	  include/qore/qore_thread.h, lib/ThreadResourceList.cpp,
	  lib/thread.cpp: removed unimplemented thread resource IDs, added
	  new check_thread_resource() API

2013-02-24 21:19  david_nichols

	* configure.ac, qore.spec: updated to 0.8.8

2013-02-24 21:14  david_nichols

	* ChangeLog, README-BINARIES: updated binary URL

2013-02-24 20:40  david_nichols

	* doxygen/pdox: added filters to work with tex output from older
	  doxygen versions

2013-02-24 15:29  david_nichols

	* qlib/SmtpClient.qm: use get_ex_pos() to display exception info

2013-02-24 15:28  david_nichols

	* doxygen/lang/155_data_type_declarations.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, lib/ql_misc.qpp,
	  qlib/HttpServer.qm: added the get_ex_pos() function

2013-02-22 19:18  david_nichols

	* lib/qore-main.cpp, lib/thread.cpp: removed debugging printfs
	  accidentally committed

2013-02-22 17:58  david_nichols

	* lib/qore-main.cpp, lib/thread.cpp: minor updates

2013-02-22 16:09  david_nichols

	* lib/thread.cpp: disabled unused function

2013-02-22 16:07  david_nichols

	* command-line.cpp, include/qore/AbstractPrivateData.h,
	  include/qore/AbstractQoreNode.h,
	  include/qore/AbstractThreadResource.h, include/qore/AutoVLock.h,
	  include/qore/BinaryNode.h, include/qore/BuiltinFunctionList.h,
	  include/qore/CallReferenceNode.h, include/qore/DBI.h,
	  include/qore/Datasource.h, include/qore/DateTime.h,
	  include/qore/DateTimeNode.h, include/qore/ExceptionSink.h,
	  include/qore/ModuleManager.h, include/qore/ParseOptionMap.h,
	  include/qore/Qore.h, include/qore/QoreBigIntNode.h,
	  include/qore/QoreBoolNode.h, include/qore/QoreClass.h,
	  include/qore/QoreCondition.h, include/qore/QoreCounter.h,
	  include/qore/QoreEncoding.h, include/qore/QoreEvents.h,
	  include/qore/QoreFile.h, include/qore/QoreFloatNode.h,
	  include/qore/QoreFtpClient.h, include/qore/QoreHTTPClient.h,
	  include/qore/QoreHashNode.h, include/qore/QoreLib.h,
	  include/qore/QoreListNode.h, include/qore/QoreNamespace.h,
	  include/qore/QoreNet.h,
	  include/qore/QoreNodeEvalOptionalRefHolder.h,
	  include/qore/QoreNothingNode.h, include/qore/QoreNullNode.h,
	  include/qore/QoreNumberNode.h, include/qore/QoreObject.h,
	  include/qore/QoreProgram.h, include/qore/QoreQueueHelper.h,
	  include/qore/QoreRWLock.h, include/qore/QoreReferenceCounter.h,
	  include/qore/QoreSSLBase.h, include/qore/QoreSSLCertificate.h,
	  include/qore/QoreSSLPrivateKey.h, include/qore/QoreSocket.h,
	  include/qore/QoreString.h, include/qore/QoreStringNode.h,
	  include/qore/QoreThreadLocalStorage.h,
	  include/qore/QoreThreadLock.h, include/qore/QoreType.h,
	  include/qore/QoreTypeSafeReferenceHelper.h,
	  include/qore/QoreURL.h, include/qore/ReferenceArgumentHelper.h,
	  include/qore/ReferenceHolder.h, include/qore/ReferenceNode.h,
	  include/qore/Restrictions.h, include/qore/SQLStatement.h,
	  include/qore/SystemEnvironment.h, include/qore/common.h,
	  include/qore/intern/AbstractIteratorHelper.h,
	  include/qore/intern/AbstractSmartLock.h,
	  include/qore/intern/AbstractStatement.h,
	  include/qore/intern/BackquoteNode.h,
	  include/qore/intern/BarewordNode.h,
	  include/qore/intern/BreakStatement.h,
	  include/qore/intern/BuiltinFunction.h,
	  include/qore/intern/CallReferenceCallNode.h,
	  include/qore/intern/CallReferenceNode.h,
	  include/qore/intern/CaseNodeRegex.h,
	  include/qore/intern/CaseNodeWithOperator.h,
	  include/qore/intern/ClassRefNode.h,
	  include/qore/intern/ComplexContextrefNode.h,
	  include/qore/intern/ConstantList.h,
	  include/qore/intern/Context.h,
	  include/qore/intern/ContextRowNode.h,
	  include/qore/intern/ContextStatement.h,
	  include/qore/intern/ContextrefNode.h,
	  include/qore/intern/ContinueStatement.h,
	  include/qore/intern/DatasourcePool.h,
	  include/qore/intern/DatasourceStatementHelper.h,
	  include/qore/intern/DoWhileStatement.h,
	  include/qore/intern/ExecArgList.h,
	  include/qore/intern/ExpressionStatement.h,
	  include/qore/intern/FindNode.h,
	  include/qore/intern/ForEachStatement.h,
	  include/qore/intern/ForStatement.h,
	  include/qore/intern/Function.h,
	  include/qore/intern/FunctionCallNode.h,
	  include/qore/intern/FunctionList.h,
	  include/qore/intern/GlobalVariableList.h,
	  include/qore/intern/IfStatement.h,
	  include/qore/intern/LocalVar.h,
	  include/qore/intern/ManagedDatasource.h,
	  include/qore/intern/ModuleInfo.h,
	  include/qore/intern/NamedScope.h,
	  include/qore/intern/ObjectMethodReferenceNode.h,
	  include/qore/intern/OnBlockExitStatement.h,
	  include/qore/intern/Operator.h, include/qore/intern/ParseNode.h,
	  include/qore/intern/ParseReferenceNode.h,
	  include/qore/intern/ParserSupport.h,
	  include/qore/intern/QC_AbstractSmartLock.h,
	  include/qore/intern/QC_AutoGate.h,
	  include/qore/intern/QC_AutoLock.h,
	  include/qore/intern/QC_AutoReadLock.h,
	  include/qore/intern/QC_AutoWriteLock.h,
	  include/qore/intern/QC_Condition.h,
	  include/qore/intern/QC_Counter.h,
	  include/qore/intern/QC_Datasource.h,
	  include/qore/intern/QC_DatasourcePool.h,
	  include/qore/intern/QC_Dir.h, include/qore/intern/QC_File.h,
	  include/qore/intern/QC_FtpClient.h,
	  include/qore/intern/QC_Gate.h, include/qore/intern/QC_GetOpt.h,
	  include/qore/intern/QC_HTTPClient.h,
	  include/qore/intern/QC_Mutex.h, include/qore/intern/QC_Program.h,
	  include/qore/intern/QC_Query.h, include/qore/intern/QC_Queue.h,
	  include/qore/intern/QC_RWLock.h,
	  include/qore/intern/QC_SQLStatement.h,
	  include/qore/intern/QC_SSLCertificate.h,
	  include/qore/intern/QC_SSLPrivateKey.h,
	  include/qore/intern/QC_Sequence.h,
	  include/qore/intern/QC_Socket.h,
	  include/qore/intern/QC_TermIOS.h,
	  include/qore/intern/QC_TimeZone.h,
	  include/qore/intern/QException.h,
	  include/qore/intern/QoreAndEqualsOperatorNode.h,
	  include/qore/intern/QoreAssignmentOperatorNode.h,
	  include/qore/intern/QoreBinaryLValueOperatorNode.h,
	  include/qore/intern/QoreCastOperatorNode.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreClassList.h,
	  include/qore/intern/QoreClosureNode.h,
	  include/qore/intern/QoreClosureParseNode.h,
	  include/qore/intern/QoreDeleteOperatorNode.h,
	  include/qore/intern/QoreDir.h,
	  include/qore/intern/QoreDivideEqualsOperatorNode.h,
	  include/qore/intern/QoreDotEvalOperatorNode.h,
	  include/qore/intern/QoreException.h,
	  include/qore/intern/QoreExtractOperatorNode.h,
	  include/qore/intern/QoreGetOpt.h,
	  include/qore/intern/QoreHashIterator.h,
	  include/qore/intern/QoreHashListIterator.h,
	  include/qore/intern/QoreHashNodeIntern.h,
	  include/qore/intern/QoreImplicitArgumentNode.h,
	  include/qore/intern/QoreImplicitElementNode.h,
	  include/qore/intern/QoreIntAssignmentOperatorNode.h,
	  include/qore/intern/QoreIntMinusEqualsOperatorNode.h,
	  include/qore/intern/QoreIntPlusEqualsOperatorNode.h,
	  include/qore/intern/QoreIntPostDecrementOperatorNode.h,
	  include/qore/intern/QoreIntPostIncrementOperatorNode.h,
	  include/qore/intern/QoreIntPreDecrementOperatorNode.h,
	  include/qore/intern/QoreIntPreIncrementOperatorNode.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreListHashIterator.h,
	  include/qore/intern/QoreListIterator.h,
	  include/qore/intern/QoreLogicalEqualsOperatorNode.h,
	  include/qore/intern/QoreLogicalGreaterThanOperatorNode.h,
	  include/qore/intern/QoreLogicalGreaterThanOrEqualsOperatorNode.h,
	  include/qore/intern/QoreLogicalLessThanOperatorNode.h,
	  include/qore/intern/QoreLogicalLessThanOrEqualsOperatorNode.h,
	  include/qore/intern/QoreLogicalNotEqualsOperatorNode.h,
	  include/qore/intern/QoreMinusEqualsOperatorNode.h,
	  include/qore/intern/QoreModuloEqualsOperatorNode.h,
	  include/qore/intern/QoreMultiplyEqualsOperatorNode.h,
	  include/qore/intern/QoreNamespaceIntern.h,
	  include/qore/intern/QoreNamespaceList.h,
	  include/qore/intern/QoreObjectIntern.h,
	  include/qore/intern/QoreObjectIterator.h,
	  include/qore/intern/QoreOperatorNode.h,
	  include/qore/intern/QoreOrEqualsOperatorNode.h,
	  include/qore/intern/QorePlusEqualsOperatorNode.h,
	  include/qore/intern/QorePostDecrementOperatorNode.h,
	  include/qore/intern/QorePostIncrementOperatorNode.h,
	  include/qore/intern/QorePreDecrementOperatorNode.h,
	  include/qore/intern/QorePreIncrementOperatorNode.h,
	  include/qore/intern/QorePseudoMethods.h,
	  include/qore/intern/QoreQueue.h,
	  include/qore/intern/QoreRegexBase.h,
	  include/qore/intern/QoreRegexNode.h,
	  include/qore/intern/QoreRemoveOperatorNode.h,
	  include/qore/intern/QoreSQLStatement.h,
	  include/qore/intern/QoreSSLIntern.h,
	  include/qore/intern/QoreShiftLeftEqualsOperatorNode.h,
	  include/qore/intern/QoreShiftRightEqualsOperatorNode.h,
	  include/qore/intern/QoreSignal.h,
	  include/qore/intern/QoreSpliceOperatorNode.h,
	  include/qore/intern/QoreThreadList.h,
	  include/qore/intern/QoreTimeZoneManager.h,
	  include/qore/intern/QoreTreeNode.h,
	  include/qore/intern/QoreTypeInfo.h,
	  include/qore/intern/QoreUnaryMinusOperatorNode.h,
	  include/qore/intern/QoreValue.h,
	  include/qore/intern/QoreXorEqualsOperatorNode.h,
	  include/qore/intern/RWLock.h,
	  include/qore/intern/RangeIterator.h,
	  include/qore/intern/ReferenceHelper.h,
	  include/qore/intern/RegexSubstNode.h,
	  include/qore/intern/RegexTransNode.h,
	  include/qore/intern/RethrowStatement.h,
	  include/qore/intern/ReturnStatement.h,
	  include/qore/intern/SSLSocketHelper.h,
	  include/qore/intern/ScopedObjectCallNode.h,
	  include/qore/intern/ScopedRefNode.h,
	  include/qore/intern/SelfVarrefNode.h,
	  include/qore/intern/Sequence.h,
	  include/qore/intern/SingleValueIterator.h,
	  include/qore/intern/SmartMutex.h,
	  include/qore/intern/StatementBlock.h,
	  include/qore/intern/StaticClassVarRefNode.h,
	  include/qore/intern/SummarizeStatement.h,
	  include/qore/intern/SwitchStatement.h,
	  include/qore/intern/ThreadExitStatement.h,
	  include/qore/intern/ThreadResourceList.h,
	  include/qore/intern/ThrowStatement.h,
	  include/qore/intern/TryStatement.h, include/qore/intern/VLock.h,
	  include/qore/intern/VRMutex.h, include/qore/intern/VarRefNode.h,
	  include/qore/intern/Variable.h,
	  include/qore/intern/WhileStatement.h,
	  include/qore/intern/config.h, include/qore/intern/glob.h,
	  include/qore/intern/inline_printf.h,
	  include/qore/intern/ql_compression.h,
	  include/qore/intern/ql_crypto.h, include/qore/intern/ql_debug.h,
	  include/qore/intern/ql_env.h, include/qore/intern/ql_file.h,
	  include/qore/intern/ql_lib.h, include/qore/intern/ql_list.h,
	  include/qore/intern/ql_math.h, include/qore/intern/ql_misc.h,
	  include/qore/intern/ql_object.h, include/qore/intern/ql_pwd.h,
	  include/qore/intern/ql_string.h, include/qore/intern/ql_thread.h,
	  include/qore/intern/ql_time.h, include/qore/intern/ql_type.h,
	  include/qore/intern/qore_date_private.h,
	  include/qore/intern/qore_dbi_private.h,
	  include/qore/intern/qore_ds_private.h,
	  include/qore/intern/qore_number_private.h,
	  include/qore/intern/qore_program_private.h,
	  include/qore/intern/qore_string_private.h,
	  include/qore/intern/qore_thread_intern.h,
	  include/qore/intern/sql_statement_private.h,
	  include/qore/intern/ssl_constants.h,
	  include/qore/intern/win32-config.h, include/qore/macros-i386.h,
	  include/qore/macros-ia64.h, include/qore/macros-none.h,
	  include/qore/macros-powerpc.h, include/qore/macros-x86_64.h,
	  include/qore/node_types.h, include/qore/params.h,
	  include/qore/qore_bitopts.h, include/qore/qore_thread.h,
	  include/qore/safe_dslist, include/qore/support.h,
	  lib/AbstractQoreNode.cpp, lib/AbstractSmartLock.cpp,
	  lib/AbstractStatement.cpp, lib/BackquoteNode.cpp,
	  lib/BarewordNode.cpp, lib/BinaryNode.cpp,
	  lib/BuiltinFunctionList.cpp, lib/CallReferenceNode.cpp,
	  lib/CallStack.cpp, lib/ClassRefNode.cpp,
	  lib/ComplexContextrefNode.cpp, lib/ConstantList.cpp,
	  lib/Context.cpp, lib/ContextRowNode.cpp,
	  lib/ContextStatement.cpp, lib/ContextrefNode.cpp, lib/DBI.cpp,
	  lib/Datasource.cpp, lib/DatasourcePool.cpp, lib/DateTime.cpp,
	  lib/DateTimeNode.cpp, lib/DoWhileStatement.cpp,
	  lib/ExceptionSink.cpp, lib/ExecArgList.cpp,
	  lib/ExpressionStatement.cpp, lib/FindNode.cpp,
	  lib/ForEachStatement.cpp, lib/ForStatement.cpp, lib/Function.cpp,
	  lib/FunctionCallNode.cpp, lib/FunctionList.cpp,
	  lib/GlobalVariableList.cpp, lib/IfStatement.cpp,
	  lib/ManagedDatasource.cpp, lib/ModuleManager.cpp,
	  lib/NamedScope.cpp, lib/OnBlockExitStatement.cpp,
	  lib/Operator.cpp, lib/ParseOptionMap.cpp, lib/Pseudo_QC_All.qpp,
	  lib/Pseudo_QC_Binary.qpp, lib/Pseudo_QC_Bool.qpp,
	  lib/Pseudo_QC_Callref.qpp, lib/Pseudo_QC_Closure.qpp,
	  lib/Pseudo_QC_Date.qpp, lib/Pseudo_QC_Float.qpp,
	  lib/Pseudo_QC_Hash.qpp, lib/Pseudo_QC_Int.qpp,
	  lib/Pseudo_QC_List.qpp, lib/Pseudo_QC_Nothing.qpp,
	  lib/Pseudo_QC_Number.qpp, lib/Pseudo_QC_Object.qpp,
	  lib/Pseudo_QC_String.qpp,
	  lib/QC_AbstractBidirectionalIterator.qpp,
	  lib/QC_AbstractDatasource.qpp, lib/QC_AbstractIterator.qpp,
	  lib/QC_AbstractQuantifiedBidirectionalIterator.qpp,
	  lib/QC_AbstractQuantifiedIterator.qpp,
	  lib/QC_AbstractSmartLock.qpp, lib/QC_AutoGate.qpp,
	  lib/QC_AutoLock.qpp, lib/QC_AutoReadLock.qpp,
	  lib/QC_AutoWriteLock.qpp, lib/QC_Condition.qpp,
	  lib/QC_Counter.qpp, lib/QC_Datasource.qpp,
	  lib/QC_DatasourcePool.qpp, lib/QC_Dir.qpp, lib/QC_File.qpp,
	  lib/QC_FileLineIterator.qpp, lib/QC_FtpClient.qpp,
	  lib/QC_Gate.qpp, lib/QC_GetOpt.qpp, lib/QC_HTTPClient.qpp,
	  lib/QC_HashIterator.qpp, lib/QC_HashKeyIterator.qpp,
	  lib/QC_HashKeyReverseIterator.qpp, lib/QC_HashListIterator.qpp,
	  lib/QC_HashListReverseIterator.qpp, lib/QC_HashPairIterator.qpp,
	  lib/QC_HashPairReverseIterator.qpp,
	  lib/QC_HashReverseIterator.qpp, lib/QC_ListHashIterator.qpp,
	  lib/QC_ListHashReverseIterator.qpp, lib/QC_ListIterator.qpp,
	  lib/QC_ListReverseIterator.qpp, lib/QC_Mutex.qpp,
	  lib/QC_ObjectIterator.qpp, lib/QC_ObjectKeyIterator.qpp,
	  lib/QC_ObjectKeyReverseIterator.qpp,
	  lib/QC_ObjectPairIterator.qpp,
	  lib/QC_ObjectPairReverseIterator.qpp,
	  lib/QC_ObjectReverseIterator.qpp, lib/QC_Program.qpp,
	  lib/QC_Queue.qpp, lib/QC_RWLock.qpp, lib/QC_RangeIterator.qpp,
	  lib/QC_ReadOnlyFile.qpp, lib/QC_SQLStatement.qpp,
	  lib/QC_SSLCertificate.qpp, lib/QC_SSLPrivateKey.qpp,
	  lib/QC_Sequence.qpp, lib/QC_SingleValueIterator.qpp,
	  lib/QC_Socket.qpp, lib/QC_TermIOS.qpp, lib/QC_TimeZone.qpp,
	  lib/QException.cpp, lib/QoreAndEqualsOperatorNode.cpp,
	  lib/QoreAssignmentOperatorNode.cpp, lib/QoreBigIntNode.cpp,
	  lib/QoreBoolNode.cpp, lib/QoreCastOperatorNode.cpp,
	  lib/QoreClass.cpp, lib/QoreClassList.cpp,
	  lib/QoreClosureNode.cpp, lib/QoreClosureParseNode.cpp,
	  lib/QoreCondition.cpp, lib/QoreCounter.cpp,
	  lib/QoreDeleteOperatorNode.cpp, lib/QoreDir.cpp,
	  lib/QoreDivideEqualsOperatorNode.cpp,
	  lib/QoreDotEvalOperatorNode.cpp, lib/QoreException.cpp,
	  lib/QoreExtractOperatorNode.cpp, lib/QoreFile.cpp,
	  lib/QoreFloatNode.cpp, lib/QoreFtpClient.cpp, lib/QoreGetOpt.cpp,
	  lib/QoreHTTPClient.cpp, lib/QoreHashNode.cpp,
	  lib/QoreImplicitArgumentNode.cpp,
	  lib/QoreImplicitElementNode.cpp,
	  lib/QoreIntAssignmentOperatorNode.cpp,
	  lib/QoreIntMinusEqualsOperatorNode.cpp,
	  lib/QoreIntPlusEqualsOperatorNode.cpp,
	  lib/QoreIntPostDecrementOperatorNode.cpp,
	  lib/QoreIntPostIncrementOperatorNode.cpp,
	  lib/QoreIntPreDecrementOperatorNode.cpp,
	  lib/QoreIntPreIncrementOperatorNode.cpp, lib/QoreLib.cpp,
	  lib/QoreListNode.cpp, lib/QoreLogicalEqualsOperatorNode.cpp,
	  lib/QoreLogicalGreaterThanOperatorNode.cpp,
	  lib/QoreLogicalGreaterThanOrEqualsOperatorNode.cpp,
	  lib/QoreLogicalLessThanOperatorNode.cpp,
	  lib/QoreMinusEqualsOperatorNode.cpp,
	  lib/QoreModuloEqualsOperatorNode.cpp,
	  lib/QoreMultiplyEqualsOperatorNode.cpp, lib/QoreNamespace.cpp,
	  lib/QoreNet.cpp, lib/QoreNothingNode.cpp, lib/QoreNullNode.cpp,
	  lib/QoreNumberNode.cpp, lib/QoreObject.cpp,
	  lib/QoreOrEqualsOperatorNode.cpp,
	  lib/QorePlusEqualsOperatorNode.cpp,
	  lib/QorePostDecrementOperatorNode.cpp,
	  lib/QorePostIncrementOperatorNode.cpp,
	  lib/QorePreDecrementOperatorNode.cpp,
	  lib/QorePreIncrementOperatorNode.cpp, lib/QoreProgram.cpp,
	  lib/QorePseudoMethods.cpp, lib/QoreQueue.cpp,
	  lib/QoreQueueHelper.cpp, lib/QoreReferenceCounter.cpp,
	  lib/QoreRegexBase.cpp, lib/QoreRegexNode.cpp,
	  lib/QoreRemoveOperatorNode.cpp, lib/QoreSQLStatement.cpp,
	  lib/QoreSSLBase.cpp, lib/QoreSSLCertificate.cpp,
	  lib/QoreSSLPrivateKey.cpp,
	  lib/QoreShiftLeftEqualsOperatorNode.cpp,
	  lib/QoreShiftRightEqualsOperatorNode.cpp, lib/QoreSignal.cpp,
	  lib/QoreSocket.cpp, lib/QoreSpliceOperatorNode.cpp,
	  lib/QoreString.cpp, lib/QoreStringNode.cpp,
	  lib/QoreTimeZoneManager.cpp, lib/QoreTreeNode.cpp,
	  lib/QoreType.cpp, lib/QoreTypeInfo.cpp, lib/QoreURL.cpp,
	  lib/QoreUnaryMinusOperatorNode.cpp,
	  lib/QoreXorEqualsOperatorNode.cpp, lib/RWLock.cpp,
	  lib/ReferenceArgumentHelper.cpp, lib/ReferenceHelper.cpp,
	  lib/ReferenceNode.cpp, lib/RegexSubstNode.cpp,
	  lib/RegexTransNode.cpp, lib/ReturnStatement.cpp,
	  lib/SQLStatement.cpp, lib/ScopedRefNode.cpp,
	  lib/SelfVarrefNode.cpp, lib/Sequence.cpp, lib/SmartMutex.cpp,
	  lib/StatementBlock.cpp, lib/StaticClassVarRefNode.cpp,
	  lib/SummarizeStatement.cpp, lib/SwitchStatement.cpp,
	  lib/SystemEnvironment.cpp, lib/ThreadResourceList.cpp,
	  lib/ThrowStatement.cpp, lib/TryStatement.cpp, lib/VLock.cpp,
	  lib/VRMutex.cpp, lib/VarRefNode.cpp, lib/Variable.cpp,
	  lib/WhileStatement.cpp, lib/charset.cpp, lib/glob.cpp,
	  lib/minitest.cpp, lib/mySocket.cpp, lib/parser.ypp,
	  lib/qc_errno.qpp, lib/qc_option.qpp, lib/qc_qore.qpp,
	  lib/ql_compression.qpp, lib/ql_context.qpp, lib/ql_crypto.qpp,
	  lib/ql_dbi.qpp, lib/ql_debug.cpp, lib/ql_env.qpp,
	  lib/ql_file.qpp, lib/ql_lib.qpp, lib/ql_list.qpp,
	  lib/ql_math.qpp, lib/ql_misc.qpp, lib/ql_object.qpp,
	  lib/ql_pwd.qpp, lib/ql_string.qpp, lib/ql_thread.qpp,
	  lib/ql_time.qpp, lib/ql_type.qpp, lib/qore-main.cpp,
	  lib/qore_date_private.cpp, lib/qpp.cpp, lib/scanner.lpp,
	  lib/support.cpp, lib/thread.cpp, main.cpp: updated copyright
	  statements to 2013

2013-02-22 15:05  david_nichols

	* lib/thread.cpp: added a function to determine the stack size on
	  windows; however stack guard is still not working on windows

2013-02-21 20:10  david_nichols

	* include/qore/intern/AbstractStatement.h, lib/Function.cpp,
	  lib/QoreSocket.cpp, lib/StatementBlock.cpp: make sure and mark
	  parameter vars as "parse_unassigned" after parsing the code
	  block; windows compile fixes

2013-02-20 13:42  david_nichols

	* include/qore/intern/AbstractStatement.h,
	  include/qore/intern/LocalVar.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreOperatorNode.h,
	  include/qore/intern/QoreTypeInfo.h,
	  include/qore/intern/QoreValue.h,
	  include/qore/intern/SelfVarrefNode.h,
	  include/qore/intern/VarRefNode.h, include/qore/intern/Variable.h,
	  lib/QoreAssignmentOperatorNode.cpp, lib/QoreLib.cpp,
	  lib/QoreTypeInfo.cpp, lib/StatementBlock.cpp, lib/VarRefNode.cpp,
	  lib/Variable.cpp, lib/parser.ypp, qlib/HttpServer.qm: initial
	  reference error fixes - "reference" and "*reference" types are
	  enforced, global references to local references now work
	  properly, etc

2013-02-19 17:05  david_nichols

	* include/qore/intern/QoreLibIntern.h, lib/QC_HTTPClient.qpp,
	  lib/QoreAssignmentOperatorNode.cpp, lib/QoreTypeInfo.cpp:
	  starting to address reference bug

2013-02-13 13:26  david_nichols

	* qlib/HttpServer.qm: implemented get_ex_pos() function in the
	  HttpServer namespace to allow for more robust error reporting
	  when source information is also available in the exception hash

2013-02-06 15:36  david_nichols

	* qlib/Pop3Client.qm, qlib/SmtpClient.qm, qlib/TelnetClient.qm:
	  added docs for log arguments

2013-02-06 12:57  david_nichols

	* include/qore/intern/ConstantList.h, lib/ConstantList.cpp: fixed a
	  bug where class constants were not being copied over when classes
	  were inherited in child Program objects

2013-02-06 12:42  david_nichols

	* lib/QoreNamespace.cpp: cosmetic fix to error msg

2013-01-29 13:18  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QoreString.cpp:
	  fixed a bug where uninitialized memory was being returned when
	  parseBase64() was called with an empty string argument; applied
	  the same fix to parseBase64ToString(); updated release notes

2013-01-29 13:12  david_nichols

	* lib/QoreLib.cpp, lib/QoreString.cpp: return an empty string if
	  parseBase64StringToString() is called with an empty argument

2013-01-29 13:08  david_nichols

	* lib/QoreLib.cpp: do not return uninitialized memory when calling
	  parseBase64StringToString() with an empty string argument

2013-01-25 16:06  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_File.qpp,
	  lib/QoreFile.cpp: updated File::write*() methods to throw
	  exceptions on errors instead of returning an error code (similar
	  to the change made with the Socket::send*() methods in 0.8.6) to
	  avoid having silent unhandled write failures, updated docs
	  accordingly

2013-01-17 18:09  david_nichols

	* include/qore/intern/SSLSocketHelper.h, lib/QoreSocket.cpp: enable
	  SSL_MODE_AUTO_RETRY to make blocking I/O with SSL a little
	  simpler; close the socket immediately if a connection reset is
	  received

2013-01-16 19:39  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: updated release notes
	  for last 2 bugs fixed

2013-01-16 19:34  david_nichols

	* include/qore/QoreSocket.h, include/qore/intern/QC_Socket.h,
	  lib/QC_Socket.qpp, lib/QoreSocket.cpp, lib/mySocket.cpp: fixed
	  erroneous usage of the timeout parameter (sometimes also missing)
	  in C++ APIs in the Socket::sendHTTPMessage() and
	  Socket::sendHTTPResponse() methods

2013-01-15 10:29  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/155_data_type_declarations.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl: doc updates

2013-01-14 15:36  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/Pseudo_QC_Date.qpp,
	  lib/ql_time.qpp: added 3 new pseudo-methods to the <date>
	  pseudo-class:
	  * <date>::durationSeconds()
	  * <date>::durationMilliseconds()
	  * <date>::durationMicroseconds()

2013-01-14 09:56  david_nichols

	* lib/Pseudo_QC_Hash.qpp: doc updates

2013-01-10 20:39  david_nichols

	* qlib/HttpServer.qm: implemented support for listener stop
	  notifications; implemented support for naming listeners and
	  stopping them by name

2013-01-10 15:43  david_nichols

	* lib/ql_lib.qpp, lib/thread.cpp: fixes for non-debugging builds
	  and warning fixes

2013-01-10 14:19  david_nichols

	* include/qore/intern/qore_program_private.h,
	  lib/Pseudo_QC_All.qpp, lib/thread.cpp, test/test.q: doc update;
	  make sure and keep parent program parse state even after parsing
	  completes for error messages called after endParsing() is called
	  by the scanner; added source exception tests to test.q

2013-01-10 12:39  david_nichols

	* include/qore/qore_thread.h: make QoreForeignThreadHelper
	  constructor taking an int explicit

2013-01-10 11:05  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QoreProgram.cpp:
	  fixed a bug where trying to dynamically call a function that does
	  not exist results in a deadlock due to an error where a mutex is
	  not unlocked

2013-01-10 08:47  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/Function.cpp: fixed
	  a bug where declaring an abstract method with parameters and then
	  declaring a reimplementation of the method in a base class with
	  no parameters caused a parse-time crash

2013-01-09 10:21  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/DatasourcePool.h,
	  include/qore/intern/ManagedDatasource.h,
	  lib/ManagedDatasource.cpp, lib/QC_Datasource.qpp,
	  lib/QC_DatasourcePool.qpp: added the following new methods:
	  - Datasource::transactionTid()
	  - Datasource::currentThreadInTransaction()
	  - DatasourcePool::currentThreadInTransaction()

2013-01-08 13:47  david_nichols

	* lib/QC_Program.qpp, lib/thread.cpp: do not call pthread_detach()
	  on foreign thread; cosmetic doc change in QC_Program.qpp

2013-01-05 07:39  david_nichols

	* doxygen/lang/225_exception_handling.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/Datasource.h, include/qore/DateTime.h,
	  include/qore/QoreProgram.h, include/qore/QoreString.h,
	  include/qore/intern/DatasourcePool.h,
	  include/qore/intern/ManagedDatasource.h,
	  include/qore/intern/QoreLibIntern.h, lib/Datasource.cpp,
	  lib/DatasourcePool.cpp, lib/ManagedDatasource.cpp,
	  lib/QC_Datasource.qpp, lib/QC_DatasourcePool.qpp,
	  lib/QC_Program.qpp, lib/QoreException.cpp, lib/QoreString.cpp,
	  lib/ql_misc.qpp, lib/ql_thread.qpp, lib/thread.cpp: do not set
	  the "source" tag at all in exceptions if there is no "source"
	  info available; updated docs; added source, offset, and
	  format_label parameters to Program::parse() and
	  Program::parsePending(); aligned the parse() function with the
	  Program::parse() method; deprecated the c++
	  Datasource::execArgs() function with the extraneous "args"
	  parameter, removed the "args" parameter from all internal
	  execArgs() functions; added a new c++ QoreStringMaker constructor
	  taking an encoding argument; updated docs + release notes for new
	  changes

2013-01-05 06:03  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/ql_time.qpp,
	  lib/qore_date_private.cpp: implemented the "us" date/time format
	  code; updated docs

2013-01-04 14:42  david_nichols

	* include/qore/intern/QoreThreadList.h, lib/thread.cpp: make call
	  stack allocation symmetric regarding thread entry reservations

2013-01-04 14:03  david_nichols

	* Makefile.am, include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreThreadList.h,
	  include/qore/intern/ThreadResourceList.h,
	  include/qore/intern/qore_thread_intern.h,
	  include/qore/qore_thread.h, lib/ql_lib.qpp, lib/ql_thread.qpp,
	  lib/thread.cpp: major reworking of internal thread list and
	  internal thread APIs, new external APIs to allow for thread entry
	  reservations and releases

2013-01-03 17:30  david_nichols

	* include/qore/DateTime.h, include/qore/QoreLib.h,
	  include/qore/QoreProgram.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreException.h,
	  include/qore/intern/Variable.h,
	  include/qore/intern/qore_date_private.h,
	  include/qore/intern/qore_program_private.h,
	  include/qore/qore_thread.h, lib/CallStack.cpp, lib/DateTime.cpp,
	  lib/Function.cpp, lib/QoreException.cpp, lib/QoreProgram.cpp,
	  lib/parser.ypp, lib/support.cpp: continuing changes to allow for
	  secondary source tags + a line offset to be added when parsing
	  for exception messages that can reference multiple code objects
	  contained in the same file; moved new thread APIs to
	  qore_thread.h

2013-01-03 16:04  david_nichols

	* include/qore/QoreString.h: oops - made
	  QoreStringMaker::QoreStringMaker constructor public

2013-01-03 07:46  david_nichols

	* lib/thread.cpp: removed more unused code

2013-01-02 17:11  david_nichols

	* include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/qore_thread_intern.h, lib/thread.cpp: removed
	  some unused code

2013-01-02 17:10  david_nichols

	* include/qore/ExceptionSink.h,
	  include/qore/intern/AbstractStatement.h,
	  include/qore/intern/ClassRefNode.h,
	  include/qore/intern/FunctionCallNode.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreException.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreOperatorNode.h,
	  include/qore/intern/VarRefNode.h, include/qore/intern/Variable.h,
	  include/qore/intern/qore_program_private.h,
	  include/qore/intern/qore_thread_intern.h,
	  lib/AbstractStatement.cpp, lib/CallStack.cpp,
	  lib/ConstantList.cpp, lib/ExceptionSink.cpp, lib/Function.cpp,
	  lib/QC_Datasource.qpp, lib/QC_DatasourcePool.qpp,
	  lib/QoreException.cpp, lib/QoreLib.cpp, lib/QoreNamespace.cpp,
	  lib/QoreProgram.cpp, lib/StatementBlock.cpp, lib/parser.ypp,
	  lib/scanner.lpp, lib/support.cpp, lib/thread.cpp: major internal
	  changes to allow for tracking an additional source tag/filename
	  in addition to the parse label + an offset line to allow for
	  exception reporting for the case when multiple code objects (with
	  different labels and independent line numbers) are created from
	  the same source file

2012-12-28 18:13  david_nichols

	* include/qore/AbstractThreadResource.h,
	  include/qore/intern/DatasourcePool.h,
	  include/qore/intern/DatasourceStatementHelper.h,
	  include/qore/intern/ManagedDatasource.h,
	  include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreSQLStatement.h,
	  include/qore/intern/ThreadResourceList.h, lib/DatasourcePool.cpp,
	  lib/ManagedDatasource.cpp, lib/QoreSQLStatement.cpp,
	  lib/ThreadResourceList.cpp, lib/thread.cpp: fixed some
	  thread-resource issues with the SQLStatement class; greatly
	  simplified SQLStatement resource management; removed unused
	  thread resource list code

2012-12-28 15:48  david_nichols

	* lib/QoreProgram.cpp: clear program location when programs go out
	  of scope in case any thread resource exceptions are thrown when
	  there is no more valid Program scope

2012-12-28 11:46  david_nichols

	* lib/QC_File.qpp: fixed for compiling for a native windows target

2012-12-28 07:50  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/QC_File.qpp: added a
	  new, easier-to-use variant of File::getTerminalAttributes() that
	  returns a TermIOS object directly with the current terminal
	  attributes

2012-12-27 11:10  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: release notes updates

2012-12-27 10:27  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: minor doc updates

2012-12-27 10:18  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: doc updates for 0.8.7
	  release

2012-12-20 10:09  david_nichols

	* include/qore/intern/Variable.h, lib/VarRefNode.cpp,
	  lib/Variable.cpp: fixed a bug where global variables were being
	  evaluated with strict mathematical boolean evaluation even when
	  perl-bool-eval was enabled (the default)

2012-12-19 13:41  david_nichols

	* lib/QoreHashNode.cpp, lib/QoreListNode.cpp, lib/Variable.cpp,
	  lib/qpp.cpp: added support for relative dates in qore value
	  expressions in qpp; added some logic to convert ptrs to NOTHING
	  to 0

2012-12-19 10:13  david_nichols

	* include/qore/Qore.h, lib/QoreLib.cpp, lib/qore-main.cpp: added
	  new library options for suppressing openssl library initialization
	  and cleanup so that these actions can be performed externally or
	  even by modules (in the case of openssl library cleanup) - in the
	  last case to avoid a core dump on shutdown in case EVP_cleanup()
	  is called by a module (such as the openldap module using the
	  openldap library) - also added new functions for checking and
	  setting library init options, so a module can tell the qore
	  library that, for example, the openssl library will be cleaned up
	  by the module (ex: openldap)

2012-12-19 08:10  david_nichols

	* lib/qore-main.cpp: additional openssl cleanup in library shutdown

2012-12-19 07:59  david_nichols

	* lib/thread.cpp: do thread-specific cleanup also for the main
	  thread when shutting down the library

2012-12-19 07:48  david_nichols

	* lib/Operator.cpp: fixed memory leaks in the select and map
	  operators when used with iterators

2012-12-19 07:33  david_nichols

	* lib/qore-main.cpp, lib/thread.cpp: added additional calls to
	  openssl apis to free allocated memory per-thread and when
	  shutting down the qore library

2012-12-19 07:14  david_nichols

	* include/qore/QoreLib.h, lib/QoreLib.cpp: added 2 new public APIs
	  for checking library options

2012-12-18 15:33  david_nichols

	* lib/thread.cpp: set thread local data key to 0 for the current
	  thread when threads are deregistered

2012-12-18 15:28  david_nichols

	* lib/Function.cpp: fixed typo in last commit

2012-12-18 15:26  david_nichols

	* lib/Function.cpp, lib/QoreClass.cpp: fixed a bug finding runtime
	  function/method variants where parse data was incorrectly
	  modified; also made it possible to call
	  QoreFunction::findVariant() from threads where there is no
	  current Program object

2012-12-18 15:04  david_nichols

	* include/qore/QoreLib.h, include/qore/intern/qore_thread_intern.h,
	  lib/thread.cpp: new APIs for registering and deregistering
	  foreign threads with the qore library

2012-12-18 12:29  david_nichols

	* qlib/HttpServer.qm: streamlined dynamic HTTP handler handling;
	  updated version string to reflect new module version

2012-12-18 12:14  david_nichols

	* qlib/HttpServer.qm: updated http server module to 0.3.6 and fixed
	  a race condition in tracking active requests in dynamic handlers
	  and removing dynamic HTTP handlers

2012-12-12 11:34  david_nichols

	* include/qore/BinaryNode.h, include/qore/DateTimeNode.h,
	  include/qore/QoreBigIntNode.h, include/qore/QoreBoolNode.h,
	  include/qore/QoreFloatNode.h, include/qore/QoreHashNode.h,
	  include/qore/QoreNothingNode.h, include/qore/QoreNullNode.h,
	  include/qore/QoreNumberNode.h, include/qore/QoreObject.h,
	  include/qore/QoreStringNode.h: added a static function to return
	  the type code (can simplify templates)

2012-12-10 11:46  david_nichols

	* include/qore/DBI.h, lib/DBI.cpp: added the DBI_CAP_AUTORECONNECT
	  capability constant

2012-12-10 07:44  david_nichols

	* include/qore/ModuleManager.h, include/qore/QoreQueueHelper.h,
	  include/qore/intern/ModuleInfo.h, lib/ModuleManager.cpp: added a
	  public C++ API for adding the standard module paths when setting
	  up the module directory list before initializing the qore library

2012-12-05 15:22  david_nichols

	* Makefile.am, include/qore/Qore.h, include/qore/QoreFile.h,
	  include/qore/QoreHTTPClient.h, include/qore/QoreLib.h,
	  include/qore/QoreObject.h, include/qore/QoreQueueHelper.h,
	  lib/Makefile.am, lib/QC_File.qpp, lib/QoreQueueHelper.cpp,
	  lib/single-compilation-unit.cpp: added c++ classes for access to
	  object private data: QoreFileHelper and QoreQueueHelper classes

2012-12-05 05:33  david_nichols

	* command-line.cpp, doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/ModuleManager.h, include/qore/QoreHTTPClient.h,
	  include/qore/QoreSocket.h, lib/ConstantList.cpp, lib/Makefile.am,
	  lib/ModuleManager.cpp, lib/QC_HTTPClient.qpp, lib/QC_Socket.qpp,
	  lib/QoreHTTPClient.cpp, qore.spec: implemented
	  HTTPClient::getPeerInfo() and HTTPClient::getSocketInfo()
	  methods, added public C++ apis for those methods in the
	  QoreHTTPClient class, updated module API to 0.16, updated Qore
	  library version to 5.10, updated release notes, removed built
	  options from -V output in qore, implemented -B to list build
	  options

2012-12-03 18:33  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/Restrictions.h, include/qore/intern/Function.h,
	  include/qore/intern/FunctionList.h, lib/FunctionList.cpp,
	  lib/thread.cpp: fixed user function variant inheritance with the
	  public keyword

2012-12-03 14:52  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, include/qore/QoreFile.h,
	  include/qore/QoreNumberNode.h, include/qore/QoreString.h,
	  include/qore/QoreURL.h, include/qore/Restrictions.h,
	  include/qore/intern/ConstantList.h,
	  include/qore/intern/Function.h,
	  include/qore/intern/FunctionList.h,
	  include/qore/intern/GlobalVariableList.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreClassList.h,
	  include/qore/intern/QoreNamespaceIntern.h, lib/ConstantList.cpp,
	  lib/FunctionList.cpp, lib/QC_Program.qpp, lib/QoreClassList.cpp,
	  lib/QoreNamespace.cpp, lib/parser.ypp, qlib/SmtpClient.qm:
	  renamed PO_INHERIT_USER_FUNC_VARIANTS to
	  PO_NO_INHERIT_USER_FUNC_VARIANTS and PO_INHERIT_GLOBAL_VARS to
	  PO_NO_INHERIT_GLOBAL_VARS and aligned the functionality with the
	  new names in order to make symbol inheritance consistent with the
	  rest of the implementation; made many small doc updates

2012-12-03 07:28  david_nichols

	* lib/thread.cpp: fixed exit() with threads running; we cannot
	  safely call pthread_join() after canceling because a thread may
	  have been canceled while holding a mutex and then another thread
	  may be waiting indefinitely on the mutex (because, for example,
	  pthread_mutex_lock() is not a cancellation point), so we just
	  cancel all threads and then sleep for half a second and then call
	  exit

2012-12-02 21:33  david_nichols

	* Makefile.am, doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/205_namespaces.dox.tmpl,
	  doxygen/lang/215_classes.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/ConstantList.h,
	  include/qore/intern/Function.h,
	  include/qore/intern/QoreNamespaceIntern.h,
	  include/qore/intern/qore_program_private.h, lib/ConstantList.cpp,
	  lib/QC_Program.qpp, lib/QoreClass.cpp, lib/QoreClassList.cpp,
	  lib/QoreNamespace.cpp, lib/QoreProgram.cpp: major code embedding
	  improvements; only code declared as "public" is imported into
	  child Program objects, giving programmers complete control over
	  which symbols are inherited in child Program objects

2012-12-01 11:27  david_nichols

	* include/qore/intern/ModuleInfo.h: updated header

2012-11-29 14:52  david_nichols

	* lib/ModuleManager.cpp, lib/QC_Program.qpp, lib/QoreProgram.cpp,
	  lib/QoreTypeInfo.cpp, lib/ql_misc.qpp: fixed a runtime class
	  matching bug - when identical user classes were created in
	  different Program objects, the match failed at runtime because
	  the wrong APIs were being used; removed most restrictions on
	  embedded logic in user modules; user module Program objects are
	  subject to the same restrictions as the parent Program object (if
	  any); added the get_parse_options() function; added the
	  Program::loadModule() method to load a module directly into a
	  Program object

2012-11-27 16:56  david_nichols

	* include/qore/intern/AbstractIteratorHelper.h,
	  lib/ForEachStatement.cpp, lib/Operator.cpp: fixed a bug in the
	  map operator with select expression when used with an iterator -
	  caused a crash before due to a bad choice for default arguments
	  for the AbstractIteratorHelper constructor

2012-11-26 14:50  david_nichols

	* include/qore/intern/Function.h,
	  include/qore/intern/QoreTypeInfo.h, lib/QoreClass.cpp: fixed a
	  bug where the generation of internal strings for abstract method
	  signatures is done while parsing but tries to resolve class names
	  in the signature types whereas this information is not available
	  when classes are declared out of order (which must be supported
	  in Qore)

2012-11-23 10:54  david_nichols

	* README, qlib/MailMessage.qm, qlib/SmtpClient.qm: SmtpClient
	  module updated to v1.3: added support for parsing a full URL in
	  the SmtpClient::constructor(); added protocol support and setting
	  the username / password from the URL; use
	  Message::checkSendPossible() to throw a more descriptive
	  exception if the message is incomplete and not ready to be sent;
	  implemented support for automatically detecting if the server
	  accepts the STARTTLS command and, if so, automatically setting
	  the STARTTLS flag if it's not already set
	  MailMessage module updated to 1.0.4 with minor doc changes and
	  non-functional code changes

2012-11-23 10:53  david_nichols

	* include/qore/intern/QoreTypeInfo.h, lib/Pseudo_QC_Nothing.qpp,
	  lib/QoreTypeInfo.cpp: added more pseudo-methods to the <nothing>
	  pseudo-class with default return values so that pseudo-methods on
	  the <hash> pseudo-class can also be safely executed on NOTHING
	  (to better support *hash values); removed support for the unused
	  and partially-implemented "reverse_logic" flag in QoreTypeInfo;
	  fixed "reference" type enforcement which was prohibiting the
	  reference from being assigned to NOTHING even if it was legal for
	  the original lvalue

2012-11-21 12:05  david_nichols

	* qlib/HttpServer.qm: removed unneeded comments / code in
	  HttpServer example

2012-11-21 08:34  david_nichols

	* ChangeLog, RELEASE-NOTES, configure.ac, lib/Makefile.am,
	  qore.spec: updated to v0.8.7 and also updated library api minor
	  version

2012-11-21 07:36  david_nichols

	* configure.ac: fixed SSA* checks when linking with static openssl
	  libraries (such as on windows, for example)

2012-11-21 06:33  david_nichols

	* lib/Pseudo_QC_Hash.qpp: minor doc update

2012-11-21 06:32  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/150_container_data_types.dox.tmpl,
	  doxygen/lang/195_statements.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, examples/httpserver.q,
	  include/qore/Qore.h, include/qore/QoreCounter.h,
	  include/qore/QoreProgram.h, lib/Pseudo_QC_Hash.qpp,
	  lib/QC_Datasource.qpp, lib/QC_DatasourcePool.qpp,
	  lib/QC_HashKeyReverseIterator.qpp,
	  lib/QC_HashPairReverseIterator.qpp, lib/thread.cpp: updated the
	  QoreProgramHelper class to wait for all background threads to
	  terminate before taking the QoreProgram object out of scope; this
	  way programs using user modules that provide their own threads
	  will not go out of scope (making all callbacks, etc go out of
	  scope as well) while threads in the user modules (that require
	  the callbacks from the original program object) are still
	  running; made many doc updates

2012-11-20 18:14  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreLibIntern.h, lib/FunctionCallNode.cpp,
	  lib/Pseudo_QC_Hash.qpp, lib/Pseudo_QC_Nothing.qpp: fixed a bug in
	  pseudo-method dynamic dispatch when the value is NOTHING but was
	  declared with another type

2012-11-20 06:07  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: fixed more typos

2012-11-20 06:05  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl: fixed typos

2012-11-18 10:26  david_nichols

	* lib/QC_Datasource.qpp, lib/QC_DatasourcePool.qpp: minor doc
	  formatting corrections and updates

2012-11-17 12:21  david_nichols

	* lib/ql_time.qpp: fixed "mork" typos - nanoo -> nano

2012-11-17 12:18  david_nichols

	* lib/Pseudo_QC_List.qpp, lib/ql_time.qpp: minor doc updates

2012-11-16 08:39  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl, lib/Pseudo_QC_All.qpp,
	  lib/Pseudo_QC_List.qpp, lib/Pseudo_QC_Nothing.qpp: added
	  <nothing>::pairIterator() and <nothing>::keyIterator()
	  pseudo-methods, that empty SingleValueIterator objects return (so
	  that pairIterator() and keyIterator() can be used safely with
	  *hash types); doc updates

2012-11-16 08:25  david_nichols

	* Makefile.am, configure.ac, doxygen/lang/180_operators.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreHashIterator.h,
	  include/qore/intern/QoreObjectIterator.h, lib/Makefile.am,
	  lib/Operator.cpp, lib/Pseudo_QC_Hash.qpp,
	  lib/Pseudo_QC_Object.qpp, lib/QC_HashIterator.qpp,
	  lib/QC_HashKeyIterator.qpp, lib/QC_HashKeyReverseIterator.qpp,
	  lib/QC_HashPairIterator.qpp, lib/QC_HashPairReverseIterator.qpp,
	  lib/QC_HashReverseIterator.qpp, lib/QC_ObjectIterator.qpp,
	  lib/QC_ObjectKeyIterator.qpp,
	  lib/QC_ObjectKeyReverseIterator.qpp,
	  lib/QC_ObjectPairIterator.qpp,
	  lib/QC_ObjectPairReverseIterator.qpp,
	  lib/QC_ObjectReverseIterator.qpp, lib/QoreNamespace.cpp,
	  lib/single-compilation-unit.cpp, qlib/CsvUtil.qm,
	  qlib/MailMessage.qm, qlib/Mime.qm, qlib/Pop3Client.qm, qore.spec,
	  test/test.q: fixed design bugs in the iterator implementation;
	  the implicit argument of the map and select operators is now the
	  value returned by AbstractIterator::getValue(); the "value_hash"
	  parameter of the HashIterator and HashReverseIterator
	  constructors and the <hash>::iterator() pseudo-method has been
	  removed; new iterator classes implemented: HashKeyIterator,
	  HashKeyReverseIterator, HashPairIterator,
	  HashPairReverseIterator, ObjectKeyIterator,
	  ObjectKeyReverseIterator, ObjectPairIterator,
	  ObjectPairReverseIterator, new pseudo-methods:
	  <hash>::keyIterator(), <hash>::pairIterator(),
	  <object>::keyIterator(), <object>::pairIterator()

2012-11-15 11:05  david_nichols

	* Makefile.am, doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/QoreHashIterator.h, lib/Makefile.am,
	  lib/Pseudo_QC_Hash.qpp, lib/QC_HashIterator.qpp,
	  lib/QC_HashKeyIterator.qpp, lib/QC_HashKeyReverseIterator.qpp,
	  lib/QC_HashReverseIterator.qpp, lib/QoreNamespace.cpp,
	  lib/single-compilation-unit.cpp: implemented the HashKeyIterator
	  and HashKeyuReverseIterator classes and the <hash>::keyIterator()
	  pseudo-method

2012-11-12 15:35  david_nichols

	* lib/Datasource.cpp, lib/DatasourcePool.cpp: cosmetic changes

2012-11-10 06:49  david_nichols

	* configure.ac, lib/Makefile.am, qore.spec: updated to 0.8.7 for
	  next release

2012-11-09 17:43  david_nichols

	* ChangeLog, RELEASE-NOTES: final changes for the 0.8.6.1 release

2012-11-09 14:48  david_nichols

	* qlib/Mime.qm: changed the default value of the decode parameter
	  in MultiPartMessage::parseBody() to True

2012-11-09 14:43  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/245_parse_directives.dox.tmpl, lib/FunctionList.cpp,
	  qlib/Mime.qm: doc updates

2012-11-09 13:48  david_nichols

	* doxygen/lang/245_parse_directives.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, qlib/MailMessage.qm,
	  qlib/Mime.qm: doc updates

2012-11-05 16:19  david_nichols

	* include/qore/QoreStringNode.h: checked in initial version of
	  openldap module

2012-11-03 16:11  david_nichols

	* qlib/MailMessage.qm, qlib/Pop3Client.qm: + updated docs; updated
	  Pop3Client module to 1.1; mask passwords in debug log by default
	  + set sender and from value properly when parsing email messages
	  in MailMessage

2012-11-03 12:51  david_nichols

	* qlib/Mime.qm: minor doc corrections

2012-11-03 12:49  david_nichols

	* qlib/Mime.qm, test/test.q: dox updated in mime module; added
	  regression tests in test.q for the mime module

2012-11-03 04:59  david_nichols

	* include/qore/intern/ConstantList.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreClassList.h,
	  include/qore/intern/QoreNamespaceIntern.h,
	  include/qore/intern/QoreNamespaceList.h, lib/ConstantList.cpp,
	  lib/QoreClassList.cpp, lib/QoreNamespace.cpp,
	  lib/QoreProgram.cpp: do not dereference constant values (or
	  anything) while holding a lock as it can lead to a deadlock (when
	  an object's destructor is run for example)

2012-11-02 18:28  david_nichols

	* include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreClassList.h, lib/QoreClassList.cpp,
	  lib/QoreNamespace.cpp: clear class constants when clearing
	  namespace constants in program destruction

2012-11-02 18:14  david_nichols

	* include/qore/intern/QoreLibIntern.h: header to go with last
	  commit

2012-11-02 18:13  david_nichols

	* lib/BuiltinFunctionList.cpp, lib/ModuleManager.cpp,
	  lib/QoreNamespace.cpp, lib/QoreProgram.cpp, lib/qore-main.cpp: do
	  not statically allocate the static system namespace as it causes
	  a race condition when one thread calls exit and another thread is
	  shutting down the library

2012-11-02 18:01  david_nichols

	* include/qore/intern/QoreLibIntern.h,
	  include/qore/intern/QoreNamespaceIntern.h,
	  include/qore/intern/QoreNamespaceList.h, lib/QoreNamespace.cpp,
	  lib/QoreProgram.cpp: + don't call StaticSystemDatasource::purge()
	  from the destructor - this can lead to a race condition when
	  exit() in one thread and the qore library is being shut down in
	  another
	  + clear constants inside the parse lock and clear global lookup
	  map at the same time

2012-11-02 16:31  david_nichols

	* lib/QoreProgram.cpp: reverted a previous change that changed
	  Program destruction behavior; program data (global and class
	  variables, thread-local data, etc) must be destroyed before the
	  Program is marked invalid or destructors cannot run (they get the
	  error: PROGRAM-ERROR: the program accessed has already been
	  deleted)

2012-11-02 16:13  david_nichols

	* include/qore/QoreProgram.h,
	  include/qore/intern/qore_program_private.h,
	  lib/ModuleManager.cpp, lib/QoreProgram.cpp, lib/parser.ypp,
	  lib/scanner.lpp, qlib/MailMessage.qm, qlib/Mime.qm: + implemented
	  %try-module variant without exception variable usable for Program
	  objects where PO_NO_TOP_LEVEL_STATEMENTS is set
	  + fixed a crashing bug handling user module parse errors due to
	  failing to set the Program context properly when merging user
	  module code to a Program object
	  + implemented the MultiPartMessage::parseBody() static method for
	  parsing multipart message bodies
	  + fixed bugs in the MailMessage module setting the content-type
	  of parts
	  + now message parts with subparts are parsed properly (affected
	  the MailMessage module; the corrected code is now in the Mime
	  module)
	  + fixed a bug where a Mime message was not detected as mime if
	  the mime header had text after the mime version

2012-11-02 13:35  david_nichols

	* lib/ModuleManager.cpp: fixed a bug parsing user modules; the
	  Program context was not set properly which could lead to a crash
	  when parsing user modules loaded from the command-line or to
	  incorrect parse options when loaded from user Program code

2012-11-01 17:22  david_nichols

	* test/test.q: added a test for retrieving the class name of a user
	  class from an external program after the program containing the
	  user class was deleted

2012-11-01 17:13  david_nichols

	* include/qore/intern/Function.h,
	  include/qore/intern/FunctionList.h,
	  include/qore/intern/QoreClassIntern.h,
	  include/qore/intern/QoreClassList.h,
	  include/qore/intern/QoreNamespaceIntern.h,
	  include/qore/intern/qore_program_private.h,
	  lib/QoreClassList.cpp, lib/QoreNamespace.cpp,
	  lib/QoreProgram.cpp: + clear all constants when invalidating and
	  clearing Programs in order to fix a dynamic memory leak when a
	  Program constant contains a call reference
	  + slightly simplified Program invalidation and fixed a potential
	  race condition

2012-11-01 12:36  david_nichols

	* TODO, lib/Operator.cpp: + fixed a bug where the invalid-operation
	  warning with the keys operator was not being triggered in common
	  cases that should have triggered the warning
	  + added code to raise an invalid-operation warning with the
	  elements operator when called with a type that can never return a
	  value

2012-10-31 14:26  david_nichols

	* lib/QoreFile.cpp: greatly increased file read performance by
	  using a 16K buffer rather than a 4k buffer

2012-10-31 08:05  david_nichols

	* Makefile.am, include/qore/ModuleManager.h,
	  include/qore/QoreLib.h, include/qore/QoreNumberNode.h,
	  include/qore/intern/QoreNumber.h,
	  include/qore/intern/qore_number_private.h, lib/Makefile.am,
	  lib/ModuleManager.cpp, lib/Pseudo_QC_Number.qpp,
	  lib/QoreNumberNode.cpp, qore.spec: + added new QoreNumberNode
	  public APIs to allow numbers to be serialized and deserialized
	  with the same precision
	  + added a new QoreNumberNode public API to allow to chose the
	  number format when converting to a string (scientific &
	  non-scientific with and without the rounging heuristic)
	  + updated module api to 0.15
	  + updated library version to reflect new public APIs

2012-10-30 20:32  david_nichols

	* configure.ac, lib/QoreNumberNode.cpp, qore.spec, test/test.q: +
	  fixed rounding of arbitrary-precision numeric values for display
	  purposes when the last significant digit is just to the right of
	  the decimal point (ex: was displaying 10.2 as "11.")
	  + changed the version to 0.8.6.1 for a bugfix point release

2012-10-29 20:21  david_nichols

	* include/qore/intern/QoreBinaryLValueOperatorNode.h,
	  include/qore/intern/QoreDeleteOperatorNode.h,
	  include/qore/intern/QoreExtractOperatorNode.h,
	  include/qore/intern/QoreMultiplyEqualsOperatorNode.h,
	  include/qore/intern/QoreOperatorNode.h,
	  include/qore/intern/QorePostIncrementOperatorNode.h,
	  include/qore/intern/QorePreIncrementOperatorNode.h,
	  include/qore/intern/QoreRemoveOperatorNode.h,
	  include/qore/intern/QoreSpliceOperatorNode.h, lib/Makefile.am,
	  lib/QoreAssignmentOperatorNode.cpp,
	  lib/QoreDeleteOperatorNode.cpp, lib/QoreExtractOperatorNode.cpp,
	  lib/QoreMinusEqualsOperatorNode.cpp,
	  lib/QorePlusEqualsOperatorNode.cpp,
	  lib/QoreRemoveOperatorNode.cpp, lib/QoreSpliceOperatorNode.cpp,
	  lib/Variable.cpp, lib/parser.ypp, qore.spec, test/test.q: + fixed
	  crashing bugs due to the lack of proper lvalue checks with the
	  expression for the background operator with operators using
	  lvalues with local variables
	  + incremented the library version

2012-10-27 08:38  david_nichols

	* ChangeLog, configure.ac, doxygen/lang/900_release_notes.dox.tmpl,
	  lib/QC_RangeIterator.qpp, qore.spec: updated release to 0.8.7,
	  minor doc corrections

2012-10-25 16:53  david_nichols

	* doxygen/qdx: updated qdx to deal properly with nested namespaces

2012-10-24 18:57  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/900_release_notes.dox.tmpl, lib/QC_Program.qpp: make
	  sure that Program objects created in user modules have a subset
	  of the current program's parse options and have their options
	  locked so that they cannot be made less restrictive

2012-10-24 18:02  david_nichols

	* doxygen/lang/120_modules.dox.tmpl,
	  doxygen/lang/245_parse_directives.dox.tmpl, qlib/HttpServer.qm:
	  doc updates

2012-10-24 16:43  david_nichols

	* doxygen/lang/900_release_notes.dox.tmpl,
	  include/qore/intern/qore_program_private.h, lib/QoreProgram.cpp:
	  fixed a bug where the qore library could crash when destroying a
	  Program object due to a race condition in removing signal
	  handlers managed by the Program object; the Program calls the
